#include <bits/stdc++.h>
#define int long long

using namespace std;

const int nmax = 2e5;

struct Node
{
    int len, w, nod;
};

int n, k;
vector<pair<int,int>> G[nmax + 5];

int lvl[nmax + 5];
int p[nmax + 5], u[nmax + 5];
int nr_nod = 0;

Node zero = {0, 0, 0};

struct arbore_indexat_binar
{
    int aib[nmax + 5];
private:
    int ubb(int x)
    {
        return (x & (-x));
    }
public:
    void update(int ua, int ub, int val)
    {
        for(int i=ua; i<=n; i+=ubb(i))
        {
            aib[i] += val;
        }
        for(int i=ub+1; i<=n; i+=ubb(i))
        {
            aib[i] -= val;
        }
    }
    int query(int poz)
    {
        int rez = 0;
        for(int i=poz; i>=1; i-=ubb(i))
        {
            rez += aib[i];
        }
        return rez;
    }
    void init()
    {
        for(int i=1; i<=n; i++)
        {
            aib[i] = 0;
        }
    }
} aib;

struct arbore_de_intervale
{
    Node ai[4 * nmax + 5];
    int lazy[4 * nmax + 5];

    Node Merge(Node a, Node b)
    {
        Node rez;
        if(a.len > b.len)
        {
            rez = a;
        }
        else if(a.len < b.len)
        {
            rez = b;
        }
        else
        {
            if(lvl[a.nod] < lvl[b.nod])
            {
                rez = a;
            }
            else
            {
                rez = b;
            }
        }
        return rez;
    }

    void propag(int nod)
    {
        if(lazy[nod] == 0)
        {
            return;
        }
        ai[nod * 2].len += lazy[nod];
        ai[nod * 2 + 1].len += lazy[nod];
        lazy[nod * 2] += lazy[nod];
        lazy[nod * 2 + 1] += lazy[nod];
        lazy[nod] = 0;
    }

    void update(int ua, int ub, int val, int nod, int a, int b)
    {
        if(ua <=a && ub >= b)
        {
            ai[nod].len += val;
            lazy[nod] += val;
            return;
        }
        propag(nod);
        int mij = (a + b) >> 1;
        if(ua <= mij)
        {
            update(ua, ub, val, nod * 2, a, mij);
        }
        if(ub > mij)
        {
            update(ua, ub, val, nod * 2 + 1, mij + 1,b);
        }
        ai[nod] = Merge(ai[nod * 2], ai[nod * 2 + 1]);
    }

    void update_poz(int poz, Node val, int nod, int a, int b)
    {
        if(a == b)
        {
            ai[nod] = val;
            return;
        }
        propag(nod);
        int mij = (a + b) >> 1;
        if(poz <= mij)
        {
            update_poz(poz, val, nod * 2, a, mij);
        }
        else
        {
            update_poz(poz, val,nod * 2 +1, mij + 1, b);
        }
        ai[nod] = Merge(ai[nod * 2], ai[nod * 2 + 1]);
    }

    Node query(int qa, int qb, int nod, int a, int b)
    {
        if(qa <= a && qb >= b)
        {
            return ai[nod];
        }
        propag(nod);
        int mij = (a + b) >> 1;
        if(qa <= mij && qb > mij)
        {
            return Merge(query(qa, qb, nod * 2, a, mij), query(qa, qb, nod *2 + 1, mij + 1, b));
        }
        if(qa <= mij)
        {
            return query(qa, qb, nod * 2, a, mij);
        }
        return query(qa, qb, nod *2 + 1, mij + 1, b);
    }

    void init(int nod, int a, int b)
    {
        ai[nod] = zero;
        lazy[nod] = 0;
        if(a == b)
        {
            return;
        }
        int mij = (a + b) >> 1;
        init(nod * 2,a, mij);
        init(nod * 2 + 1, mij + 1, b);
    }

} ai;

int cnt = 0;
int len = 0;

void debug(vector<int> v)
{
    for(auto it : v)
    {
        cerr<<it<<' ';
    }
    cerr<<'\n';
}

void dfs(int nod, int dad = 0, int edge_dad = 0)
{
    vector<int> l;
    for(auto it : G[nod])
    {
        if(it.first == dad)
        {
            continue;
        }
        dfs(it.first, nod, it.second);
        l.push_back(aib.query(p[it.first]));
    }
    if(cnt > k)
    {
        return;
    }
    sort(l.begin(), l.end(), greater<int>());
    /*if(len == 5)
    {
        cerr<<nod<<": ";
        debug(l);
    }*/
    if(l.size() == 0)
    {
        Node cur;
        cur.nod = nod;
        cur.len = 0;
        cur.w = edge_dad;
        ai.update_poz(p[nod], cur, 1, 1, n);
        ai.update(p[nod], u[nod], edge_dad, 1, 1, n);
        aib.update(p[nod], p[nod], cur.len);
        aib.update(p[nod], u[nod], edge_dad);
        return;
    }
    if(l.size() == 1 && l[0] <= len)
    {
        Node cur;
        cur.nod = nod;
        cur.len = l[0];
        cur.w = edge_dad;
        ai.update_poz(p[nod], cur, 1, 1, n);
        ai.update(p[nod], u[nod], edge_dad, 1, 1, n);
        aib.update(p[nod], p[nod], cur.len);
        aib.update(p[nod], u[nod], edge_dad);
        return;
    }
    if(l.size() >= 2 && l[0] + l[1] <= len)
    {
        Node cur;
        cur.nod = nod;
        cur.len = l[0];
        cur.w = edge_dad;
        ai.update_poz(p[nod], cur, 1, 1, n);
        ai.update(p[nod], u[nod], edge_dad, 1, 1, n);
        aib.update(p[nod], p[nod], cur.len);
        aib.update(p[nod], u[nod], edge_dad);
        return;
    }
    int val = -1;
    if(l.size() > 1)
    {
        for(int i=0; i<l.size(); i++)
        {
            if(l[i] <= len / 2)
            {
                val = len - l[i];
                break;
            }
        }
        if(val == -1)
        {
            val = len / 2;
        }
    }
    else
    {
        val = len;
    }
    while(ai.query(p[nod], u[nod], 1, 1, n).len > val)
    {
        Node rez = ai.query(p[nod], u[nod], 1, 1, n);
        int lg = rez.len;
        int dif = rez.w;
        int nod_upd = rez.nod;
        if(lg - val >= dif)
        {
            cnt += dif;
            ai.update(p[nod_upd], u[nod_upd], -dif, 1, 1, n);
            aib.update(p[nod_upd], u[nod_upd], -dif);
            ai.update_poz(p[nod_upd], zero, 1, 1, n);
        }
        else
        {
            cnt += lg - val;
            ai.update(p[nod_upd], u[nod_upd], val - lg, 1, 1, n);
            aib.update(p[nod_upd], u[nod_upd], val - lg);
            rez.w -= (lg - val);
            rez.len -= (lg - val);
            ai.update_poz(p[nod_upd], rez, 1, 1, n);
        }
        if(cnt > k)
        {
            break;
        }
    }
    if(cnt > k)
    {
        return;
    }
    Node cur;
    cur.nod = nod;
    cur.len = 0;
    for(auto it : G[nod])
    {
        if(it.first == dad)
        {
            continue;
        }
        cur.len = max(cur.len, aib.query(p[it.first]));
    }
    cur.w = edge_dad;
    ai.update_poz(p[nod], cur, 1, 1, n);
    ai.update(p[nod], u[nod], edge_dad, 1, 1, n);
    aib.update(p[nod], p[nod], cur.len);
    aib.update(p[nod], u[nod], edge_dad);
}

bool ok(int ln)
{
    ai.init(1, 1, n);
    aib.init();
    cnt = 0;
    len = ln;
    dfs(1);
    return (cnt <= k);
}

void get_tour(int nod, int dad = 0, int level = 1)
{
    lvl[nod] = level;
    p[nod] = (++nr_nod);
    for(auto it : G[nod])
    {
        if(it.first == dad)
        {
            continue;
        }
        get_tour(it.first, nod, level + 1);
    }
    u[nod] = nr_nod;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef home
    freopen("nr.in","r",stdin);
    freopen("nr.out","w",stdout);
#endif // home
    cin>>n>>k;
    for(int i=1; i<n; i++)
    {
        int x, y, c;
        cin>>x>>y>>c;
        G[x].push_back({y, c});
        G[y].push_back({x, c});
    }
    get_tour(1);
    int st = 1;
    int dr = 2e9;
    int rez = 0;
    while(st <= dr)
    {
        int mij = (st + dr) >> 1;
        if(ok(mij))
        {
            rez = mij;
            dr = mij - 1;
        }
        else
        {
            st = mij + 1;
        }
    }
    cout<<rez<<'\n';
    return 0;
}
