#include <bits/stdc++.h>
#include "soft_drinks.h"

using namespace std;

using dbl = double;
#define double long double

double eps = 0.00000001d;

double solo(pair<double, double> A, double Ma, double Mb)
{
    double ct = 1e9;
    if (A.first != 0)
        ct = min(ct, (double)Ma / (double)A.first);
    if (A.second != 0)
        ct = min(ct, (double)Mb / (double)A.second);
    return ct;
}

double ff(pair<double, double> A, pair<double, double> B, double Ma, double Mb, double tr)
{
    Ma -= A.first * tr;
    Mb -= A.second * tr;
    if (Ma < 0 or Mb < 0)
        return 0;
    return tr + solo(B, Ma, Mb);
}

double duo(pair<double, double> A, pair<double, double> B, int Ma, int Mb)
{
    double st = 0, pas = 1 << 20;
    while (pas > eps)
    {
        double tr = st + pas;
        if (ff(A, B, Ma, Mb, tr) != 0 and ff(A, B, Ma, Mb, tr) < ff(A, B, Ma, Mb, tr + eps * 10.0d))
            st += pas;
        pas /= 2.0d;
    }
    return ff(A, B, Ma, Mb, st);
}

int n;
pair<int, int> a[100005];
int bmin = 1e9;

void init(const vector<int> & A, const vector<int>& B)
{
    n = A.size();
    for (int i = 1; i <= n; i++)
        a[i].first = A[i - 1], a[i].second = B[i - 1], bmin = min(bmin, a[i].second);
}

pair<pair<int, int>, pair<int, int>> upd(pair<int, int> A, pair<int, int> B, pair<int, int> C)
{
    double k1 = duo(A, B, C.first, C.second), k2 = duo(A, C, B.first, B.second), k3 = duo(B, C, A.first, A.second);
    if (k1 >= 1.0d)
        return {A, B};
    else if (k2 >= 1.0d)
        return {A, C};
    else if (k3 >= 1.0d)
        return {B, C};
    double angA, angB, angC;
    angA = (double)A.first / (double)(A.first + A.second);
    angB = (double)B.first / (double)(B.first + B.second);
    angC = (double)C.first / (double)(C.first + C.second);
    pair<int, int> cpA = A, cpB = B, cpC = C;
    if (angA < angB and angA > angC)
    {
        A = cpC;
        B = cpA;
        C = cpB;
    }
    if (angA > angB and angA < angC)
    {
        A = cpB;
        B = cpA;
        C = cpC;
    }
    if (angA < angB and angB < angC)
    {
        A = cpA;
        B = cpB;
        C = cpC;
    }
    if (angA > angB and angB > angC)
    {
        A = cpC;
        B = cpB;
        C = cpA;
    }
    if (angC < angB and angC > angA)
    {
        A = cpA;
        B = cpC;
        C = cpB;
    }
    if (angC > angB and angC < angA)
    {
        A = cpB;
        B = cpC;
        C = cpA;
    }
    angB = (double)B.first / (double)(B.first + B.second);
    if (angB >= 0.5d)
        return {B, A};
    return {C, B};
}

dbl friendDrink(int Ma, int Mb, int La, int Ra)
{
    vector<pair<int, int>> v;
    for (int i = 1; i <= n; i++)
        if (a[i].first >= La and a[i].first <= Ra)
            v.push_back(a[i]);
    vector<pair<int, int>> nv;
    for (int i = 0; i < v.size(); i++)
    {
        bool nah = false;
        for (int j = 0; j < v.size(); j++)
            if (i != j and v[j].first <= v[i].first and v[j].second <= v[i].second and v[j].first + v[j].second < v[i].first + v[i].second)
                nah = true;
        if (!nah)
            nv.push_back(v[i]);
    }
    v = nv;
    double ans = 0;
    for (int i = 0; i < v.size(); i++)
        ans = max(ans, solo(v[i], Ma, Mb));
    if (v.size() < 2)
        return (dbl)ans;
    pair<pair<int, int>, pair<int, int>> cn = {v[0], v[1]};
    for (int i = 2; i < v.size(); i++)
    {
        cn = upd(cn.first, cn.second, v[i]);
    }
    ans = max(ans, duo(cn.first, cn.second, Ma, Mb));
    return (dbl)ans;
}
