#include "cycles.h"
#include <iostream>
#include <algorithm>
#include <cassert>
#include <random>
#include <chrono>

using namespace std;

const int MAXN = 1000;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int n, cyc, cycord[MAXN+2], p[MAXN+2];

void makeBigCycle()
{
	for (int i = 0; i < n-1; i++) {
		int res = performSwap(i, i+1);
		if (res > cyc) {
			performSwap(i, i+1);
		}
		else {
			cyc = res;
		}
	}
}

void coolSort(int l, int r)
{
	if (l >= r) return;
	swap(cycord[l + rng() % (r-l+1)], cycord[r]);
	cyc = performSwap(0, cycord[r]);
	int l2 = l, r2 = r-1;
	while (l2 <= r2) {
		int res = performSwap(cycord[l2], cycord[r]);
		performSwap(cycord[l2], cycord[r]);
		if (res > cyc) {
			/// s-a impartit ciclul, deci e inainte de pivot
			l2++;
		}
		else {
			/// s-a unit ciclul, deci e dupa pivot
			swap(cycord[l2], cycord[r2--]);
		}
	}
	cyc = performSwap(0, cycord[r]);
	swap(cycord[r], cycord[l2]);
	coolSort(l, l2-1);
	coolSort(l2+1, r);
}

void sortPermutation(int N)
{
	n = N;
	cyc = performSwap(0, 1);
	makeBigCycle();
	assert(cyc == 1);
	for (int i = 1; i < n; i++) {
		cycord[i] = i;
	}
	shuffle(cycord+1, cycord+n, rng);
	coolSort(1, n-1);
	p[0] = cycord[1];
	for (int i = 1; i < n-1; i++) {
		p[cycord[i]] = cycord[i+1];
	}
	p[cycord[n-1]] = 0;
	for (int i = 0; i < n; i++) {
		if (p[i] == i) continue;
		for (int j = i+1; j < n; j++) {
			if (p[j] == i) {
				performSwap(i, j);
				swap(p[i], p[j]);
			}
		}
	}
}
