#include <vector>
#include <algorithm>
#include <iostream>
using namespace std;
vector <int> a,b;
vector <pair<int,int> > c;
int n;
long double eps=1e-4;
void init(const std::vector<int>& A, const std::vector<int>& B)
{
    n=A.size();
    for (int i=0;i<n;++i)
    c.push_back({A[i],B[i]});
    sort(c.begin(),c.end());
    a.resize(n);
    b.resize(n);
    for (int i=0;i<n;++i)
    {
        a[i]=c[i].first;
        b[i]=c[i].second;
    }
}
double getres(double a1,double a2,double b1,double b2,double MA,double MB)
{
    if (a1>a2) {swap(a1,a2); swap(b1,b2);}
    if (abs(a1)<eps)
    {
        if (abs(a2)<eps)
        {
            return -1;
        }
        double c2=MA/a2;
        double c1=(MB-b2*MA/a2)/b1;
        if (c1<-eps) return -1;
        return c1+c2;
    }
    double c1=MA/a1;
    if (b1-b2*a1/a2>eps)c1=min(c1,(MB-MA*b2/a2)/(b1-b2*a1/a2));
    else if (b1-b2*a1/a2<-eps)
    {
        if (c1*(b1-b2*a1/a2)>MB-MA*b2/a2) return -1;
    }
    else if (MB-MA*b2/a2<-eps) c1=-1;
    if (c1<-eps) return -1;
    return (MA+(a2-a1)*c1)/a2;

}
double friendDrink(int Ma, int Mb, int La, int Ra)
{
    int st=0,dr=n-1;
    if (a[n-1]<La||a[0]>Ra) return 0;
    while (true)
    {
        if (a[st]<La) st++;
        else break;
    }
    while (true)
    {
        if (a[dr]>Ra) dr--;
        else break;
    }
    if (dr<st) return 0;
        double ma=0;
        double MA=Ma,MB=Mb;
    for (int i=st;i<=dr;++i)
    {
        for (int j=i;j<=dr;++j)
        {
            double a1=a[i],a2=a[j],b1=b[i],b2=b[j];
            MA=Ma,MB=Mb;
            ma=max(ma,getres(a1,a2,b1,b2,MA,MB));
            ma=max(ma,getres(b1,b2,a1,a2,MB,MA));
        }
    }
    return ma;
}
/**
a1 b1
a2 b2
a1*c1+a2*c2<=Ma
c2=(Ma-a1*c1)/a2
b1*c1+b2*c2<=Mb
c1<=Ma/a1
c1*(b1-b2*a1/a2)<=Mb-Ma*b2/a2
c1+c2=(Ma+(a2-a1)*c1)/a2
**/
