#include <vector>
#include <algorithm>
#include <iostream>
#include <cmath>
using namespace std;
vector <int> a,b;
vector <pair<int,int> > c;
const int NMAX=1e5+505;
int n;
pair<int,int> pp[NMAX+505],ps;
long double eps=1e-6;
vector <pair<int,int> > glob;
long long det(pair<long long,long long> a,pair<long long,long long> b,pair<long long,long long> c)
{
    if (a.first*b.second+b.first*c.second+c.first*a.second-(a.second*b.first+b.second*c.first+c.second*a.first)>0) return 1;
    else return -1;
}
int cmp(pair<int,int> a,pair<int,int> b)
{
    return det(ps,a,b)>0;
}
vector <pair<int,int> > makecht(vector <pair<int,int> > p)
{
    int n=p.size();
    pp[1]=p[0];
    for (int i=2;i<=n;++i)
        pp[i]=p[i-1];
        sort(pp+1,pp+n+1);
        ps=pp[1];
    sort(pp+2,pp+n+1,cmp);
    vector <pair<int,int> > points;
    points.push_back(pp[1]);
    for (int i=2;i<=n;++i)
    {
        while (points.size()>1&&det(points[points.size()-2],points[points.size()-1],pp[i])<0) points.pop_back();
        points.push_back(pp[i]);
    }
    points.push_back(points[0]);
    return points;
}
void init(const std::vector<int>& A, const std::vector<int>& B)
{
    n=A.size();
    for (int i=0;i<n;++i)
    c.push_back({A[i],B[i]});
    sort(c.begin(),c.end());
    a.resize(n);
    b.resize(n);
    for (int i=0;i<n;++i)
    {
        a[i]=c[i].first;
        b[i]=c[i].second;
        glob.push_back({a[i],b[i]});
    }
    glob=makecht(glob);
}
double getres(double a1,double a2,double b1,double b2,double MA,double MB)
{
    if (a1>a2) {swap(a1,a2); swap(b1,b2);}
    if (abs(a1)<eps)
    {
        if (abs(a2)<eps)
        {
            return -1;
        }
        double c2=MA/a2;
        double c1=(MB-b2*MA/a2)/b1;
        if (c1<-eps) return -1;
        return c1+c2;
    }
    double c1=MA/a1;
    if (b1-b2*a1/a2>eps)c1=min(c1,(MB-MA*b2/a2)/(b1-b2*a1/a2));
    else if (b1-b2*a1/a2<-eps)
    {
        if (c1*(b1-b2*a1/a2)>MB-MA*b2/a2) return -1;
    }
    else if (MB-MA*b2/a2<-eps) c1=-1;
    if (c1<-eps) return -1;
    return (MA+(a2-a1)*c1)/a2;
}
double getreal(double a1,double a2,double b1,double b2,double MA,double MB)
{
    double ma=0;
    ma=max(ma,getres(a1,a2,b1,b2,MA,MB));
    ma=max(ma,getres(b1,b2,a1,a2,MB,MA));
    return ma;
}
double getrealind(int i,int j,double MA,double MB)
{
    return getreal(a[i],a[j],b[i],b[j],MA,MB);
}
double friendDrink(int Ma, int Mb, int La, int Ra)
{
    double MA=Ma,MB=Mb;
    int st=0,dr=n-1;
    if (a[n-1]<La||a[0]>Ra) return 0;
    while (true)
    {
        if (a[st]<La) st++;
        else break;
    }
    while (true)
    {
        if (a[dr]>Ra) dr--;
        else break;
    }
    if (dr<st) return 0;
    vector <pair<int,int> > vv;
    for (int i=st;i<=dr;++i)
    vv.push_back({a[i],b[i]});
    vv=makecht(vv);
    long double slop=atan2(MB,MA);
    double ma=0;
    for (int i=0;i+1<vv.size();++i)
    {
        for (int j=i;j<=min(i+5,int(vv.size()-1));++j)
        //long double c1=atan2(vv[i].second,vv[i].first),c2=atan2(vv[i+1].second,vv[i+1].first);
        /*if (min(c1,c2)<=slop&&max(c1,c2)>=slop)*/ ma=max(ma,getreal(vv[i].first,vv[j].first,vv[i].second,vv[j].second,MA,MB));
    }
    for (int i=st;i<=dr;++i)
    {
        ma=max(ma,getrealind(i,i,MA,MB));
    }
    return ma;
}
/**
a1 b1
a2 b2
a1*c1+a2*c2<=Ma
c2=(Ma-a1*c1)/a2
b1*c1+b2*c2<=Mb
c1<=Ma/a1
c1*(b1-b2*a1/a2)<=Mb-Ma*b2/a2
c1+c2=(Ma+(a2-a1)*c1)/a2

a1*c1+a2*c2=Ma
b1*c1+b2*c2=Mb
[a1 a2][c1]=[Mb]
[b1 b2][c2]=[Ma]
**/
