#include "soft_drinks.h"
#include <iostream>
#include <set>
#include <vector>
#include <cassert>
#include <algorithm>
#include <random>
#include <chrono>
#include <functional>
#include <ranges>
#define all(x) (x).begin(),(x).end()

using namespace std;

using ll = long long;
using ld = long double;
// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int, int>;
using tii = tuple<int, int, int>;

namespace {
   ld a, b, c, d;
}
void init(const std::vector<int>& A_, const std::vector<int>& B_) {
   a = A_[0];
   b = B_[0];
   c = A_[1];
   d = B_[1];
   if(a < c) swap(a, c), swap(b, d);
   return;
}

const ld eps = 1e-8;

bool check(ld S, ld L, ld R, ld Ma, ld Mb) {
   R *= S;
   L *= S;
   if(Ma < L + eps) return false;
   R = min(Ma, R);
   
   ld ml = (L - c * S) / (a - c);
   ld mr = (R - c * S) / (a - c);
   if(b - d > eps) {
      ld acidr = (Mb - S * d) / (b - d);
      if(ml + eps < min(acidr, mr)) return 1;
      return 0;
   }
   else {
      ld acidl = -(Mb - S * d) / (b - d);
      if(max(ml, acidl) + eps < mr) return 1;
      return 0;
   }
}

double friendDrink(int Ma, int Mb, int L, int R) {
   ld vol = 0;
   for(ld x = 1e9; x > eps; x /= 2.)
      if(check(vol + x, L, R, Ma, Mb)) vol += x;
   return vol;
}
