#include "soft_drinks.h"
#include <iostream>
#include <set>
#include <vector>
#include <cassert>
#include <algorithm>
#include <iomanip>
#include <random>
#include <chrono>
#include <functional>
#include <ranges>
#define all(x) (x).begin(),(x).end()

using namespace std;

using ll = long long;
using ld = long double;
// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int, int>;
using tii = tuple<int, int, int>;

namespace {
   ld a, b, c, d;
   ld A, B, L, R;
}
void init(const std::vector<int>& A_, const std::vector<int>& B_) {
   a = A_[0];
   b = B_[0];
   c = A_[1];
   d = B_[1];
   if(a < c) swap(a, c), swap(b, d);
   return;
}

const ld eps = 1e-8, inf = 1e9;


ld eval(ld x) {
   ld ulimit = min((A - a * x) / c, (B - b * x) / d);
   ld llimit = 0;
   
   if(c - L < eps) {
      ulimit = min(ulimit, x * (L - a) / (c - L));
   }
   if(c - L > eps) {
      llimit = max(llimit, x * (L - a) / (c - L));
   }
   else {
      if(x * (L - a) > eps) return -inf;
   }
   
   if(c - R > eps) {
      ulimit = min(ulimit, x * (R - a) / (c - R));
   }
   if(c - R < eps) {
      llimit = max(llimit, x * (R - a) / (c - R));
   }
   else {
      if(x * (L - a) < eps) return -inf;
   }
   if(llimit > ulimit - eps) return -inf;
   return ulimit + x;
}

double friendDrink(int Ma, int Mb, int La, int Ra) {
   A = Ma;
   B = Mb;
   L = La;
   R = Ra;
   ld l = 0, r = 1e9;
   while(r - l > eps) {
      ld l1 = l + (r - l) / 3.;
      ld r1 = r - (r - l) / 3.;
      if(eval(l1) == -inf) r = l1;
      else {
	 if(eval(l1) > eval(r1)) r = r1;
	 else l = l1;
      }
   }
   return max(0., eval(l));
}
