#include "soft_drinks.h"
#include <iostream>
#include <set>
#include <vector>
#include <cassert>
#include <algorithm>
#include <iomanip>
#include <random>
#include <chrono>
#include <functional>
#include <ranges>
#define all(x) (x).begin(),(x).end()

using namespace std;

using ll = long long;
using ld = long double;
// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int, int>;
using tii = tuple<int, int, int>;

namespace {
   ld a, b, c, d;
}
void init(const std::vector<int>& A_, const std::vector<int>& B_) {
   a = A_[0];
   b = B_[0];
   if(sz(A_) == 1) {
      c = -1;
      return;
   }
   c = A_[1];
   d = B_[1];
   if(a < c) swap(a, c), swap(b, d);
   return;
}

const ld eps = 1e-8, inf = 1e9;

// double eval(ld a, ld b, ld c, ld d) {
   // auto eval = [&](ld x) {
      // ld ulimit = min((A - a * x) / c, (B - b * x) / d);
      // if(ulimit < 0) return -inf;
      // ld llimit = 0;

      // if(c - L < eps) {
	 // ulimit = min(ulimit, x * (L - a) / (c - L));
      // }
      // if(c - L > eps) {
	 // llimit = max(llimit, x * (L - a) / (c - L));
      // }
      // else {
	 // if(x * (L - a) > eps) return -inf;
      // }

      // if(c - R > eps) {
	 // ulimit = min(ulimit, x * (R - a) / (c - R));
      // }
      // if(c - R < eps) {
	 // llimit = max(llimit, x * (R - a) / (c - R));
      // }
      // else {
	 // if(x * (L - a) < eps) return -inf;
      // }
      // if(llimit > ulimit - eps) return -inf;
      // return ulimit + x;
   // };
   
   // ld l = 0, r = 1e9;
   // while(r - l > eps) {
      // ld l1 = l + (r - l) / 3.;
      // ld r1 = r - (r - l) / 3.;
      // if(eval(l1) == -inf) r = l1;
      // else {
	 // if(eval(l1) > eval(r1)) r = r1;
	 // else l = l1;
      // }
   // }
   // ld coop = max((ld)0., eval(l));
   // if(L <= a && a <= R)
      // coop = max(coop, min((b == 0? inf : B / b), (a == 0? inf : A / a)));
   // if(L <= c && c <= R)
      // coop = max(coop, min((d == 0? inf : B / d), (c == 0? inf : A / c)));
   // return coop;
// }

ld evalUnder(ld a, ld b, ld A, ld B) {
   return min((b == 0? inf : B / b), (a == 0? inf : A / a));
}

double friendDrink(int Ma, int Mb, int La, int Ra) {
   ld A, B, L, R;
   A = Ma;
   B = Mb;
   L = La;
   R = Ra;
   if(c == -1) {
      ld coop = (ld)0.;
      if(L <= a && a <= R)
	 coop = max(coop, min((b == 0? inf : B / b), (a == 0? inf : A / a)));
      return coop;
   }
   L = max(L, c);
   R = min(R, a);
   if(R < L) return 0;
   
   ld vecx = R, vecy = (a == c? b : b + (d - b) * (a - R) / (a - c));
   ld fin = 0;
   fin = max(fin, evalUnder(vecx, vecy, A, B));
   vecx = L, vecy = (a == c? d : d + (b - d) * (L - c) / (a - c));
   fin = max(fin, evalUnder(vecx, vecy, A, B));
   return fin;
}
