#include "soft_drinks.h"
#include <iostream>
#include <set>
#include <vector>
#include <cassert>
#include <algorithm>
#include <iomanip>
#include <random>
#include <chrono>
#include <functional>
#include <ranges>
#define all(x) (x).begin(),(x).end()

using namespace std;

using ll = long long;
using ld = long double;
// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int, int>;
using tii = tuple<int, int, int>;

vector<ld> X, Y;

void init(const std::vector<int>& A_, const std::vector<int>& B_) {
   for(auto x: A_) X.emplace_back(x);
   for(auto x: B_) Y.emplace_back(x);
   return;
}

const ld eps = 1e-8, inf = 1e9;

// double eval(ld a, ld b, ld c, ld d) {
   // auto eval = [&](ld x) {
      // ld ulimit = min((A - a * x) / c, (B - b * x) / d);
      // if(ulimit < 0) return -inf;
      // ld llimit = 0;

      // if(c - L < eps) {
	 // ulimit = min(ulimit, x * (L - a) / (c - L));
      // }
      // if(c - L > eps) {
	 // llimit = max(llimit, x * (L - a) / (c - L));
      // }
      // else {
	 // if(x * (L - a) > eps) return -inf;
      // }

      // if(c - R > eps) {
	 // ulimit = min(ulimit, x * (R - a) / (c - R));
      // }
      // if(c - R < eps) {
	 // llimit = max(llimit, x * (R - a) / (c - R));
      // }
      // else {
	 // if(x * (L - a) < eps) return -inf;
      // }
      // if(llimit > ulimit - eps) return -inf;
      // return ulimit + x;
   // };
   
   // ld l = 0, r = 1e9;
   // while(r - l > eps) {
      // ld l1 = l + (r - l) / 3.;
      // ld r1 = r - (r - l) / 3.;
      // if(eval(l1) == -inf) r = l1;
      // else {
	 // if(eval(l1) > eval(r1)) r = r1;
	 // else l = l1;
      // }
   // }
   // ld coop = max((ld)0., eval(l));
   // if(L <= a && a <= R)
      // coop = max(coop, min((b == 0? inf : B / b), (a == 0? inf : A / a)));
   // if(L <= c && c <= R)
      // coop = max(coop, min((d == 0? inf : B / d), (c == 0? inf : A / c)));
   // return coop;
// }

ld p2(ld a) { return a * a; }
ld dist(ld a, ld b) { return sqrt(p2(a) + p2(b)); }

int orient(ld a, ld b, ld c, ld d) {
   return (a * d - b * c < eps)? -1 : ((a * d - b * c > eps)? 1 : 0);
}

ld evalUnder(ld Ax, ld Ay, ld Bx, ld By, ld A, ld B) {
   if(orient(Bx, By, A, B) == 0) {
      return dist(A, B) / dist(Bx, By);
   }
   if(orient(Ax, Ay, A, B) == 0) {
      return dist(A, B) / dist(Ax, Ay);
   }
   
   ld alpha = Bx;
   for(ld step = 1e9; step > 1e-8; step /= 2.) {
      alpha += step;
      if(orient(Bx - Ax, By - Ay, A * alpha, B * alpha) <= 0) alpha += step;
      alpha -= step;
   }
   return dist(A, B) / alpha;
}

double friendDrink(int Ma, int Mb, int La, int Ra) {
   ld A, B, L, R;
   A = Ma;
   B = Mb;
   L = La;
   R = Ra;
   ld coop = (ld)0.;
   for(int i = 0; i < sz(X); i++) {
      auto a = X[i];
      auto b = Y[i];
      if(L <= a && a <= R)
	 coop = max(coop, min((b == 0? inf : B / b), (a == 0? inf : A / a)));
   }
   for(int i = 0; i < sz(X); i++) {
      auto a = X[i];
      auto b = Y[i];
      for(int j = 0; j < sz(X); j++) {
	 auto c = X[j];
	 auto d = Y[j];
	 L = La;
	 R = Ra;
	 L = max(L, c);
	 R = min(R, a);
	 
	 if(L > R) continue;
	 
	 ld Ax = R, Ay = (a == c? b : b + (d - b) * (a - R) / (a - c));
	 ld Bx = L, By = (a == c? d : d + (b - d) * (L - c) / (a - c));
	 coop = max(coop, evalUnder(Ax, Ay, Bx, By, A, B));
      }
   }
   
   return coop;
}
