#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
#include <random>
#include <chrono>
#include "cycles.h"
#define all(x) (x).begin(),(x).end()

using namespace std;

using ll = long long;
// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int, int>;
using tii = tuple<int, int, int>;
int N;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
int rnd(int x) { return rng() % x; }

int lval;
int query(int x, int y) {
   return lval = performSwap(x, y);
}

void quicksort(vector<int> idx) {
   if(sz(idx) <= 1) return;
   int a = rnd(sz(idx)), b = rnd(sz(idx) - 1);
   if(b >= a) b++;
   auto bias = query(idx[a], idx[b]);
   vector<int> L, R;
   for(auto x : idx) {
      if(x == idx[a]) L.emplace_back(x);
      else if(x == idx[b]) R.emplace_back(x);
      else {
	 if(query(x, idx[b]) < bias) L.emplace_back(x);
	 else R.emplace_back(x);
	 query(x, idx[b]);
      }
   }
   
   quicksort(L);
   quicksort(R);
   return;
}

void sortPermutation(int n_) {
   N = n_;
   int C = (query(0, 1), query(0, 1));
   for(int i = 0; i < N - 1; i++) {
      int A = performSwap(i, i + 1);
      if(A > C) performSwap(i, i + 1);
      else C = A;
   }
   vector<int> incycle(N);
   iota(all(incycle), 0);
   quicksort(incycle);
   return;
}
