#warning vreau sa ia puncte
#include <iostream>
#include <set>
#include <queue>
#include <vector>
#include <cassert>
#include <algorithm>
#include <random>
#include <chrono>
#include <functional>
#include <ranges>
#define all(x) (x).begin(),(x).end()

using namespace std;

using ll = long long;
// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int, int>;
using tii = tuple<int, int, int>;

const int inf = 1e9 + 5;


template<typename T>
struct AINT {
   vector<T> aint;
   int n;
   void init(int n_) {
      n = n_;
      aint.assign(2 * n + 5, T());
   }
   template<class CB> void walk(CB&& cb) { walk(cb, 1, n); }
   template<class CB> void walk(CB&& cb, int l, int r) { walk(cb, l, r, 1, 1, n); }
   template<class CB> void walk(CB&& cb, int l, int r, int node, int cl, int cr) { 
      if(cr < l || r < cl) return;
      if(l <= cl && cr <= r && !cb(aint[node], cl, cr)) return;
      int mid = (cl + cr) >> 1, L = node + 1, R = node + (mid - cl + 1) * 2;
      aint[node].push(aint[L], aint[R]);
      walk(cb, l, r, L, cl, mid);
      walk(cb, l, r, R, mid + 1, cr);
      aint[node].pull(aint[L], aint[R]);
   }
};

struct MaxAdd {
   int mx;
   int lazy;
   MaxAdd(): mx(-inf), lazy(0) {;}
   MaxAdd(int a): mx(a), lazy(0) {;}
   void apply(int x) {
      mx += x;
      lazy += x;
   }
   void pull(const MaxAdd& L, const MaxAdd& R) {
      mx = max(L.mx, R.mx);
   }
   void push(MaxAdd& L, MaxAdd& R) {
      if(!lazy) return;
      L.apply(lazy);
      R.apply(lazy);
      lazy = 0;
   }
};

namespace G {
   vector<vector<pii>> g;
   vector<int> d, pin, pout, p, preord;
   int inp;
   
   void init(int n) { g.assign(n, vector<pii>{}); }
   int newnode() { g.emplace_back(); return sz(g) - 1; }
   void addedge(int a, int b, int w) { g[b].emplace_back(a, w), g[a].emplace_back(b, w); }
      
   void startgraph() {
      d.assign(sz(g), 0);
      pin.assign(sz(g), 0);
      p.assign(sz(g), 0);
      pout.assign(sz(g), 0);
   }
   void initd(int node, int f) {
      p[node] = f;
      for(auto [x, c] : g[node]) {
	 if(x == f) continue;
	 d[x] = d[node] + c;
	 initd(x, node);
      }
      return;
   }
   
   pii findcentr() {
      int x = 0, y = 1;
      for(int step = 0; step < 2; step++) {
	 fill(all(d), 0);
	 initd(x, x);
	 for(int i = 0; i < sz(g); i++)
	    if(d[i] > d[y]) y = i;
	 swap(x, y);
      }
      fill(all(d), 0);
      initd(x, x);
      int D = d[y];
      int z = y;
      // cerr << x << ' ' << y << '\t' << sz(g) << '\n';;
      for(int i = 0; (d[y] - d[p[z]]) * 2 < D; i++, z = p[z]);
      
      
      
      int Dup = d[p[z]];
      int target = D / 2;
      if(Dup == target || d[z] - d[p[z]] == 1) return make_pair(p[z], D);
      int ncentr = newnode();
      addedge(p[z], ncentr, target - Dup);
      addedge(z, ncentr, (d[z] - d[p[z]]) - (target - Dup));
      for(int i = 0; i < sz(g[z]); i++) {
	 if(g[z][i].first == p[z]) {
	    swap(g[z][i], g[z].back());
	    g[z].pop_back();
	    break;
	 }
      }
      for(int i = 0; i < sz(g[p[z]]); i++) {
	 if(g[p[z]][i].first == z) {
	    swap(g[p[z]][i], g[p[z]].back());
	    g[p[z]].pop_back();
	    break;
	 }
      }
      
      return pii{ncentr, D};
   }
   
   void initall(int node, int f) {
      pin[node] = inp++;
      preord.emplace_back(node);
      p[node] = f;
      for(auto [x, c] : g[node]) {
	 if(x == f) continue;
	 d[x] = d[node] + c;
	 initall(x, node);
      }
      pout[node] = inp - 1;
      return;
   }
   void initall(int root) {
      inp = 1;
      fill(all(d), 0);
      preord.clear();
      preord.emplace_back(-1);
      initall(root, root);
   }
   bool isanc(int f, int node) { return pin[f] <= pin[node] && pout[node] <= pout[f]; }
}

const int nmax = 1e6 + 5;
vector<int> dial[nmax];

struct DistsMaintainer : AINT<MaxAdd> {
   void addsub(int node, int val) {
      walk([&](auto &a, int cl, int cr) {
	 a.apply(val);
	 return 0;
      }, G::pin[node], G::pout[node]);
   } 
   int query(int node) {
      int mx = 0;
      walk([&](auto &a, int cl, int cr) {
	 mx = max(mx, a.mx);
	 return 0;
      }, G::pin[node], G::pout[node]);
      return mx;
   }
};

struct Link {
   int weight;
   int parentexhaust, node;
   Link(int a, int b, int c): weight(a), parentexhaust(b), node(c) {;}
};

// template<typename T> void print(T x) {
   // while(!x.empty()) cerr << x.top().node << '\t' << x.top().weight << ' ' << x.top().parentexhaust << '\n', x.pop();
   // cerr << '\n';
// }

signed main() {
   cin.tie(0) -> sync_with_stdio(0);
   
   int n, K;
   cin >> n >> K;
   G::init(n);
   for(int i = 1, x, y, w; i < n; i++) {
      cin >> x >> y >> w;
      --x;
      --y;
      G::addedge(x, y, w);
   }
   using namespace G;
   startgraph();
   n = sz(g);
   
   
   auto [centr, D] = findcentr();
   // cerr << centr << '\n';
   // for(int i = 0; i < sz(g); i++) {
      // for(auto [j, c] : g[i])
	 // if(i < j) cerr << i << ' ' << j << ' ' << c << '\n';
   // }
   // cerr << '\n';
   startgraph();
   n = sz(g);
   
   initall(centr);
   
   DistsMaintainer downdists;
   downdists.init(n);
   downdists.walk([&](auto &a, int cl, int cr) {
      if(cl != cr) return 1;
      a.mx = d[preord[cl]];
      return 0;
   });
   
   auto compare_death = [&](Link& a, Link& b) { return a.parentexhaust > b.parentexhaust; };
   priority_queue<Link, vector<Link>, decltype(compare_death)> samelevel(compare_death);
   auto compare_enter = [&](Link& a, Link& b) { return a.weight < b.weight; };
   priority_queue<Link, vector<Link>, decltype(compare_enter)> candidate(compare_enter);
   
   int offsetex = 0;
   
   for(auto [y, c] : g[centr])
      candidate.emplace(Link{downdists.query(y), c, y});
   
   auto inserttopcandidate = [&](){
      auto a = candidate.top();
      candidate.pop();
      a.weight += offsetex;
      a.parentexhaust += offsetex;
      samelevel.emplace(a);
   };
   
   while(K >= 0 && (sz(candidate) || sz(samelevel))) {
      while([&]() {
	 if(sz(samelevel) == 0) return true;
	 if(sz(candidate) == 0) return false;
	 auto a = candidate.top();
	 // cerr << a.weight << ' ' << samelevel.top().weight << '\n';
	 return a.weight >= samelevel.top().weight - offsetex;
      }())
	 inserttopcandidate();
	 
      // cerr << offsetex << '\n';
      // cerr << "cand:\n";
      // print(candidate);
      // cerr << "samelevel:\n";
      // print(samelevel);
	 
      int maxdec = ([&]() {
	 int mn = samelevel.top().parentexhaust - offsetex;
	 if(sz(candidate)) mn = min(samelevel.top().weight - offsetex - candidate.top().weight, mn);
	 return mn;
      }());
      assert(maxdec >= 0);
      
      int iterations = min(K / sz(samelevel), maxdec);
      // cerr << iterations << " of " << sz(samelevel) << " for " << K << '\n';
      // cerr << "--\n";
      if(iterations == 0) {
	 assert(maxdec > 0);
	 while(sz(samelevel)) {
	    auto [w, pe, node] = samelevel.top();
	    samelevel.pop();
	    K--;
	    int highedge = -1;
	    for(auto [x, c] : g[node])
	       if(x == p[node]) highedge = c;
	    int decreased = highedge - (pe - offsetex - (K >= 0));
	    // cerr << node << ": " << highedge << ' ' << decreased << ' ' << '\t' << pe << ' ' << offsetex << ' ' << (K >= 0) << '\n';
	    assert(decreased >= 0);
	    downdists.addsub(node, -decreased);
	    candidate.emplace(downdists.query(node), highedge - decreased, node);
	 }
	 break;
      }
      offsetex += iterations;
      K -= sz(samelevel) * iterations;
      
      while(sz(samelevel) && samelevel.top().parentexhaust <= offsetex) {
	 auto [w, pe, node] = samelevel.top();
	 samelevel.pop();
	 
	 
	 int highedge = -1;
	 for(auto [x, c] : g[node])
	    if(x == p[node]) highedge = c;
	 int decreased = highedge - (pe - offsetex);
	 assert(decreased >= 0);
	 downdists.addsub(node, -decreased);
	 assert(decreased == highedge);
	 for(auto [x, c] : g[node]) {
	    if(x == p[node]) continue;
	    candidate.emplace(Link{downdists.query(x), c, x});
	 }
      }
   }
   
   vector<int> hh;
   while(sz(candidate)) hh.emplace_back(candidate.top().weight), candidate.pop();
   sort(all(hh), greater<int>());
   hh.emplace_back(0); hh.emplace_back(0); hh.emplace_back(0); hh.emplace_back(0); 
   cout << hh[0] + hh[1] << '\n';
   
   // for(int i = n; K && i > 0; i--) {
      // while(K && sz(dial[i])) {
	 // int x = dial[i].back();
	 // dial[i].pop_back();
	 
	 // downdists.addsub(x, -1);
	 // if(sz(g[x]) == 1) dial[0].emplace_back(x);
	 // else {
	    // for(auto y : g[x]) {
	       // if(isanc(x, y))
		  // dial[downdists.query(y)].emplace_back(y);
	    // }
	 // }
	 // K--;
      // }
   // }
   
   // for(int i = n; i >= 0; i--) {
      // if(sz(dial[i])) {
	 // if(sz(dial[i]) >= 2) cout << 2 * i << '\n';
	 // else assert(sz(dial[i - 1])), cout << 2 * i - 1 << '\n';
	 // return 0;
      // }
   // }
   // assert(false);
   return 0;
}
