#include <bits/stdc++.h>
using namespace std;
#define pii pair<int, int>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
#define ordered_set tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update>
mt19937 rnd( chrono::steady_clock::now().time_since_epoch().count() );
using ll = long long;
const int NMAX = 2000;

struct Edge{
  int a;
  int b;
  int w;
};
Edge list_edges[NMAX+1];

vector <pii> edges[NMAX+1];
int n;
int dep[NMAX+1];
int parent[NMAX+1];

void dfs( int node, int par = -1 ) {
  parent[node] = par;
  for( auto vec: edges[node] ) {
    if( vec.first != par ) {
      dep[vec.first] = dep[node] + vec.second;
      dfs( vec.first, node );
    }
  }
}

void put_edges() {
  int i, a, b, w;
  for( i = 1; i <= n; i++ )
    edges[i].clear();
  for( auto edg: list_edges ) {
    a = edg.a;
    b = edg.b;
    w = edg.w;
    edges[a].push_back( { b, w } );
    edges[b].push_back( { a, w } );
  }
}

int lca[NMAX+1][NMAX+1];
int get_lca( int i, int j ) {
  while( i != j ) {
    if( dep[i] > dep[j] )
      i = parent[i];
    else
      j = parent[j];
  }
  return i;
}
void compute_lca() {
  int i, j;
  for( i = 1; i <= n; i++ ) {
    for( j = i + 1; j <= n; j++ ) {
      lca[i][j] = lca[j][i] = get_lca( i, j );
    }
  }
}

pii diam() {
  int maxi = -1, i, j, d, LCA, dist, fv;
  for( i = 1; i <= n; i++ ) {
    for( j = i + 1; j <= n; j++ ) {
      LCA = lca[i][j];
      dist = dep[i] - dep[LCA] + dep[j] - dep[LCA];
      if( dist > maxi ) {
        maxi = dist;
        fv = 1;
      }
      else if( dist == maxi )
        fv++;
    }
  }
  return { maxi, fv };
}

void solve() {
  int k, i, a, b, w, maxi, poz;
  pii ans, cur;
  cin >> n >> k;
  maxi = 0;
  for( i = 0; i < n - 1; i++ ) {
    cin >> a >> b >> w;
    list_edges[i] = Edge{ a, b, w };
    maxi = max( maxi, w );
  }
  if( n <= 2000 && maxi == 1 ) {
    k = min( k, n - 1 );
    put_edges();
    dfs( 1 );
    compute_lca();
    ans = diam();
    while( k-- ) {
      for( i = 0; i < n - 1; i++ ) {
        Edge& edg = list_edges[i];
        if( edg.w == 0 )
          continue;
        edg.w--;
        put_edges();
        dfs( 1 );
        cur = diam();
        if( cur.first < ans.first || ( cur.first == ans.first && cur.second < ans.second ) ) {
          ans = cur;
          poz = i;
        }
        edg.w++;
      }
      list_edges[poz].w--;
    }
    put_edges();
    dfs( 1 );
    cout << diam().first;
  }
}
int main() {
  ios_base::sync_with_stdio( false );
  cin.tie( NULL );
  cout.tie( NULL );
  int t = 1;
  // cin >> t;
  while( t-- ) {
    solve();
  }
}

