#include <bits/stdc++.h>
using namespace std;
#define pii pair<int, int>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
#define ordered_set tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update>
mt19937 rnd( chrono::steady_clock::now().time_since_epoch().count() );
using ll = long long;
const int NMAX = 200;

struct Edge{
  int a;
  int b;
  int w;
};
Edge list_edges[NMAX+1];

vector <pii> edges[NMAX+1];
int n;
int dep[NMAX+1], nivel[NMAX+1];
int parent[NMAX+1];

void dfs( int node, int par = -1 ) {
  parent[node] = par;
  for( auto vec: edges[node] ) {
    if( vec.first != par ) {
      dep[vec.first] = dep[node] + vec.second;
      nivel[vec.first] = nivel[node] + 1;
      dfs( vec.first, node );
    }
  }
}

void put_edges() {
  int i, a, b, w;
  for( i = 1; i <= n; i++ )
    edges[i].clear();
  for( auto edg: list_edges ) {
    a = edg.a;
    b = edg.b;
    w = edg.w;
    edges[a].push_back( { b, w } );
    edges[b].push_back( { a, w } );
  }
}

int x, y;
int diam() {
  int i;
  for( i = 1; i <= n; i++ )
    dep[i] = 0;
  put_edges();
  dfs( 1 );
  int maxi = 0;
  for( i = 1; i <= n; i++ ) {
    if( dep[i] > maxi ) {
      maxi = dep[i];
      x = i;
    }
  }
  for( i = 1; i <= n; i++ )
    dep[i] = 0;
  dfs( x );
  maxi = 0;
  for( i = 1; i <= n; i++ ) {
    if( dep[i] > maxi ) {
      maxi = dep[i];
      y = i;
    }
  }
  return maxi;
}

vector <int> path;
void getPath() {
  vector <int> aux;
  while( x != y ) {
    if( nivel[x] > nivel[y] ) {
      path.push_back( x );
      x = parent[x];
    }
    else {
      aux.push_back( y );
      y = parent[y];
    }
  }
  path.push_back( x );
  reverse( aux.begin(), aux.end() );
  for( auto x: aux )
    path.push_back( x );
}

bool viz[NMAX+1];
int dp[NMAX+1];

void dfs_diam( int node, int inaltime ) {
  viz[node] = true;
  dp[node] = inaltime;
  for( auto vec: edges[node] ) {
    if( !viz[vec.first] ) {
      dfs_diam( vec.first, inaltime + 1 );
      dp[node] = max( dp[node], dp[vec.first] );
    }
  }
}
void solve() {
  int k, i, a, b, w, poz, d;
  pii ans, cur;
  cin >> n >> k;
  for( i = 0; i < n - 1; i++ ) {
    cin >> a >> b >> w;
    list_edges[i] = Edge{ a, b, w };
  }
  if( k == 1 ) {
    d = diam();
    getPath();
    for( auto x: path )
      viz[x] = true;
    for( i = 0; i < path.size(); i++ )
      dfs_diam( path[i], 0 );
    for( i = 1; i <= n; i++ )
      viz[i] = false;
    for( auto x: path )
      viz[x] = true;
    bool ok = true;
    for( i = 0; i < path.size(); i++ ) {
      vector<int> adj;
      for( auto vec: edges[path[i]] )
        if( !viz[vec.first] ) adj.push_back( dp[vec.first] );
      sort( adj.begin(), adj.end(), greater<int>() );
      if( adj.size() >= 2 && adj[0] + adj[1] >= d )
        ok = false;
    }
    if( !ok ) {
      cout << d;
      return;
    }
    ok = true;
    set<int> s;
    for( i = 0; i < path.size(); i++ ) {
      if( !s.empty() && *(s.begin()) + dp[i] + i == d ) {
        ok = false;
        x = path[i];
        y = path[i-1];
      }
      s.insert( dp[i] - i );
    }
    if( ok ) {
      cout << d - 1;
      return;
    }
    for( i = 0; i < n - 1; i++ ) {
      a = list_edges[i].a, b = list_edges[i].b, w = list_edges[i].w;
      if( ( a == x && b == y ) || ( a == y && b == x ) )
        list_edges[i].w--;
    }
    cout << diam();
  }
}
int main() {
  ios_base::sync_with_stdio( false );
  cin.tie( NULL );
  cout.tie( NULL );
  int t = 1;
  // cin >> t;
  while( t-- ) {
    solve();
  }
}

