#include <iostream>
#include <algorithm>
#include <vector>

#define nMax 2001

using namespace std;


struct nod{
    int mark=0;
    vector<int> kids;
};

int n, k, x, y, z, curMark, curNod, curRoot, maxim=0;
int dist[nMax][nMax];
nod tree[nMax];

struct edge{
    int x;
    int y;
    int z;
};

vector<edge> top;

void dfs(){
    tree[curNod].mark=curMark;
    for(auto i : tree[curNod].kids){
        if(tree[i].mark!=curMark){
            dist[curNod][i]++;
            dist[i][curNod]++;
            int aux=curNod;
            curNod=i;
            dfs();
            curNod=aux;
        }
    }
}

int compare(edge a, edge b){
    return a.z>b.z;
}

void dfs2(int sum){
    tree[curNod].mark=curMark;
    for(auto i : tree[curNod].kids){
        if(tree[i].mark!=curMark){
            sum+=dist[curNod][i];
            if(!dist[curRoot][curNod]){
                dist[curRoot][curNod]=dist[curNod][curRoot]=sum;
                if(sum>maxim)
                    maxim=sum;
            }
            int aux=curNod;
            curNod=i;
            dfs2(sum);
            curNod=aux;
            sum-=dist[curNod][i];
        }
    }
}


int main()
{
    cin>>n>>k;
    for(int i=1;i<n;i++){
        cin>>x>>y>>z;
        dist[x][y]=dist[y][x]=z;
        tree[x].kids.push_back(y);
        tree[y].kids.push_back(x);
    }

    for(int i=1;i<=n;i++){
        curMark++;
        curRoot=i;
        curNod=i;
        dfs();
    }

    for(int i=1;i<n;i++)
        for(int j=i+1;j<=n;j++){
            if(!dist[i][j])continue;
            top.push_back({i, j, dist[i][j]});
            dist[i][j]=1;
            dist[j][i]=1;
        }


    sort(top.begin(), top.end(), compare);

    for(int i=0;i<k&&i<(top.size()-1);i++)
        dist[top[i].x][top[i].y]=0;


    curMark=0;
    for(int i=1;i<=n;i++){
        curMark++;
        curRoot=i;
        curNod=i;
        dfs2(0);
    }

    cout<<maxim;

    return 0;
}
