#include <vector>
#include <algorithm>
#include "cycles.h"

using namespace std;

int nrcycles;

int triswap( int x, int y, int z ) {
    performSwap( x, z );
    int newnrcycles = performSwap( y, z );
    performSwap( y, z );
    performSwap( x, z );

    return newnrcycles;
}

bool cmp( int a, int b ) {
    int newnrcycles = triswap( 0, a, b );
    //printf( "%d %d %d\n", a, b, newnrcycles );
    return (newnrcycles > 1);
}

void sortPermutation( int n ) {
    nrcycles = performSwap( 0, 1 );
    for ( int i = 1; i < n; i++ ) {
        int newnrcycles = performSwap( 0, i );
        if ( newnrcycles > nrcycles )
            newnrcycles = performSwap( 0, i );
        nrcycles = newnrcycles;
    }
    assert( nrcycles == 1 );

    vector<int> cyc;
    for ( int i = 1; i < n; i++ )
        cyc.push_back( i );

    sort( cyc.begin(), cyc.end(), cmp );
    //for ( int i = 0; i < n - 1; i++ )
    //    printf( "%d %d\n", i,  cyc[i] );

    for ( int i = 0; i < n - 1; i++ )
        performSwap( 0, cyc[i] );
}

