#include <vector>
#include <algorithm>
#include "cycles.h"
#include <cassert>

using namespace std;

int nrcycles;

int triswap( int x, int y, int z ) {
    performSwap( x, z );
    int newnrcycles = performSwap( y, z );

    return newnrcycles;
}

bool cmp( int a, int b ) {
    int newnrcycles = triswap( 0, a, b );
    //printf( "%d %d %d\n", a, b, newnrcycles );
    triswap( a, 0, b );
    return (newnrcycles > 1);
}

void sortPermutation( int n ) {
    int nrcyc = performSwap( 0, 1 );
    for ( int i = 0; i + 1 < n; i += 2 ) {
        int newSwap = performSwap( i, i + 1 );
        if ( newSwap > nrcyc )
            nrcyc++;
        else
            performSwap( i, i + 1 );
    }
}
