#include <vector>
#include <algorithm>
#include "cycles.h"
#include <cassert>

using namespace std;

int nrcycles;

int triswap( int x, int y, int z ) {
    performSwap( x, z );
    int newnrcycles = performSwap( y, z );

    return newnrcycles;
}

bool cmp( int a, int b ) {
    int newnrcycles = triswap( 0, a, b );
    //printf( "%d %d %d\n", a, b, newnrcycles );
    triswap( a, 0, b );
    return (newnrcycles > 1);
}

void sortPermutation( int n ) {
    performSwap( 0, 1 );
    int nrcyc = performSwap( 0, 1 );
    int poz = 0;
    for ( int i = 1; i < n; i++ ) {
        int newnrcyc = performSwap( 0, i );
        if ( newnrcyc >= nrcyc ) 
            poz = i;
        nrcyc = newnrcyc;
    }
    for ( int i = n - 1; i > 0; i-- )
        nrcyc = performSwap( 0, i );

    for ( int i = 0; i < n; i++ ) {
        if ( i != poz ) {
            int nn = performSwap( i, poz );
            if ( nn == n )
                return;
            performSwap( i, poz );
        }
    }
}
