#include <vector>
#include <iostream>

using namespace std;

struct edge {
    int u, v, c;
    int other( int w ) {
        return u ^ v ^ w;
    }
};

struct diameter {
    int len, u, v, l;
};

const int MAX_N = 2e5;
int maxDepth[MAX_N + 1], maxNode[MAX_N + 1];
int depth[MAX_N + 1];
int parent[MAX_N + 1], parentEdge[MAX_N + 1];
edge edges[MAX_N];
vector<int> adj[MAX_N + 1];

diameter diam;
bool ok = true;
void findDiam( int u, int p ) {
    int max1 = 0, max2 = 0, nod1 = u, nod2 = -1;
    for ( int e: adj[u] ) {
        int v = edges[e].other( u );
        if ( v == p )
            continue;
        int c = edges[e].c;
        depth[v] = depth[u] + c;
        parentEdge[v] = e;
        parent[v] = u;
        findDiam( v, u );
        if ( maxDepth[v] + c > max1 ) {
            max2 = max1;
            nod2 = nod1;
            max1 = maxDepth[v] + c;
            nod1 = maxNode[v];
        } else if ( maxDepth[v] + c > max2 ) {
            max2 = maxDepth[v] + c;
            nod2 = maxNode[v];
        }
    }
    maxDepth[u] = max1;
    maxNode[u] = nod1;

    if ( p == 0 || ok ) {
    if ( max1 > diam.len ) 
        diam = { max1, nod1, u, u };
    if ( nod2 != -1 && max1 + max2 > diam.len ) 
        diam = { max1 + max2, nod1, nod2, u };
    }
}

int findCenter( diameter d, bool scad ) {
    int u = d.u, v = d.v, l = d.l;
    if ( depth[u] - depth[l] < depth[v] - depth[l] )
        swap( u, v );
    int a = d.len, b = 0, e = 0;
    while ( a > b ) {
        e = parentEdge[u];
        a -= edges[e].c;
        b += edges[e].c;
        u = edges[e].other( u );
    }
    //printf( "SCAD 1 din %d\n", e );
    if ( scad )
        edges[e].c--;
    return u;
}

int main() {
    int n, k;

    cin >> n >> k;
    for ( int i = 0; i < n - 1; i++ ) {
        cin >> edges[i].u >> edges[i].v >> edges[i].c;
        adj[edges[i].u].push_back( i );
        adj[edges[i].v].push_back( i );
    }

    diam = { 0, 0, 0, 0 };
    findDiam( 1, 0 );
    int c = findCenter( diam, false );
ok = false;
    for ( int i = 0; i < k; i++ ) {
        diam = { 0, 0, 0, 0 };
        findDiam( c, 0 );
        //printf( "DIAM %d %d %d %d\n", diam.len, diam.l, diam.u, diam.v );
        if ( diam.len == 0 )
            break;
        findCenter( diam, true );
    }
ok = true;
    diam = { 0, 0, 0, 0 };
    findDiam( 1, 0 );

    cout << diam.len << "\n";
}
