#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#include "cycles.h"
#define MAXN 1003
using namespace std;

int aint[MAXN*4];

struct XYZ{
  int x,y;
};

int sir[MAXN]={0,1,4,3,2};

int aft,bef;

void SwapTwo(int poz1,int poz2){
  bef=aft;
  swap(sir[poz1],sir[poz2]);
  aft=performSwap(poz1,poz2);
}

void FirstMistake(XYZ a,XYZ b){
  int mij1,mij2;

  if(a.x==a.y && b.x==b.y){
    SwapTwo(a.x,b.x);
  }

  mij1=(a.x+a.y)/2;
  mij2=(b.x+b.y)/2;

  if(a.x!=a.y){
    SwapTwo(mij1,mij1+1); ///Dec
    SwapTwo(mij1+1,mij2); ///Con

    if(bef<aft){
      SwapTwo(mij1+1,mij2); ///Dec
      FirstMistake({mij1+1,a.y},b);
      return;
    }
    SwapTwo(mij1+1,mij2);///Dec
    ///--------------------
    SwapTwo(mij1,mij2);

    if(bef<aft){
      SwapTwo(mij1,mij2);
      FirstMistake({a.x,mij1},b);
      return;
    }
    SwapTwo(mij1,mij2);
  }

  if(b.x!=b.y){
    SwapTwo(mij2,mij2+1);
    SwapTwo(mij1,mij2+1);

    if(bef<aft){
      SwapTwo(mij1,mij2+1);
      FirstMistake(a,{mij2+1,b.y});
      return;
    }
    SwapTwo(mij1,mij2+1);
    ///--------------------
    SwapTwo(mij1,mij2);

    if(bef<aft){
      SwapTwo(mij1,mij2);
      FirstMistake(a,{b.x,mij2});
      return;
    }
    SwapTwo(mij1,mij2);
  }
}

void Connect(int x,int y,int poz){
  int mij;

  if(x==y){
    aint[poz]=0;
    return;
  }

  mij=(x+y)/2;

  Connect(x,mij,poz);
  Connect(mij+1,y,poz);

  SwapTwo(mij,mij+1);

  if(bef<aft){ ///BAGAM WHILE
    aint[poz]=0;
    FirstMistake({x,mij},{mij+1,y});
  }else{
    aint[poz]=1;
  }
}

void Dissconnect(int x,int y,int poz){
  int mij;

  if(x==y){
    return;
  }

  mij=(x+y)/2;

  if(aint[poz]==1){
    SwapTwo(mij,mij+1);
    aint[poz]=0;
  }

  Dissconnect(x,mij,poz);
  Dissconnect(mij+1,y,poz);
}

void sortPermutation(int n){
  bef=performSwap(0,1);
  aft=performSwap(0,1);

  Connect(0,n-1,1);

  Dissconnect(0,n-1,1);
}
