#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include "soft_drinks.h"

using ld = double;

int n;
std::vector<int> a, b;
int minA = 0;

void init(const std::vector<int>& A, const std::vector<int>& B) {
  a = A;
  b = B;
  n = (int) a.size();
}

ld friendDrink(int mA, int mB, int lA, int rA) {
  int cnt = 0;
  cnt += (lA <= a[0] && a[0] <= rA);
  cnt += (lA <= a[1] && a[1] <= rA);
  if (cnt == 0) {
    return 0;
  } 
  if (cnt == 1) {
    if (lA <= a[0] && a[0] <= rA) {
      return std::min((ld) mA / a[0], (ld) mB / b[0]);
    } else {
      return std::min((ld) mA / a[1], (ld) mB / b[1]);
    }
  }
  auto f = [&](ld x) {
    return (ld) x + std::min((ld) (mA - (ld) x * a[0]) / a[1], (ld) (mB - (ld) x * b[0]) / b[1]);
  };
  ld l = 0, r = std::min((ld) mA / a[0], (ld) mB / b[0]);
  for (int steps = 0; steps < 200; steps++) {
    ld mid1 = l + (r - l) / 3;
    ld mid2 = r - (r - l) / 3;
    if (f(mid1) > f(mid2)) {
      r = mid2;
    } else {
      l = mid1;
    }
  }
  return f(r);
}