#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <random>
#include "cycles.h"

using ll = long long;
std::mt19937 rng(123);

int cycles;

// int get() {
//   performSwap(0, 1);
//   int aux = performSwap(0, 1);
//   return aux;
// }

void solve(std::vector<int> cycle) {
  assert(!cycle.empty());
  
  if ((int) cycle.size() == 1) {
    return;
  }
  if ((int) cycle.size() == 2) {
    performSwap(cycle[0], cycle[1]);
    cycles++;
    return;
  }
  std::shuffle(cycle.begin(), cycle.end(), rng);
  int sz = (int) cycle.size();
  int i = cycle[0], j = cycle[1];
  std::vector<int> c1, c2;
  performSwap(i, j);
  c1.push_back(i);
  c2.push_back(j);

  for (int u : cycle) {
    if (u == i || u == j) {
      continue;
    } 
    if (performSwap(u, i) == cycles) { // u e in 2
      c2.push_back(u);
      performSwap(u, i);
    } else {
      c1.push_back(u);
      performSwap(u, i);
    }
  }

  // std::cout << " ? " << (int) c1.size() << '\n';
  cycles++;
  solve(c1);
  solve(c2);
}

void sortPermutation(int n) {
  cycles = performSwap(0, 1);
  for (int i = 1; i < n; i++) {
    if (performSwap(0, i) == cycles + 1) { // le am despartit
      performSwap(0, i);
    } else {
      cycles--;
    }
  }
  std::vector<int> cycle(n);
  for (int i = 0; i < n; i++) {
    cycle[i] = i;
  }

  cycles = 1;
  solve(cycle);
}