#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>

using ll = long long;
#define int ll
const int NMAX = 200;
const int INF = 1e18;
#define debug(x) #x << " = " << x << '\n'

std::vector<std::pair<int, int>> g[NMAX + 1];
int dp[NMAX + 1][NMAX + 1];
int dp2[NMAX + 1][NMAX + 1];
int wUp[NMAX + 1];

void dfs0(int u, int p = 0) {
  if (p) {
    int ptr = 0;
    while (g[u][ptr].first != p) {
      ptr++;
    }
    g[u].erase(g[u].begin() + ptr);
  }

  for (const auto &[v, w] : g[u]) {
    wUp[v] = w;
    dfs0(v, u);
  }
}

void dfs(int u, int mid) {
  for (const auto &[v, w] : g[u]) {
    dfs(v, mid);
  }
  for (int d = 0; d <= NMAX; d++) {
    if (d > mid) {
      dp[u][d] = dp2[u][d] = INF;
      continue;
    }
    if (d > mid - d) {
      ll sum = 0; 
      int mini = INF;
      for (const auto &[v, w] : g[u]) {
        sum += dp2[v][mid - d];
        if (dp2[v][d] != INF && dp2[v][mid - d] != INF) {
          mini = std::min(mini, dp2[v][d] - dp2[v][mid - d]);
        }
      }
      if (g[u].empty()) {
        mini = 0;
      }
      dp[u][d] = std::min((ll) INF, sum + mini);
    } else {
      // toate sa fie <= d
      dp[u][d] = 0;
      for (const auto &[v, w] : g[u]) {
        dp[u][d] += dp2[v][d];
      }
    }
  }

  for (int i = 0; i <= NMAX; i++) {
    dp2[u][i] = INF;
  }
  for (int d = 0; d <= mid ; d++) {
    for (int t = 0; t <= NMAX; t++) {
      int his = d + wUp[u] - t;
      if (0 <= his && his <= mid) {
        dp2[u][his] = std::min(dp2[u][his], dp[u][d] + t);
      }
   }
  }
  // for (int i = 0; i < NMAX; i++) {
    // if (dp[u][i] < dp[u][i + 1]) {
    //   std::cout << debug(u) << debug(i);
    //   std::cout << debug(mid);
    //   std::cout << debug(dp[u][i]);
    //   std::cout << debug(dp[u][i + 1]);
  //   }
  // }
  for (int i = NMAX - 1; i >= 0; i--) {
    // dp[u][i] = std::min(dp[u][i + 1], dp[u][i]);
    // dp2[u][i] = std::min(dp2[u][i + 1], dp2[u][i]);
  }
}

signed main() {
  #ifdef LOCAL
freopen("input.txt", "r", stdin);
  #endif
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(0);

  int n, K;
  std::cin >> n >> K;

  for (int i = 1; i < n; i++) {
    int u, v, w;
    std::cin >> u >> v >> w;
    g[u].push_back({v, w});
    g[v].push_back({u, w});
  }

  dfs0(1);

  auto check = [&](int mid) {
    dfs(1, mid);
    return dp[1][mid] <= K;
  };
  
  int l = 0, r = NMAX;
  while (l < r) {
    int mid = (l + r) / 2;
    if (check(mid)) {
      r = mid;
    } else {
      l = mid + 1;
    }
  }

  std::cout << r;

  return 0;
}