#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <set>

using ll = long long;
#define int ll

const int NMAX = 2e5;
const int INF = 1e9 + 100;
#define debug(x) #x << " = " << x << '\n'

std::vector<std::pair<int, int>> g[NMAX + 1];
int wUp[NMAX + 1];
int depth[NMAX + 1];
int deepest[NMAX + 1];
int diam_down[NMAX + 1];
int diam_up[NMAX + 1];

void dfs0(int u, int p = 0) {
  if (p) {
    int ptr = 0;
    while (g[u][ptr].first != p) {
      ptr++;
    }
    g[u].erase(g[u].begin() + ptr);
  }

  for (const auto &[v, w] : g[u]) {
    wUp[v] = w;
    dfs0(v, u);
  }
}

int diam = 0;

void dfs(int u) {
  deepest[u] = depth[u];
  diam_down[u] = 0;
  int max1 = -1, max2 = -1;
  for (const auto &[v, w] : g[u]) {
    depth[v] = depth[u] + w;
    dfs(v);   
    diam_down[u] = std::max(diam_down[u], diam_down[v]);
    if (deepest[v] >= max1) {
      max2 = max1;
      max1 = deepest[v];
    } else if (deepest[v] > max2) {
      max2 = deepest[v];
    }
  }
  if (max1 >= 0) {
    diam_down[u] = std::max(diam_down[u], max1 - depth[u]);
  }
  if (max2 >= 0) {
    diam_down[u] = std::max(diam_down[u], max1 + max2 - 2 * depth[u]);
  }
  deepest[u] = std::max(deepest[u], max1);
}

std::multiset<int> st;

// diam_up[u] =def= daca elimin tot subarborele lui u (inclusiv u) atunci care e diametrul?

void dfs2(int u) {
  std::multiset<int> st2;
  st.insert(-depth[u]);
  for (const auto &[v, w] : g[u]) {
    st.insert(deepest[v] - 2 * depth[u]);
    st2.insert(diam_down[v]);
  }
  for (const auto &[v, w] : g[u]) {
    st2.erase(st2.find(diam_down[v]));
    if (!st2.empty()) {
      diam_up[v] = std::max(diam_up[v], *st2.rbegin());
    }
    if ((int) st2.size() >= 2) {
      int x = *st2.rbegin();
      st2.erase(st2.find(x));
      int y = *st2.rbegin();
      st2.insert(x);
      diam_up[v] = std::max(diam_up[v], x + y);
    }
    st2.insert(diam_down[v]);
  }
  st2.clear();
  for (const auto &[v, w] : g[u]) {
    for (const auto &[vv, ww] : g[u]) {
      if (v != vv) {
        diam_up[v] = std::max(diam_up[v], deepest[vv] + *st.rbegin());
      }
    }
  }
  for (const auto &[v, w] : g[u]) {
    // combin pe u cu altcineva
    st.erase(st.find(deepest[v] - 2 * depth[u]));
    diam_up[v] = std::max(diam_up[v], depth[u] + *st.rbegin());
    diam_up[v] = std::max(diam_up[v], diam_up[u]);
    dfs2(v);
    st.insert(deepest[v] - 2 * depth[u]);
  }
  for (const auto &[v, w] : g[u]) {
    st.erase(st.find(deepest[v] - 2 * depth[u]));
  }
  st.erase(st.find(-depth[u]));
  // st.insert(-depth[u]);
  // for (const auto &[v, w] : g[u]) {
  //   st.insert(deepest[v] - 2 * depth[u]);
  // }
  // for (const auto &[v, w] : g[u]) {
  //   diam_up[v] = std::max(diam_up[v], diam_up[u]);
  //   diam_up[v] = std::max(diam_up[v], );
  //   st.erase(st.find(deepest[v] - 2 * depth[u]));
  //   dfs2(v);
  //   st.insert(deepest[v] - 2 * depth[u]);
  // }
  // for (const auto &[v, w] : g[u]) {
  //   st.erase(st.find(deepest[v] - 2 * depth[u]));
  // }
  // st.erase(st.find(-depth[u]));
}

int answer = 2e9 + 100;
int K;

void dfs3(int u) {
  st.insert(-depth[u]);
  for (const auto &[v, w] : g[u]) {
    st.insert(deepest[v] - 2 * depth[u]);
  }
  for (const auto &[v, w] : g[u]) {
    int me = std::max(std::max(diam_up[v], diam_down[v]), deepest[v] + *st.rbegin() - K);
    answer = std::min(answer, me);
    st.erase(st.find(deepest[v] - 2 * depth[u]));
    dfs3(v);
    st.insert(deepest[v] - 2 * depth[u]);
  }
  for (const auto &[v, w] : g[u]) {
    st.erase(st.find(deepest[v] - 2 * depth[u]));
  }
  st.erase(st.find(-depth[u]));
}

signed main() {
  #ifdef LOCAL
freopen("input.txt", "r", stdin);
  #endif
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(0);

  int n;
  std::cin >> n >> K;

  for (int i = 1; i < n; i++) {
    int u, v, w;
    std::cin >> u >> v >> w;
    g[u].push_back({v, w});
    g[v].push_back({u, w});
  }

  dfs0(1);
  dfs(1);
  dfs2(1);
  dfs3(1);
  
  std::cout << answer;
  
  return 0;
}