#include <bits/stdc++.h>

using namespace std;

const int NMAX = 1e5;

int a[NMAX];
int b[NMAX];
int n;

void init(const std::vector<int>& A, const std::vector<int>& B) {
    n = A.size();
    for ( int i = 0; i < n; i ++ ) {
        a[i] = A[i];
        b[i] = B[i];
    }
}

double minDrink( int i, int Ma, int Mb ) {
    if ( b[i] == 0 ) return (double)Ma / a[i];
    if ( a[i] == 0 ) return (double)Mb / b[i];
    return min( (double)Ma / a[i], (double)Mb / b[i] );
}
bool isBetter( int i, int j ) {
    return a[i] >= a[j] && b[i] >= b[j];
}
double min2Drink( int i, int j, double Ma, double Mb ) {
    if ( i == j ) return minDrink( i, Ma, Mb );
    if ( isBetter( i, j ) || isBetter( j, i ) ) return 0;
    double t = (double)( Mb * a[j] - Ma * b[j] ) / ( Ma * ( b[i] - b[j] ) - Mb * ( a[i] - a[j] ) );

    if ( 0 <= t && t <= 1 ) {
        //assert( abs( (double)Ma / ( a[j] + t * ( a[i] - a[j] ) ) - (double)Mb / ( b[j] + t * ( b[i] - b[j] ) ) ) < 0.00001 );
        return (double)Ma / ( a[j] + t * ( a[i] - a[j] ) );
    }
    return max( minDrink( i, Ma, Mb ), minDrink( j, Ma, Mb ) );
}
double friendDrink(const int Ma, const int Mb, const int La, const int Ra) {
    double ans = 0;
    for ( int i = 0; i < n; i ++ ) {
        if ( La <= a[i] && a[i] <= Ra ) {
            for ( int j = i; j < n; j ++ ) {
                if ( La <= a[j] && a[j] <= Ra ) {
                    ans = max( ans, min2Drink( i, j, Ma, Mb ) );
                }
            }
        }
    }
    return ans;
}
/*
2 1
1 3
2 2
2 2 1 3

4 3
4 0
2 8
6 4
3 6
8 2 4 6
8 2 3 6
0 10 0 10
*/
