#include <bits/stdc++.h>

using namespace std;

const int NMAX = 2e5;

vector <pair<int, int>> edges[NMAX + 1];
int depth[NMAX + 1];
bool isDiameter[NMAX + 1];
pair <int, int> nxt[NMAX + 1];

int n;

void dfs( int node, int p = 0, int d = 0 ) {
    depth[node] = d;
    for ( auto e : edges[node] ) {
        if ( e.first != p ) {
            dfs( e.first, node, d + e.second );
        }
    }
}

void fillDiameter( int node ) {
    while ( depth[node] ) {
        isDiameter[node] = true;
        for ( auto e : edges[node] ) {
            if ( depth[e.first] < depth[node] ) {
                nxt[node] = e;
            }
        }
        node = nxt[node].first;
    }
    isDiameter[node] = true;
}
int maxDepthNode() {
    int maxD = 1;
    for ( int i = 1; i <= n; i ++ ) {
        if ( depth[maxD] < depth[i] ) maxD = i;
    }
    return maxD;
}
int calcDiameter() {
    dfs( 1 );
    dfs( maxDepthNode() );
    int d = maxDepthNode();
    fillDiameter( d );
    return depth[d];
}

void decrease( int a, int b ) {
//    cout << a << ' ' << b << endl;
    for ( auto& e : edges[a] ) {
        if ( e.first == b ) e.second --;
    }
    for ( auto& e : edges[b] ) {
        if ( e.first == a ) e.second --;
    }
}
int main() {
    int k;
    cin >> n >> k;
    for ( int i = 1, a, b, c; i < n; i ++ ) {
        cin >> a >> b >> c;
        edges[a].push_back( {b, c} );
        edges[b].push_back( {a, c} );
    }
    if ( k == 0 ) {
        cout << calcDiameter() << '\n';
    } else {
        while ( k > 0 ) {
            int dist = calcDiameter();
            bool dec = false;
            int center = 0;
//            for ( int i = 1; i <= n; i ++ ) cout << isDiameter[i] << ' ';
//            cout << endl;
//            cout << dist << endl;
            for ( int i = 1; i <= n; i ++ ) {
                if ( isDiameter[i] && depth[i] ) {
                    if ( nxt[i].second > 0 && depth[i] * 2 == dist ) {
                        center = i;
                    }
                }
            }
            if ( center ) {
                decrease( center, nxt[center].first );
                k --;
            } else {

                int a = -1, b = -1, d = maxDepthNode();
//                cout << d << endl;
                while ( depth[d] ) {
                    int d1 = depth[nxt[d].first];
                    int d2 = dist - d1 - nxt[d].second;
//                    cout << d << ": "<< d1 << ' ' << d2 << endl;
                    if ( nxt[d].second > 0 && d2 <= d1 ) {
                        a = d;
                        b = nxt[d].first;
                    }
                    d = nxt[d].first;
                }
                if ( a != -1 ) {
                    decrease( a, b );
                    k --;
                }
            }
//            break;
        }
        cout << calcDiameter() << '\n';
    }
    return 0;
}
/*
5 1
1 2 5
2 3 4
2 4 2
4 5 2
*/
