#include <bits/stdc++.h>

using namespace std;

const int NMAX = 2e5;

vector <pair<int, int>> edges[NMAX + 1];
int depth[NMAX + 1];
bool isDiameter[NMAX + 1];
pair <int, int> nxt[NMAX + 1];

int n;

void dfs( int node, int p = 0, int d = 0 ) {
    depth[node] = d;
    for ( auto e : edges[node] ) {
        if ( e.first != p ) {
            dfs( e.first, node, d + e.second );
        }
    }
}

void fillDiameter( int node, int dest, int p = 0 ) {
    if ( node == dest ) {
        isDiameter[node] = true;
    } else {
        for ( auto e : edges[node] ) {
            if ( e.first == p ) continue;
            fillDiameter( e.first, dest, node );
            if ( isDiameter[e.first] ) {
                nxt[node] = e;
                isDiameter[node] = true;
                break;
            }
        }
    }
}
int maxDepthNode() {
    int maxD = 1;
    for ( int i = 1; i <= n; i ++ ) {
        if ( depth[maxD] < depth[i] ) maxD = i;
    }
    return maxD;
}
int calcDiameter() {
    dfs( 1 );
    int start = maxDepthNode();
    dfs( start );
    int d = maxDepthNode();
    fillDiameter( d, start );
    return depth[d];
}

void decrease( int a, int b ) {
//    cout << a << ' ' << b << endl;
    for ( auto& e : edges[a] ) {
        if ( e.first == b ) e.second --;
    }
    for ( auto& e : edges[b] ) {
        if ( e.first == a ) e.second --;
    }
}
int main() {
    int k, sumW = 0;
    cin >> n >> k;
    for ( int i = 1, a, b, c; i < n; i ++ ) {
        cin >> a >> b >> c;
        sumW += c;
        edges[a].push_back( {b, c} );
        edges[b].push_back( {a, c} );
    }
    k = min( k, sumW );
    if ( k == 0 ) {
        cout << calcDiameter() << '\n';
    } else {
        while ( k > 0 ) {
            for ( int i = 1; i <= n; i ++ ) {
                isDiameter[i] = false;
                nxt[i].second = 0;
                depth[i] = 0;
            }
            int dist = calcDiameter();
            int center = 0;
            for ( int i = 1; i <= n; i ++ ) {
                if ( isDiameter[i] && depth[i] ) {

                    if ( nxt[i].second > 0 && depth[i] * 2 == dist ) {
                        center = i;
                    }
                }
            }
            if ( center ) {
                decrease( center, nxt[center].first );
                k --;
            } else {

                int a = -1, b = -1, d = maxDepthNode();
                while ( depth[d] ) {
                    int d1 = depth[nxt[d].first];
                    int d2 = dist - d1 - nxt[d].second;
                    if ( nxt[d].second > 0 && d2 <= d1 ) {
                        a = d;
                        b = nxt[d].first;
                    }
                    d = nxt[d].first;
                }
                if ( a != -1 ) {
                    decrease( a, b );
                    k --;
                }
            }
        }
        cout << calcDiameter() << '\n';
    }
    return 0;
}
/*

5 60
1 2 5
2 3 4
2 4 3
4 5 2

5 6
1 2 2
2 3 2
2 4 0
4 5 2

5 100
1 2 2
2 3 2
2 4 0
4 5 2
*/
