#include <iostream>
#include <vector>
#include <climits>
using namespace std;

#define MAXN 200000

struct edge{
  int u,v,w;
}edges[MAXN-1];
vector<int> adj[MAXN+1];
int depth[MAXN+1],parent[MAXN+1];
vector<vector<short>> cost;

void dfs(int node,int par,int level){
  parent[node]=par;
  depth[node]=level;
  for(auto vec:adj[node]){
    if(vec!=par){
      dfs(vec,node,level+1);
    }
  }
}

pair<int,int> diameter(int n){
  int lung,maxlung=0,maxsize=0,edgesize;

  for(int u=1;u<=n;u++){
    for(int v=u+1;v<=n;v++){
      int n1=u,n2=v;
      if(depth[n1]<depth[n2]){
        swap(n1,n2);
      }

      lung=edgesize=0;
      while(depth[n1]>depth[n2]){
        lung+=cost[n1][parent[n1]];
        edgesize++;
        n1=parent[n1];
      }
      while(n1!=n2){
        lung+=cost[n1][parent[n1]]+cost[n2][parent[n2]];
        edgesize+=2;
        n2=parent[n2];
        n1=parent[n1];
      }
      if(lung>maxlung){
        maxlung=lung;
        maxsize=edgesize;
      }else if(lung==maxlung){
        maxsize=max(maxsize,edgesize);
      }
    }
  }

  return {maxlung,maxsize};
}

int main(){
  int n,k,i,mindiam;

  cin>>n>>k;
  cost.resize(n+1);
  for(i=1;i<=n;i++){
    cost[i].resize(n+1);
  }

  for(i=0;i<n-1;i++){
    cin>>edges[i].u>>edges[i].v>>edges[i].w;
    cost[edges[i].u][edges[i].v]=edges[i].w;
    cost[edges[i].v][edges[i].u]=edges[i].w;
    adj[edges[i].u].push_back(edges[i].v);
    adj[edges[i].v].push_back(edges[i].u);
  }

  dfs(1,0,0);

  if(k==0){
    cout<<diameter(n).first;
  }else{
    if(k>=n){
      cout<<0;
    }else{
      auto x=diameter(n);
      cout<<x.first-min(k,x.second);
    }
  }
}
