#include "soft_drinks.h"

const int nmax = 1e5 + 5;
const int inf = 3e9;

struct ceva{
    int sugar, acid;
}v[nmax];

int n;

int binse(int s)
{
    int st = 1, dr = n, poz;
    while(st <= dr)
    {
        int mij = (st + dr) / 2;
        if(v[mij].sugar >= s)
            poz = mij, dr = mij - 1;
        else
            st = mij + 1;
    }

    return poz;
}

bool cmp(ceva x, ceva y){
    return x.sugar < y.sugar;
}

void init(const std::vector<int>& A, const std::vector<int>& B)
{
    n = A.size();
    for(int i = 0; i < n; i ++) v[i + 1].sugar = A[i];
    for(int i = 0; i < n; i ++) v[i + 1].acid = B[i];

    std::sort(v + 1, v + n + 1, cmp);
}

double friendDrink(int Ma, int Mb, int La, int Ra)
{
    int p = binse(La), p2 = binse(Ra + 1) - 1; double maxi = 0;
    for(int i = p; i <= p2; i ++)
        maxi = std::max(maxi, std::min((double)Ma / v[i].sugar, (double)Mb / v[i].acid));

    return maxi;
}