#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <stack>
#include <queue>
#include <map>
#include <algorithm>
#include <string>
#include <climits>
#include <cassert>
//#include <random>

//#include <bits/stdc++.h>

#include "cycles.h"

using namespace std;

#define DEBUG 1

#if DEBUG
    #define DEBUG_LOG_ONLY if(DEBUG)
    #define DEBUG_PAUSE_SYSTEM system("pause");
    #define DEBUG_CLEAR system("cls");
    #define DEBUG_PRINT_VAR_BOLD(name, var) cout << "log /> " << name << " " << var << "\n";
    #define DEBUG_NEW_LINE cout << "\n";
#endif // DEBUG

/// !O pemutare sortata are n cicluri

int cicluriOrg;

bool PerformEvenSwap(int n) {
    int cicluriCur = cicluriOrg;
    for(int i = 0; i + 1 < n; i += 2) {
        if(performSwap(i, i + 1) <= cicluriCur) {
            performSwap(i, i + 1);
        }
        else cicluriCur++;
    }
    return cicluriCur == n;
}

void PerformOneSwap(int n) {
    for(int i = 0; i < n - 1; i++) {
        if(performSwap(i, i + 1) == n) return;
        else performSwap(i, i + 1);
    }
    for(int i = 0; i < n - 2; i++) {
        if(performSwap(i, i + 2) == n) return;
        else performSwap(i, i + 2);
    }
    
    
    int pozAnt = -1;
    for(int i = 0; i < n - 1; i++) {
        int cic = performSwap(i, i + 1);

        int poz;
        if(cic == cicluriOrg - 2) performSwap(i, i + 1);
        else if(i + 2 < n)  {
            int cic0 = performSwap(i + 1, i + 2);
            if(cic0 == cic - 2 || cic0 == cic) poz = i + 1;
            else                               poz = i;

            performSwap(i + 1, i + 2);
            performSwap(i, i + 1);

            if(pozAnt == -1) poz = pozAnt;
            else {
                performSwap(pozAnt, poz);
                return;
            }
        }
        else {
            int cic0 = performSwap(i - 1, i);
            if(cic0 == cic - 2 || cic0 == cic) poz = i;
            else                               poz = i + 1;

            performSwap(i - 1, i);
            performSwap(i, i + 1);

            if(pozAnt == -1) poz = pozAnt;
            else {
                performSwap(pozAnt, poz);
                return;
            }
        }
    }
}

void sortPermutation(int n) {
    //performSwap(0, 1);
    cicluriOrg = performSwap(0, 1);
    if(cicluriOrg == n) return;

    if(PerformEvenSwap(n)) return;
    PerformOneSwap(n);
}
