#include "soft_drinks.h"

#include <bits/stdc++.h>

using namespace std;

int N;
vector<pair<int, int>> drink;

void init(const vector<int> &_A, const vector<int> &_B) {
    N = _A.size();
    for (int i = 0; i < N; ++i)
        drink.push_back({ _A[i], _B[i] });
    sort(drink.begin(), drink.end(), [](auto p1, auto p2) {
         return atan2(p1.first, p1.second) < atan2(p2.first, p2.second);
    });
}

pair<double, double> solve(double a, double b, double c, double d, double m, double n) {
    double det = a * d - b * c;
    if (det == 0) return { -1, -1 };
    return { (m * d - n * b) / det, (a * n - m * c) / det };
}

double friendDrink(const int Ma, const int Mb, const int La, const int Ra) {
    pair<int, int> p1, p2;
    for (int i = 0; i < N; ++i)
        if (drink[i].first >= La && drink[i].second <= Ra) {
            p1 = drink[i];
            break;
        }
    for (int i = N - 1; i >= 0; --i)
        if (drink[i].first >= La && drink[i].second <= Ra) {
            p2 = drink[i];
            break;
        }
    auto[x, y] = solve(p1.first, p2.first, p1.second, p2.second, Ma, Mb);
    if (x == -1) return min((double)Ma / max(p1.first, p2.first), (double)Mb / max(p1.second, p2.second));
    return x + y;
}
