#include <iostream>
#include <queue>
#include <vector>
#include <random>
#include <ctime>
#include "cycles.h"

std::mt19937 mt(time(0));

void sortPermutation(int n) {
    int nr_cicluri = performSwap(0, 1);

    for (int i = 1; i < n; i++) {
        int new_cycles = performSwap(i, 0);

        if (new_cycles > nr_cicluri) {
            //revert
            performSwap(i, 0);
        } else {
            nr_cicluri = new_cycles;
        }
    }

    //am adus toata permutarea la un singur ciclu

    std::queue<std::vector<int>> q;

    std::vector<int> tot;
    for (int i = 0; i < n; i++)
        tot.push_back(i);
    q.push(tot);

    while (!q.empty()) {
        std::vector<int> v = q.front();
        q.pop();

        if (v.size() == 1) continue;

        if (v.size() == 2) {
            performSwap(v[0], v[1]);
            nr_cicluri++;
            continue;
        }

        int sz = v.size();
        int id1 = 0, id2 = 0;

        while (true) {
            id1 = mt() % sz;
            id2 = mt() % sz;
            if (id1 != id2)
                break;
        }

        //std::cout << id1 << ' ' << id2 << '\n';
        //std::cout << v[id1] << ' ' << v[id2] << '\n';

        performSwap(v[id1], v[id2]);
        nr_cicluri++;

        std::vector<int> perm1, perm2;
        perm1.push_back(v[id1]);
        perm2.push_back(v[id2]);

        for (int x : v) {
            if (x == v[id1] || x == v[id2]) continue;

            int new_cycles = performSwap(x, v[id1]);
            performSwap(x, v[id1]);
            if (new_cycles > nr_cicluri) {
                perm1.push_back(x);
            } else {
                perm2.push_back(x);
            }
        }

        q.push(perm1);
        q.push(perm2);
    }
}

