#include <iostream>
#include <vector>
#include <queue>

using ll = long long;

const int MAX_N = 2e5 + 5;
const int INF = 2e9 + 5;

int n, k;

std::vector<std::pair<int, int>> g[MAX_N + 1];
int dist[MAX_N + 1];
bool vis[MAX_N + 1];

std::pair<int, int> get_farthest_node(int node) {
    for (int i = 1; i <= n; i++) {
        dist[i] = INF;
        vis[i] = false;
    }
    dist[node] = 0;

    std::priority_queue<std::pair<int, int>, std::vector<std::pair<int, int>>, std::greater<std::pair<int, int>>> pq;

    pq.push(std::make_pair(0, node));

    while (!pq.empty()) {
        int node = pq.top().second;
        pq.pop();

        if (vis[node]) continue;
        vis[node] = true;

        for (auto it : g[node])
            if (dist[node] + it.second < dist[it.first]) {
                dist[it.first] = dist[node] + it.second;
                pq.push(std::make_pair(dist[it.first], it.first));
            }
    }

    int mx = 0, to = node;
    for (int i = 1; i <= n; i++) {
        if (dist[i] > mx) {
            mx = dist[i];
            to = i;
        }
    }

    return std::make_pair(to, mx);
}

void solve() {
    auto p1 = get_farthest_node(1);
    auto p2 = get_farthest_node(p1.first);

    std::cout << p2.second << '\n';
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cin >> n >> k;
    for (int i = 1; i < n; i++) {
        int u, v, w;
        std::cin >> u >> v >> w;
        g[u].push_back(std::make_pair(v, w));
        g[v].push_back(std::make_pair(u, w));
    }
    solve();
    return 0;
}
