#include "bits/stdc++.h"
#include "soft_drinks.h"

using namespace std;

#define for0(i, n) for (ll i = 0; i < n; ++i)
#define pb push_back
#define con continue
#define ret return
#define be(x) x.begin()

typedef long long ll;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef long double ld;


struct ST {
    ll n;
    vll t;

    ST() {}

    ST(ll n) : n(n), t(4 * n, 1e18) {}

    void update(ll p, ll x) {
        update(1, 0, n, p, x);
    }

    void update(ll v, ll l, ll r, ll p, ll x) {
        if (l > p || r <= p) ret;
        if (l + 1 == r) {
            t[v] = min(t[v], x);
            ret;
        }
        ll m = (l + r) / 2;
        update(v * 2, l, m, p, x);
        update(v * 2 + 1, m, r, p, x);
        t[v] = min(t[v * 2], t[v * 2 + 1]);
    }

    ll get(ll l, ll r) {
        ret get(1, 0, n, l, r);
    }

    ll get(ll v, ll l, ll r, ll L, ll R) {
        if (l >= R || r <= L) ret 1e18;
        if (l >= L && r <= R) ret t[v];
        ll m = (l + r) / 2;
        ret min(get(v * 2, l, m, L, R), get(v * 2 + 1, m, r, L, R));
    }
};

const long double eps = 1e-9;

int n;
vector<pair<ll, ll>> v;
ld ans = 0;
ST t1, t2, t3;

void init(const std::vector<int> &A, const std::vector<int> &B) {
    n = A.size();
    t1 = t2 = t3 = ST(n);
    for0(i, n) v.pb({A[i], B[i]});
    sort(v.begin(), v.end());
    for0(i, n) {
        ll j = lower_bound(v.begin(), v.end(), make_pair((ll) v[i].first, 0ll)) - v.begin();
        if (v[i].first == v[i].second) {
            t1.update(j, v[i].first + v[i].second);
        } else if (v[i].first < v[i].second) {
            t2.update(j, v[i].first + v[i].second);
        } else {
            t3.update(j, v[i].first + v[i].second);
        }
    }
}

bool check(long double m, vector<long double> a1, vector<long double> b1, long double ma, long double mb) {
    if (a1.size() == 0) ret 0;
    if (a1.size() == 1) ret (a1[0] * m <= ma && b1[0] * m <= mb);
    if (a1[0] > a1[1]) swap(a1[0], a1[1]), swap(b1[0], b1[1]);
    if (b1[0] <= b1[1]) ret (a1[0] * m <= ma && b1[0] * m <= mb);
    if (a1[0] * m > ma || b1[1] * m > mb) ret 0;
    long double ost = ma - a1[0] * m;
    long double m2 = min(m, ost / (a1[1] - a1[0])), m1 = m - m2;
    ret (a1[0] * m1 + a1[1] * m2 <= ma && b1[0] * m1 + b1[1] * m2 <= mb);
}

double friendDrink(const int Ma, const int Mb, const int La, const int Ra) {
    ll jl = lower_bound(v.begin(), v.end(), make_pair((ll) La, 0ll)) - v.begin();
    ll jr = lower_bound(v.begin(), v.end(), make_pair((ll) Ra, (ll) 1e9 + 5)) - v.begin();
    if (jl >= jr) ret 0;
    double rt = min(t1.get(jl, jr) / 2., (t2.get(jl, jr) + t3.get(jl, jr)) / 4.);
    ret (double) Ma / rt;
//    cout.precision(9);
//    cout << fixed;
//    vector<long double> a1, b1;
//    for (int i = 0; i < n; i++) {
//        if (a[i] >= La && a[i] <= Ra) a1.push_back(a[i]), b1.push_back(b[i]);
//    }
//    long double l = 0, r = 2e9 + 5;
//    while (r - l > eps) {
//        long double m = (r + l) / 2;
//        if (check(m, a1, b1, Ma, Mb)) {
//            l = m;
//        } else {
//            r = m;
//        }
//    }
//    ret l;
}