#include "soft_drinks.h"
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using db = double;

constexpr db infdb = 3e18;
constexpr db eps = 1e-9;

#define A first
#define B second

db eval(pair<ll, ll> a, pair<ll, ll> b) {
    db ma = a.A == 0 ? infdb : b.A / db(a.A);
    db mb = a.B == 0 ? infdb : b.B / db(a.B);
    return min(ma, mb);
}

pair<ll, ll> operator-(const pair<ll, ll> &a, const pair<ll, ll> &b) {
    return {a.first - b.first, a.second - b.second};
}

ll crs(const pair<ll, ll> &a, const pair<ll, ll> &b) {
    return a.A * b.B - a.B * b.A;
}

int frac(const pair<ll, ll> &a, const pair<ll, ll> &b) { // -1 => a < b : 0 => tie 1 => a > b
    auto fa = a.B * b.A;
    auto fb = a.A * b.B;
    return fa < fb ? -1 : fa == fb ? 0 : 1;
}



db qry(const pair<ll, ll> &u, const pair<ll, ll> &v, db d) {
    db k = db(v.B - u.B) / (v.A - u.A);
    if (abs(k - d) < eps) {
        return u.first;
    }
    db x = db(u.B - d * u.A) / db(d - k);
    return x + u.first;
}

struct Struct {
    vector<pair<ll, ll>> a;
    vector<int> ord, stk;
    int n;

    void clear() {
        a.clear();
    }

    void add(int x, int y) {
        a.push_back({x, y});
    }

    void build() {
        n = a.size();
        ord.assign(n, 0);
        std::iota(ord.begin(), ord.end(), 0);
        sort(ord.begin(), ord.end(), [&](int i, int j) {
            return a[i] < a[j];
        });
        stk.clear();
        for (int i : ord) {
            if (!stk.empty() && a[stk.back()].B <= a[i].B) {
                continue;
            }
            stk.push_back(i);
        }
        ord = stk;
        stk.clear();
        sort(ord.begin(), ord.end(), [&](int i, int j) {
            return frac(a[i], a[j]) > 0;
        });
        for (int i : ord) {
            while (stk.size() > 1 && crs(a[stk.back()] - a[stk.end()[-2]], a[i] - a[stk.end()[-2]]) >= 0) {
                stk.pop_back();
            }
            stk.push_back(i);
        }
    }

    db query(ll Ma, ll Mb) {
        db res = 0;
        for (int i : ord) {
            res = max(res, eval(a[i], pair(Ma, Mb)));
        }
//        cerr << res << endl;
        if (Ma == 0) {
            // find minB
            return res;
        }
//        for (auto i : stk) {
//            cout << a[i].A << "," << a[i].B << endl;
//        }
//        for (auto i : ord) {
//            cout << a[i].A << "," << a[i].B << endl;
//        }
        pair<ll, ll> m(Ma, Mb);
        for (int i = 0; i < ord.size(); ++i) {
            for (int j = i + 1; j < ord.size(); ++j) {
                auto u = a[ord[i]];
                auto v = a[ord[j]];
                if (u.first > v.first) {
                    swap(u, v);
                }
//                cout << "relax: " << u.A << "," << u.B << " " << v.A << "," << v.B << endl;
                db x = qry(u, v, db(m.second) / m.first);
                res = max(res, db(m.first) / x);
            }
        }
        return res;
        for (int i = 0; i < stk.size(); ++i) {
            int x = stk[i];
            if (frac(a[x], m) <= 0) {
//                cerr << "here!" << endl;
                if (i > 0) {
                    auto u = a[stk[i - 1]];
                    auto v = a[x];
                    db x = qry(u, v, db(m.second) / m.first);
                    res = max(res, db(m.first) / x);
//                    cerr << "here!" << endl;
                }
                break;
            }
        }
        return res;
    }
} full;

vector<pair<int, int>> ax;

void init(const std::vector<int>& A, const std::vector<int>& B) {
    full.clear();
    ax.assign(A.size(), {});
    for (int i = 0; i < A.size(); ++i) {
        full.add(A[i], B[i]);
        ax[i] = pair(A[i], B[i]);
    }
    full.build();
}

double friendDrink(const int Ma, const int Mb, const int La, const int Ra) {
    if (La == 0 && Ra == int(1e9)) {
        return full.query(Ma, Mb);
    } else {
        Struct now{};
        for (int i = 0; i < ax.size(); ++i) {
            if (ax[i].A >= La && ax[i].A <= Ra) {
                now.add(ax[i].A, ax[i].B);
            }
        }
        now.build();
        return now.query(Ma, Mb);
    }
}
