#include "soft_drinks.h"
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using db = double;

constexpr db infdb = 3e18;
constexpr db eps = 1e-9;

#define A first
#define B second

db eval(pair<ll, ll> a, pair<ll, ll> b) {
    db ma = a.A == 0 ? infdb : b.A / db(a.A);
    db mb = a.B == 0 ? infdb : b.B / db(a.B);
    return min(ma, mb);
}

pair<ll, ll> operator-(const pair<ll, ll> &a, const pair<ll, ll> &b) {
    return {a.first - b.first, a.second - b.second};
}

ll crs(const pair<ll, ll> &a, const pair<ll, ll> &b) {
    return a.A * b.B - a.B * b.A;
}

int frac(const pair<ll, ll> &a, const pair<ll, ll> &b) { // -1 => a < b : 0 => tie 1 => a > b
    auto fa = a.B * b.A;
    auto fb = a.A * b.B;
    return fa < fb ? -1 : fa == fb ? 0 : 1;
}



db qry(const pair<ll, ll> &u, const pair<ll, ll> &v, db d) {
    db k = db(v.B - u.B) / (v.A - u.A);
    if (abs(k - d) < eps) {
        return u.first;
    }
    db x = db(u.B - d * u.A) / db(d - k);
    return x + u.first;
}

struct Struct {
    vector<pair<ll, ll>> a;
    vector<int> ord_id, stk_id;
    vector<pair<ll, ll>> ord, stk;
    vector<ll> pref, suf;
    int n;

    void clear() {
        a.clear();
    }

    void add(int x, int y) {
        a.push_back({x, y});
    }

    void build() {
        n = a.size();
        ord_id.assign(n, 0);
        std::iota(ord_id.begin(), ord_id.end(), 0);
        sort(ord_id.begin(), ord_id.end(), [&](int i, int j) {
            return a[i] < a[j];
        });
        stk_id.clear();
        for (int i : ord_id) {
            if (!stk_id.empty() && a[stk_id.back()].B <= a[i].B) {
                continue;
            }
            stk_id.push_back(i);
        }
        ord_id = stk_id;
        stk_id.clear();
        sort(ord_id.begin(), ord_id.end(), [&](int i, int j) {
            return frac(a[i], a[j]) > 0;
        });
        for (int i : ord_id) {
            while (stk_id.size() > 1 && crs(a[stk_id.back()] - a[stk_id.end()[-2]], a[i] - a[stk_id.end()[-2]]) <= 0) {
                stk_id.pop_back();
            }
            stk_id.push_back(i);
        }
        ord.clear(), stk.clear();
        for (int i : ord_id) {
            ord.push_back(a[i]);
        }
        for (int i : stk_id) {
            stk.push_back(a[i]);
        }
        pref.assign(ord.size(), 3e18);
        suf.assign(ord.size(), 3e18);
        for (int i = 0; i < ord.size(); ++i) {
            pref[i] = ord[i].B;
            if (i > 0) {
                pref[i] = min(pref[i], pref[i - 1]);
            }
        }
        for (int i = int(ord.size()) - 1; i >= 0; --i) {
            suf[i] = ord[i].A;
            if (i + 1 < ord.size()) {
                suf[i] = min(suf[i], suf[i + 1]);
            }
        }
    }

    db query(ll Ma, ll Mb) {
        if (ord.empty()) {
            return 0;
        }
//        if (Ma == 0) {
//            // find minB
//            return Mb / db(pref.back());
//        }
        db res = 0;
        int lo = -1, hi = ord.size();
        pair<ll, ll> m(Ma, Mb);
        while (lo + 1 < hi) {
            int mid = lo + hi >> 1;
            if (frac(ord[mid], m) > 0) {
                lo = mid;
            } else {
                hi = mid;
            }
        }
        if (lo >= 0) {
            res = max(res, Mb / db(pref[lo]));
        }
        if (hi < ord.size()) {
            res = max(res, Ma / db(suf[hi]));
        }
//        for (int i : ord_id) {
//            res = max(res, eval(a[i], pair(Ma, Mb)));
//        }
//        cerr << res << endl;
//        for (auto i : stk_id) {
//            cout << a[i].A << "," << a[i].B << endl;
//        }
//        for (auto i : ord_id) {
//            cout << a[i].A << "," << a[i].B << endl;
//        }
        lo = -1, hi = stk.size();
        while (lo + 1 < hi) {
            int mid = lo + hi >> 1;
            if (frac(stk[mid], m) <= 0) {
                hi = mid;
            } else {
                lo = mid;
            }
        }
        if (hi > 0 && hi < stk.size()) {
            auto u = stk[hi];
            auto v = stk[hi - 1];
            db x = qry(u, v, db(m.second) / m.first);
            res = max(res, db(m.first) / x);
        }
//        for (int i = 0; i < stk_id.size(); ++i) {
//            int x = stk_id[i];
//            if (frac(a[x], m) <= 0) {
////                cerr << "here!" << endl;
//                if (i > 0) {
//                    auto u = a[stk_id[i - 1]];
//                    auto v = a[x];
//                    db x = qry(u, v, db(m.second) / m.first);
//                    res = max(res, db(m.first) / x);
////                    cerr << "here!" << endl;
//                }
//                break;
//            }
//        }
        return res;
    }
} full;

vector<pair<int, int>> ax;

void init(const std::vector<int>& A, const std::vector<int>& B) {
    full.clear();
    ax.assign(A.size(), {});
    for (int i = 0; i < A.size(); ++i) {
        full.add(A[i], B[i]);
        ax[i] = pair(A[i], B[i]);
    }
    full.build();
}

double friendDrink(const int Ma, const int Mb, const int La, const int Ra) {
    if (La == 0 && Ra == int(1e9)) {
        return full.query(Ma, Mb);
    } else {
        Struct now{};
        for (int i = 0; i < ax.size(); ++i) {
            if (ax[i].A >= La && ax[i].A <= Ra) {
                now.add(ax[i].A, ax[i].B);
            }
        }
        now.build();
        return now.query(Ma, Mb);
    }
}
