#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    auto solve = [&](vector<int> &a_, int L) -> pair<int, int> { // {mx, sum}
        // a[i] -= 1 so that a[i] + a[j] <= L for each (i, j) && max(a[i]) -> min
        if (a_.size() == 1) {
            int x = a_[0];
            if (x > L) {
                return {L, x - L};
            } else {
                return {x, 0};
            }
        }
        pair<int, int> mx{0, 0};
        for (auto x : a_) {
            if (mx.first < x) {
                mx.second = mx.first;
                mx.first = x;
            } else {
                mx.second = max(mx.second, x);
            }
        }
        auto [A0, A1] = mx;
        if (A0 + A1 <= L) {
            return {A0, 0};
        }
        if (A1 + A1 <= L) {
            return {L - A1, A0 + A1 - L};
        }
        int a0 = (L + 1) / 2;
        int a1 = L / 2;
        int sum = A0 - a0;
        for (int i = 0; i < a_.size(); ++i) {
            if (a_[i] == A0) {
                A0 = -1;
                continue;
            }
            sum += max(0, a_[i] - a1);
        }
        return {a0, sum};
    };

    int N, K;
    cin >> N >> K;
    vector<vector<array<int, 2>>> adj(N);
    for (int i = 1; i < N; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        --a, --b;
        adj[a].push_back({b, w});
        adj[b].push_back({a, w});
    }

    auto check = [&](int mid) {
        int did = 0;
        auto dfs = [&](auto self, int v, int fa) -> int {
            vector<int> a{0};
            for (auto [to, w] : adj[v]) {
                if (to == fa) {
                    continue;
                }
                a.push_back(self(self, to, v) + w);
                if (did > K) {
                    return 0;
                }
            }
            auto [mx, sum] = solve(a, mid);
            did += sum;
            if (did > K) {
                return 0;
            }
            return mx;
        };
        int res = dfs(dfs, 0, -1);
        did += max(0, res - mid);
        return did <= K;
    };

    int lo = -1, hi = 2e9 + 7;
    while (lo + 1 < hi) {
        int mid = lo + (hi - lo) / 2;
        if (check(mid)) {
            hi = mid;
        } else {
            lo = mid;
        }
    }
    cout << hi << '\n';

    return 0;
}