#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    auto solve = [&](vector<int> &a_, int L) -> pair<int, int> { // {mx, sum}
        // a[i] -= 1 so that a[i] + a[j] <= L for each (i, j) && max(a[i]) -> min
        if (a_.size() == 1) {
            int x = a_[0];
            if (x > L) {
                return {L, x - L};
            } else {
                return {x, 0};
            }
        }
        pair<int, int> mx{0, 0};
        for (auto x : a_) {
            if (mx.first < x) {
                mx.second = mx.first;
                mx.first = x;
            } else {
                mx.second = max(mx.second, x);
            }
        }
        auto [A0, A1] = mx;
        if (A0 + A1 <= L) {
            return {A0, 0};
        }
        if (A1 + A1 <= L) {
            return {L - A1, A0 + A1 - L};
        }
        int a0 = (L + 1) / 2;
        int a1 = L / 2;
        int sum = A0 - a0;
        for (int i = 0; i < a_.size(); ++i) {
            if (a_[i] == A0) {
                A0 = -1;
                continue;
            }
            sum += max(0, a_[i] - a1);
        }
        return {a0, sum};
    };

    int N, K;
    cin >> N >> K;
    vector<vector<array<int, 2>>> adj_(N);
    int sumw = 0;
    for (int i = 1; i < N; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        --a, --b;
        sumw += w;
        adj_[a].push_back({b, w});
        adj_[b].push_back({a, w});
    }

    vector<int> tin(N), siz(N), tout(N);

    auto find_size = [&](auto self, int v) -> void {
        siz[v] = 1;
        for (auto &p : adj_[v]) {
            auto [to, w] = p;
            adj_[to].erase(std::find(adj_[to].begin(), adj_[to].end(), array<int, 2>{v, w}));
            self(self, to);
            siz[v] += siz[to];
            if (siz[to] > siz[adj_[v][0][0]]) {
                swap(p, adj_[v][0]);
            }
        }
    };

    int timer = 0;
    auto hld_reorder = [&](auto self, int v) -> void {
        tin[v] = timer++;
        for (auto [to, w] : adj_[v]) {
            self(self, to);
        }
    };
    find_size(find_size, 0);
    hld_reorder(hld_reorder, 0);
    vector<vector<array<int, 2>>> adj(N);
    for (int x = 0; x < N; ++x) {
        adj[x].reserve(adj_[x].size());
        int tx = tin[x];
        for (auto [to, w] : adj_[x]) {
            adj[tx].push_back({tin[to], w});
        }
    }

    auto check = [&](int mid) {
        int did = 0;
        vector<int> dp(N);
        auto dfs = [&](auto self, int v, int fa) -> int {
            dp[v] = 0;
            pair<int, int> mx{0, -1};
            for (auto [to, w] : adj[v]) {
                auto x = self(self, to, v) + w;
                if (did > K) {
                    return 0;
                }
                if (mx.first < x) {
                    mx.second = mx.first;
                    mx.first = x;
                } else {
                    mx.second = max(mx.second, x);
                }
            }
            int M = 0, sum = 0;
            if (mx.second == -1) {
                if (mx.first > mid) {
                    M = mid;
                    sum = mx.first - mid;
                } else {
                    M = mx.first;
                    sum = 0;
                }
            } else {
                auto [A0, A1] = mx;
                if (A0 + A1 <= mid) {
                    M = A0;
                    sum = 0;
                } else if (A1 + A1 <= mid) {
                    M = mid - A1;
                    sum = A0 + A1 - mid;
                } else {
                    int a0 = (mid + 1) / 2;
                    int a1 = mid / 2;
                    sum = A0 - a0;
                    for (auto [to, w] : adj[v]) {
                        int x = dp[to] + w;
                        if (x == A0) {
                            A0 = -1;
                            continue;
                        }
                        sum += max(0, x - a1);
                    }
                    M = a0;
                }
            }
            did += sum;
            if (did > K) {
                return 0;
            }
            return dp[v] = M;
        };
        int res = dfs(dfs, 0, -1);
        did += max(0, res - mid);
        return did <= K;
    };

    int lo = -1, hi = sumw;
    while (lo + 1 < hi) {
        int mid = lo + (hi - lo) / 2;
        if (check(mid)) {
            hi = mid;
        } else {
            lo = mid;
        }
    }
    cout << hi << '\n';

    return 0;
}