#include<bits/stdc++.h>
#include "soft_drinks.h"
using namespace std;

using i128 = __int128;
using ll = long long;


struct num {
	i128 x = 0, y = 1;

	void norm() {
		if (y < 0) {
			y = -y, x = -x;
		}
	}

	num() = default;

	num(i128 _x, i128 _y) : x(_x), y(_y) {
		norm();
	}

	num(i128 _x) : x(_x), y(1) {
		norm();
	}

	double val() {
		return 1.0 * x / y;
	}
};

num operator+(num a, num b) {
	num c(a.x * b.y + b.x * a.y, a.y * b.y);
	c.norm();
	return c;
}
num operator-(num a, num b) {
	num c(a.x * b.y - b.x * a.y, a.y * b.y);
	c.norm();
	return c;
}
num operator*(num a, num b) {
	num c(a.x * b.x, a.y * b.y);
	c.norm();
	return c;
}
num operator/(num a, num b) {
	num c(a.x * b.y, a.y * b.x);
	assert(b.x != 0);
	c.norm();
	return c;
}
bool operator<(num a, num b) {
	if (a.x < 0 && b.x > 0) return true;
	if (a.x > 0 && b.x < 0) return false;
	if (a.x < 0 && b.x < 0) {
		return -a.x * b.y > -b.x * a.y;
	}
	return a.x * b.y < a.y * b.x;
}
bool operator>(num a, num b) {
	return b < a;
}
bool operator==(num a, num b) {
	return a.x * b.y == a.y * b.x;
}
bool operator!=(num a, num b) {
	return !(a == b);
}
bool operator<=(num a, num b) {
	return a < b || a == b;
}
bool operator>=(num a, num b) {
	return a > b || a == b;
}

struct CHT {
	vector<pair<num, num>> ch;
	vector<num> pts;

	void build(vector<pair<num, num>> lines) {
		sort(lines.begin(), lines.end(), [&](auto x, auto y) {
			if (x.first == y.first) return x.second > y.second;
			return x.first < y.first;
		});
		auto inter = [&](pair<num, num> l1, pair<num, num> l2) -> num {
			return (l1.second - l2.second) / (l2.first - l1.first);
		};
		ch.clear();
		pts.clear();
		for (auto i : lines) {
			while (ch.size() > 1) {
				if (ch.back().first != i.first && pts.back() <= inter(ch.back(), i)) {
					break;
				} else {
					pts.pop_back();
					ch.pop_back();
				}
			}
			if (ch.size()) pts.push_back(inter(ch.back(), i));
			ch.push_back(i);
		}
	}

	num get(num x) {
		int k = upper_bound(pts.begin(), pts.end(), x) - pts.begin();
		return ch[k].first * x + ch[k].second;
	}
} ques;

vector<int> a, b;

void init(const vector<int>& A, const vector<int>& B) {
	int n = A.size();
	a.resize(n), b.resize(n);
	for (int i = 0; i < n; ++i) {
		a[i] = A[i], b[i] = B[i];
	}
}
double friendDrink(const int Ma, const int Mb, const int La, const int Ra) {
	vector<int> A, B;
	for (int i = 0; i < a.size(); ++i) {
		if (La <= a[i] && a[i] <= Ra) {
			A.push_back(a[i]);
			B.push_back(b[i]);
		}
	}
	int n = A.size();
	vector<pair<num, num>> lines;
	num lb(0);
	for (int i = 0; i < n; ++i) {
		if (A[i] != 0) {
			lines.emplace_back(num(-B[i], A[i]), num(1, A[i]));
		} else {
			lb = max(lb, num(1, B[i]));
		}
	}
	sort(lines.begin(), lines.end(), [&](auto x, auto y) {
		if (x.first == y.first) return x.second < y.second;
		return x.first < y.first;
	});
	auto inter = [&](pair<num, num> l1, pair<num, num> l2) -> num {
		return (l2.second - l1.second) / (l1.first - l2.first);
	};
	vector<pair<num, num>> ch;
	vector<num> pts;
	for (auto i : lines) {
		while (ch.size() > 1) {
			if (ch.back().first != i.first && pts.back() <= inter(ch.back(), i)) {
				break;
			} else {
				pts.pop_back();
				ch.pop_back();
			}
		}
		if (ch.size()) pts.push_back(inter(ch.back(), i));
		ch.push_back(i);
	}
	num ret = 1e18;
	for (int i = 0; i < ch.size(); ++i) {
		num x(0);
		if (i > 0) x = pts[i - 1];
		x = max(x, lb);
		if (i >= pts.size() || x <= pts[i]) {
			num alpha = x * ch[i].first + ch[i].second;
			num beta = x;
			if (alpha >= num(0)) {
				ret = min(ret, alpha * Ma + beta * Mb);
			}
		}
		if (ch[i].first != num(0)) {
			num y = ch[i].second / ch[i].first * num(-1);
			if (x <= y && (i >= pts.size() || y <= pts[i])) {
				num alpha = num(0);
				num beta = y;
				ret = min(ret, alpha * Ma + beta * Mb);
			}
		}
	}
	return ret.val();
}
