#include<bits/stdc++.h>
using namespace std;

int diameter(int n, vector<tuple<int, int, int>> e) {
	vector<vector<pair<int, int>>> g(n);
	for (auto [u, v, w] : e) {
		g[u].emplace_back(v, w);
		g[v].emplace_back(u, w);
	}
	auto mxd = [&](auto mxd, int u, int p) -> pair<int, int> {
		pair<int, int> ret = {0, u};
		for (auto [to, w] : g[u]) {
			if (to != p) {
				auto ss = mxd(mxd, to, u);
				ss.first += w;
				ret = max(ret, ss);
			}
		}
		return ret;
	};
	auto [d1, st] = mxd(mxd, 0, -1);
	auto [d2, fi] = mxd(mxd, st, -1);
	return d2;
}

int main() {
	cin.tie(nullptr)->sync_with_stdio(false);

	int n, k;
	cin >> n >> k;
	vector<tuple<int, int, int>> e(n - 1);
	vector<vector<pair<int, int>>> g(n);
	for (auto& [u, v, w] : e) {
		cin >> u >> v >> w;
		--u, --v;
		g[u].emplace_back(v, w);
		g[v].emplace_back(u, w);
	}
	auto check = [&](int d) -> bool {
		if (d == 0) return k >= n - 1;
		vector<int> mxd(n);
		auto dfs = [&](auto dfs, int u, int p) -> void {
			mxd[u] = 0;
			for (auto [to, w] : g[u]) {
				if (to != p) {
					dfs(dfs, to, u);
					mxd[u] = max(mxd[u], mxd[to] + 1);
				}
			}
		};
		for (int r = 0; r < n; ++r) {
			dfs(dfs, r, -1);
			int cnt = 0;
			for (auto i : mxd) cnt += i >= d / 2;
			if (cnt - 1 <= k) {
				return true;
			}
		}
		for (auto [u, v, w] : e) {
			dfs(dfs, u, v);
			dfs(dfs, v, u);
			{
				int cnt = 0;
				for (auto i : mxd) cnt += i >= (d - 1) / 2;
				if (cnt - 2 <= k) {
					return true;
				}
			}
			{
				int cnt = 0;
				for (auto i : mxd) cnt += i >= d / 2;
				if (cnt - 1 <= k) {
					return true;
				}
			}
		}
		return false;
	};
	int L = 0, R = n;
	while (L != R) {
		int M = (L + R) / 2;
		if (check(M)) R = M;
		else L = M + 1;
	}
	cout << L;
}