#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define x first
#define y second

using vec = pair<int, int>;

vec operator+(const vec &a, const vec &b) {
	return {a.x + b.x, a.y + b.y};
}

vec operator-(const vec &a, const vec &b) {
	return {a.x - b.x, a.y - b.y};
}

ll norm(const vec &a) {
	return 1ll * a.x * a.x + 1ll * a.y * a.y;
}

ll dot_prod(const vec &a, const vec &b) {
	return 1ll * a.x * b.x + 1ll * a.y * b.y;
}

ll cross_prod(const vec &a, const vec &b) {
	return 1ll * a.x * b.y - 1ll * a.y * b.x;
}

vector<vec> down(const vector<vec> &a) {
	vector<vec> ans;
	for (auto s : a) {
		while (ans.size() >= 2 && cross_prod(ans[ans.size() - 1] - ans[ans.size() - 2], s - ans[ans.size() - 1]) <= 0) {
			ans.pop_back();
		}
		ans.push_back(s);
	}
	return ans;
}

const int N = 100100;
vec a[N];
int n;


	vector<vec> can;
	vector<vec> f;
	int minB;

void init(const vector<int>& xx, const vector<int>& yy) {
	n = xx.size();
	for (int i = 0; i < n; i++) {
		a[i] = {xx[i], yy[i]};
	}
	sort(a, a + n);
	can = vector<vec>(a, a + n);
	f = down(can);
	if (f.size() >= 2 && f[f.size() - 1].x == f[f.size() - 2].x) {
		f.pop_back();
	}
	minB = 1'000'000'000;
	for (int i = 0; i < f.size(); i++) {
		minB = min(minB, f[i].y);
	}
}

double friendDrink(int A, int B, int la, int ra) {
	if (f.empty()) return 0;
	double l = (double)A / f.back().x;
	double r = (double)A / f[0].x;
	while ((r - l) / max(l, 1.0) > 1e-9) {
		double m = (r + l) / 2;
		double c = A / m;
		int i = upper_bound(f.begin(), f.end(), make_pair(((int)c) + 1, -1)) - f.begin();
		int j = i - 1;
		double mn = ((f[i].x - c) * f[j].y + (c - f[j].x) * f[i].y) / double(f[i].x - f[j].x);
		if (mn > f[j].y) mn = minB;
		if (B / mn >= m) {
			l = m;
		} else {
			r = m;
		}
	}
	return min(l, B / (double)minB);
}
