#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <chrono>
#include <random>
#include <complex>
#include <numeric>
#include <assert.h>
#include <functional>
#include <climits>
#include <cstring>
#include <iterator>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ushort = unsigned short;

#ifndef LOCAL
#define endl "\n"
#endif
#define f first
#define s second
#define vec vector
#define pii pair<int, int>
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
template<typename T1, typename T2>
istream& operator>> (istream &in, pair<T1, T2> &p) { in >> p.f >> p.s; return in; }
template<typename T1, typename T2>
ostream& operator<< (ostream &out, pair<T1, T2> p) { out << "(" << p.f << " " << p.s << ")"; return out; }
#define printv(v) cerr << #v << " "; for (auto &x : v) { cerr << x << " "; } cerr << endl;
#define printvv(v) cerr << #v << " "; for (auto &x : v) { for (auto &y : x) { cerr << y << " "; } cerr << endl; }
#define debug(x) cerr << #x << " " << x << endl;

template<typename T>
istream& operator>> (istream &in, vector<T> &v) {
    for (auto &x : v) {
        in >> x;
    }
    return in;
}
template<typename T>
ostream& operator<< (ostream &out, vector<T> v) {
    for (auto &x : v) {
        out << x << " ";
    }
    return out;
}
template<typename T>
void operator-=(vector<T> &v, int delta) {
    for (auto &x : v) {
        x -= delta;
    }
}
template<typename T>
void operator+=(vector<T> &v, int delta) {
    for (auto &x : v) {
        x += delta;
    }
}

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define double ld

const double EPS = 1e-9;

struct Point {
    int x, y;
    Point(int x, int y) : x(x), y(y) {}
};

Point operator-(Point a, Point b) {
    return Point(a.x - b.x, a.y - b.y);
}

ll operator%(Point a, Point b) {
    return a.x * b.y - a.y * b.x;
}

bool operator<(Point a, Point b) {
    if (a.x == b.x) {
        return a.y > b.y;
    }
    return a.x < b.x;
}

vector<Point> convex;

const int MAX_N = (1<<17);

int T[MAX_N * 2];

void upd(int i, int x) {
    i += MAX_N;
    T[i] = min(T[i], x);
    i /= 2;
    while (i > 0) {
        T[i] = min(T[i * 2], T[i * 2 + 1]);
        i /= 2;
    }
}

int get(int i, int l, int r, int ql, int qr) {
    if (ql >= r || qr <= l) {
        return 1e9 + 1;
    }
    if (ql <= l && r <= qr) {
        return T[i];
    } else {
        int m = (l + r) / 2;
        return min(get(i * 2, l, m, ql, qr), get(i * 2 + 1, m, r, ql, qr));
    }
}

//int getInd(double x) {
//    return lower_bound(all(pts), Point(x, 1e9 + 1)) - pts.begin();
//}

void getConvex(vector<Point> &pts) {
    convex.clear();
    for (auto &p : pts) {
        if (convex.empty()) {
            convex.pb(p);
            continue;
        }
        if (convex.back().x == p.x) {
            convex.pop_back();
        }
        while (convex.size() > 1 && (((convex[convex.size() - 1] - convex[convex.size() - 2]) % (p - convex[convex.size() - 2]) <= 0))) {
            convex.pop_back();
        }
        convex.pb(p);
    }
}

vector<Point> pts;

void init(const vector<int> &A, const vector<int> &B) {
    int n = A.size();
    for (int i = 0; i < n; ++i) {
        pts.pb(Point(A[i], B[i]));
    }
    for (int i = 0; i < MAX_N * 2; ++i) {
        T[i] = 1e9 + 1;
    }
    sort(all(pts));
    getConvex(pts);
//    for (auto &p : pts) {
//        upd(getInd(p.x), p.y);
//    }
}

double getY(double x) {
    auto it = lower_bound(all(convex), Point((int)x, 1e9 + 1));
    while (it != convex.end() && it->x < x) {
        it++;
    }
    if (it == convex.end()) {
        return false;
    }
    if (it == convex.begin()) {
        return false;
    }
    Point B = *it;
    it--;
    Point A = *it;
//    cout << x << " : " << mp(A.x, A.y) << ' ' << mp(B.x, B.y) << endl;
//    cout << "RES " << A.y + (B.y - A.y) * (x - A.x) / (B.x - A.x) << endl;
    return A.y + (B.y - A.y) * (x - A.x) / (B.x - A.x);
}

bool check(int l, int Ra, double m, double Ma, double Mb) {
    if (l * m >= Ma) {
        return false;
    }
    vector<Point> ptsNow;
    int best = 1e9 + 1;
    for (auto &p : pts) {
        if (p.x >= l && p.x <= Ra) {
            ptsNow.pb(p);
            if (p.x * m <= Mb) {
                best = min(best, (int) p.y);
            }
        }
    }
    getConvex(ptsNow);
//    int best = get(1, 0, MAX_N, getInd(l), getInd(min(Ra, Ma / m) + EPS));
    if (best <= 1e9 && best * m <= Mb) {
        return true;
    }
//    cout << getY(Ma / m) << endl;
    if (getY(Ma / m) * m <= Mb) {
        return true;
    }
    return false;
}

double friendDrink(int Ma, int Mb, int La, int Ra) {
    return (double)Mb / convex[0].y;
    double l = 0,  r = 1e9 + 1;
    while (r - l > EPS) {
        double m = (l + r) / 2;
        if (check(La, Ra, m, Ma, Mb)) {
            l = m;
        } else {
            r = m;
        }
    }
    return r;
}

#ifdef LOCAL
int main() {
    std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);
    freopen("in.txt", "r", stdin);

    int n, q;
    std::cin >> n >> q;

    std::vector<int> A(n), B(n);
    for (int i = 0; i < n; i ++) {
        std::cin >> A[i] >> B[i];
    }
    init(A, B);

    for (int i = 0; i < q; i ++) {
        int a, b, l, r;
        std::cin >> a >> b >> l >> r;
        const auto ret = friendDrink(a, b, l, r);
        std::cout << fixed << setprecision(6) << ret << "\n";
    }

    return 0;
}

#endif