#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <chrono>
#include <random>
#include <complex>
#include <numeric>
#include <assert.h>
#include <functional>
#include <climits>
#include <cstring>
#include <iterator>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ushort = unsigned short;

#ifndef LOCAL
#define endl "\n"
#endif
#define f first
#define s second
#define vec vector
#define pii pair<int, int>
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
template<typename T1, typename T2>
istream& operator>> (istream &in, pair<T1, T2> &p) { in >> p.f >> p.s; return in; }
template<typename T1, typename T2>
ostream& operator<< (ostream &out, pair<T1, T2> p) { out << "(" << p.f << " " << p.s << ")"; return out; }
#define printv(v) cerr << #v << " "; for (auto &x : v) { cerr << x << " "; } cerr << endl;
#define printvv(v) cerr << #v << " "; for (auto &x : v) { for (auto &y : x) { cerr << y << " "; } cerr << endl; }
#define debug(x) cerr << #x << " " << x << endl;

template<typename T>
istream& operator>> (istream &in, vector<T> &v) {
    for (auto &x : v) {
        in >> x;
    }
    return in;
}
template<typename T>
ostream& operator<< (ostream &out, vector<T> v) {
    for (auto &x : v) {
        out << x << " ";
    }
    return out;
}
template<typename T>
void operator-=(vector<T> &v, int delta) {
    for (auto &x : v) {
        x -= delta;
    }
}
template<typename T>
void operator+=(vector<T> &v, int delta) {
    for (auto &x : v) {
        x += delta;
    }
}

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

int performSwap(int i, int j);

void sortPermutation(int n) {
    performSwap(0, 1);
    int C = performSwap(0, 1);
    vector<pii> st;
    auto change = [&](int a, int b, bool write = true) {
//        cout << "CHANGE " << a << ' ' << b << endl;
        if (write) {
            st.pb(mp(a, b));
        }
        int nC = performSwap(a, b);
        nC -= C;
        C += nC;
        return nC;
    };
    auto unite = [&](int l, int r) {
        for (int i = l; i < r - 1; ++i) {
            if (change(i, i + 1) > 0) {
                change(i, i + 1);
            }
        }
    };
    auto rec = [&](int l, int r, auto &&self) -> bool {
        if (l + 1 == r) {
            return false;
        }
        int m = (l + r) / 2;
//        cout << "(" << l << ' ' << m << ' ' << r << ") " << endl;
        int stH = st.size();
        unite(l, m);
        int ansR = -1, ansL = -1;
        for (int i = m; i < r; ++i) {
            int res = change(l, i, false);
            change(l, i, false);
            if (res > 0) {
                ansR = i;
                break;
            }
        }
        while (st.size() > stH) {
            change(st.back().f, st.back().s, false);
            st.pop_back();
        }
        if (ansR == -1) {
            if (self(l, m, self)) {
                return true;
            }
            if (self(m, r, self)) {
                return true;
            }
            return false;
        } else {
            unite(m, r);
            for (int i = l; i < m; ++i) {
                int res = change(i, m, false);
                change(i, m, false);
                if (res > 0) {
                    ansL = i;
                    break;
                }
            }
            while (st.size() > stH) {
                change(st.back().f, st.back().s, false);
                st.pop_back();
            }
            change(ansL, ansR);
            return true;
        }
    };
    rec(0, n, rec);
}

#ifdef LOCAL
static int64_t cnt = 0;
static std::vector<int> perm;
static int64_t n;

static int findPermCount() {
    std::vector<bool> used(n, false);
    int64_t cntc = 0;
    for (int64_t i = 0; i < n; i ++) {
        if (used[i]) { continue; }
        int64_t curr = i; cntc ++;
        while (!used[curr]) {
            used[curr] = true;
            curr = perm[curr];
        }
    }
    return cntc;
}

int performSwap(int i, int j) {
    ++cnt;

    bool valid_swap = true;
    valid_swap &= (0 <= i && i < n);
    valid_swap &= (0 <= j && j < n);
    valid_swap &= (i != j);

    if (!valid_swap) {
        std::cout << "WRONG. Your program made an invalid swap: (" << i << ", " << j << ")" << std::endl;
        exit(0);
    }

    std::swap(perm[i], perm[j]);
    return findPermCount();
}

int main() {
    freopen("in.txt", "r", stdin);
    std::cin >> n;
    perm.resize(n);
    for (int64_t i = 0; i < n; i ++) { std::cin >> perm[i]; }

    sortPermutation(n);
    if (findPermCount() != n) {
        std::cout << "WRONG. The final permutation is not sorted." << std::endl;
    } else {
        std::cout << "CORRECT with " << cnt << " swaps" << std::endl;
    }
    return 0;
}

#endif