#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <chrono>
#include <random>
#include <complex>
#include <numeric>
#include <assert.h>
#include <functional>
#include <climits>
#include <cstring>
#include <iterator>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
using ushort = unsigned short;

#ifndef LOCAL
#define endl "\n"
#endif
#define f first
#define s second
#define vec vector
#define pii pair<int, int>
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define mp make_pair
template<typename T1, typename T2>
istream& operator>> (istream &in, pair<T1, T2> &p) { in >> p.f >> p.s; return in; }
template<typename T1, typename T2>
ostream& operator<< (ostream &out, pair<T1, T2> p) { out << "(" << p.f << " " << p.s << ")"; return out; }
#define printv(v) cerr << #v << " "; for (auto &x : v) { cerr << x << " "; } cerr << endl;
#define printvv(v) cerr << #v << " "; for (auto &x : v) { for (auto &y : x) { cerr << y << " "; } cerr << endl; }
#define debug(x) cerr << #x << " " << x << endl;

template<typename T>
istream& operator>> (istream &in, vector<T> &v) {
    for (auto &x : v) {
        in >> x;
    }
    return in;
}
template<typename T>
ostream& operator<< (ostream &out, vector<T> v) {
    for (auto &x : v) {
        out << x << " ";
    }
    return out;
}
template<typename T>
void operator-=(vector<T> &v, int delta) {
    for (auto &x : v) {
        x -= delta;
    }
}
template<typename T>
void operator+=(vector<T> &v, int delta) {
    for (auto &x : v) {
        x += delta;
    }
}

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

signed Main();
void Solve();
void PreCalc();

static void run_with_stack_size(signed (*func)(), size_t stsize) {
    char *stack, *send;
    stack = (char *)malloc(stsize);
    send = stack+stsize-16;
    send = (char *)((uintptr_t)send/16*16);
    asm volatile(
            "mov %%rsp, (%0)\n"
            "mov %0, %%rsp\n"
            :
            : "r" (send));
    func();
    asm volatile(
            "mov (%0), %%rsp\n"
            :
            : "r"   (send));
    free(stack);
}


signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    int tStart = clock();
    run_with_stack_size(Main, 1024*1024*1024);
    cout << "execution time : " << (clock() - tStart) / 1e3 << endl;
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    Main();
#endif
}

signed Main() {
    PreCalc();
    int t;
//    cin >> t;
    t = 1;
    int test = 0;
    while (t--) {
        ++test;
#ifdef LOCAL
        cout << "--------- TEST #" << test << " ----------" << endl;
#endif
        Solve();
    }
    return 0;
}

/* This code is praying to GOD for protecting from bugs and "other things" */

void PreCalc() {

}

vector<vector<pii>> graph;

void Solve() {
    int n, k;
    cin >> n >> k;
    if (k >= n - 1) {
        cout << 0 << endl;
        return;
    }
    graph.assign(n, {});
    vector<pii> edges(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        --a; --b;
        edges[i] = mp(a, b);
        graph[a].pb(mp(b, i));
        graph[b].pb(mp(a, i + n - 1));
    }
    vector<vector<int>> dp(n * 2 - 2, vector<int>(n));
    vector<int> calced(n * 2 - 2);
    auto calc = [&](int e, auto &&self) -> void {
        int u, v;
        if (e >= n - 1) {
            v = edges[e - (n - 1)].f;
            u = edges[e - (n - 1)].s;
        } else {
            u = edges[e].f;
            v = edges[e].s;
        }
        for (auto &pu : graph[v]) {
            if (pu.f != u) {
                if (!calced[pu.s]) {
                    self(pu.s, self);
                }
                for (int i = n-1; i > 0; --i) {
                    dp[e][i] += dp[pu.s][i] + ((dp[pu.s][i-1])>0);
                }
                dp[e][0] += dp[pu.s][0] + 1;
            }
        }
        calced[e] = true;
    };
    int l = 0, r = n-1;
    for (int i = 0; i < n * 2 - 2; ++i) {
        if (!calced[i]) {
            calc(i, calc);
        }
    }
    while (r - l > 1) {
        int m = (l + r) / 2;
        bool ok = false;
        for (int i = 0; i < (n - 1); ++i) {
            if (dp[i][m / 2] + dp[(i + n - 1)][m - (m / 2) - 1] <= k) {
                ok = true;
                break;
            }
            if (dp[i][m - (m / 2) - 1] + dp[(i + n - 1)][m / 2] <= k) {
                ok = true;
                break;
            }
            if (m % 2 == 0 && dp[i][m / 2] + dp[(i + n - 1)][m / 2] <= k - 1) {
                ok = true;
                break;
            }
        }
        if (ok) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << r << endl;
}
