#include<bits/stdc++.h>
#include "soft_drinks.h"

using namespace std;

typedef int ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const double eps = 1e-10;
const ll INF = 2'000'000'000;

ll ma, mab;
vector<tuple<ll, ll, ll>> all;

bool cmp(pair<ll, ll> a, pair<ll, ll> b) {
	return ((long long)(mab - a.second)) * (b.first - ma) > ((long long)(mab - b.second)) * (a.first - ma);
}

void init(const vector<ll>& a, const vector<ll>& b) {
	ma = INF;
	mab = INF;
	ll n = a.size();
	for (ll i = 0; i < n; i++) {
		if (assign_min(ma, a[i])) {
			mab = b[i];
		}
		if (ma == a[i]) {
			assign_min(mab, b[i]);
		}
	}
	vector<pair<ll, ll>> pot;
	for (ll i = 0; i < n; i++) {
		if (b[i] < mab) {
			pot.emplace_back(a[i], b[i]);
		}
	}
	sort(pot.begin(), pot.end(), cmp);
	ll lb = mab;
	ll la = ma;
	for (auto[a, b] : pot) {
		if (b < lb) {
			all.emplace_back(la, a, b);
			la = a;
			lb = b;
		}
	}
}

double friendDrink(ll Ma, ll Mb, ll La, ll Ra) {
	if (((double)Ma) / ma < ((double)Mb) / mab) {
		return ((double)Ma) / ma;
	}
	double l = ma, r = INF;
	double ans = ((double)Mb) / mab;
	if (all.empty()) {
		return ans;
	}
	while (r - l > eps) {
		double mid = (l + r) / 2;
		ll it = lower_bound(all.begin(), all.end(), make_tuple(ceil(mid), 0, 0)) - all.begin() - 1;
		auto[_, na, nb] = all[it];
		if (na < mid) {
			r = mid;
			continue;
		}
		double nowb = mab - ((double)(mid - ma)) / (na - ma) * (mab - nb);
		if (((double)Ma) / mid < ((double)Mb) / nowb) {
			r = mid;
		} else {
			l = mid;
			ans = ((double)Mb) / nowb;
		}
	}
	return ans;
}

#ifdef LOCAL
int main() {
        std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);

        int n, q;
        std::cin >> n >> q;

        std::vector<int> A(n), B(n);
        for (int i = 0; i < n; i ++) {
                std::cin >> A[i] >> B[i];
        }
        init(A, B);

        for (int i = 0; i < q; i ++) {
                int a, b, l, r;
                std::cin >> a >> b >> l >> r;
                const auto ret = friendDrink(a, b, l, r);
                std::cout << ret << "\n";
        }

        return 0;
}
#endif
