#include<bits/stdc++.h>
#include "soft_drinks.h"

using namespace std;

typedef long long ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const double eps = 1e-7;
const ll INF = 1'000'000'000'000;

vector<pair<ll, ll>> all;

void init(const vector<int>& a, const vector<int>& b) {
	for (ll i = 0; i < a.size(); i++) {
		all.emplace_back(a[i], b[i]);
	}
}

double friendDrink(int Ma, int Mb, int La, int Ra) {
	double ans = 0;
	for (ll i = 0; i < all.size(); i++) {
		if (all[i].first >= La && all[i].second <= Ra) {
			assign_max(ans, min((all[i].first == 0 ? INF : ((double)Ma) / all[i].first), (all[i].second == 0 ? INF : ((double)Mb) / all[i].second)));
			auto[a1, b1] = all[i];
			for (ll j = 0; j < all.size(); j++) {
				if (all[j].first >= La && all[j].second <= Ra) {
					auto[a2, b2] = all[j];
					if (a1 < a2 && b1 > b2) {
						double l = 0, r = INF;
						while (r - l > eps) {
							double mid = (l + r) / 2;
							double nca = ((double)Ma) / mid, ncb = ((double)Mb) / mid;
							if (ncb > b1) {
								ncb = b1;
							}
							if (nca > a2) {
								nca = a2;
							}
							if (nca < a1) {
								r = mid;
								continue;
							}
							double nb = b1 - (nca - a1) / (a2 - a1) * (b1 - b2);
							if (ncb - nb <= eps) {
								l = mid;
							} else {
								r = mid;
							}
						}
						assign_max(ans, l);
					}
				}
			}
		}
	}
	return ans;
}

#ifdef LOCAL
int main() {
        std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);

        int n, q;
        std::cin >> n >> q;

        std::vector<int> A(n), B(n);
        for (int i = 0; i < n; i ++) {
                std::cin >> A[i] >> B[i];
        }
        init(A, B);

        for (int i = 0; i < q; i ++) {
                int a, b, l, r;
                std::cin >> a >> b >> l >> r;
                const auto ret = friendDrink(a, b, l, r);
                std::cout << ret << "\n";
        }

        return 0;
}
#endif
