#include<bits/stdc++.h>
#include "soft_drinks.h"

using namespace std;

typedef long long ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const double eps = 1e-11;
const ll INF = 1'000'000'000'000;

vector<tuple<ll, ll, ll>> all;
set<pair<ll, ll>> allab;
vector<ll> allob;

bool cmp(pair<ll, ll> a, pair<ll, ll> b, pair<ll, ll> c) {
	return ((c.second - a.second)) * (b.first - c.first) >= ((c.second - b.second)) * (a.first - c.first);
}

void init(const vector<int>& aa, const vector<int>& bb) {
	vector<int> a = aa;
	vector<int> b = bb;
	ll n = a.size();
	for (ll i = 0; i < n; i++) {
		allab.insert(make_pair(a[i], b[i]));
	}
	vector<pair<ll, ll>> pot;
	for (ll i = 0; i < n; i++) {
		pot.emplace_back(b[i], a[i]);
	}
	sort(pot.rbegin(), pot.rend());
	vector<pair<ll, ll>> nall;
	for (auto[b, a] : pot) {
		while (nall.size() > 1 && cmp(make_pair(a, b), nall.back(), nall[nall.size() - 2])) {
			nall.pop_back();
		}
		nall.emplace_back(a, b);
	}
	ll la = 0;
	nall.erase(nall.begin());
	for (auto[a, b] : nall) {
		all.emplace_back(la, a, b);
		allob.push_back(a);
		la = a;
	}
}

double friendDrink(int Ma, int Mb, int La, int Ra) {
	auto it = allab.lower_bound(make_pair(La, -1));
	if (it == allab.end()) {
		return 0;
	}
	auto[ma, mab] = *it;
	if (ma > Ra) {
		return 0;
	}
	ll to = upper_bound(allob.begin(), allob.end(), Ra) - allob.begin() - 1;
	ll from = lower_bound(allob.begin(), allob.end(), La + 1) - allob.begin();
	if ((ma == 0 ? INF : ((double)Ma) / ma) < (mab == 0 ? INF : ((double)Mb) / mab)) {
		return ((double)Ma) / ma;
	}
	double l = ma, r = INF;
	double ans = ((double)Mb) / mab;
	if (all.empty()) {
		return ans;
	}
	if (from > to) {
		return ans;
	}
	while ((r - l) / max(1.0, l) > eps) {
		double mid = (l + r) / 2;
		ll it = lower_bound(all.begin(), all.end(), make_tuple(ceil(mid), 0, 0)) - all.begin() - 1;
		if (it < from) {
			it = from;
		}
		if (it > to) {
			it = to;
		}
		auto[mto, na, nb] = all[it];
		ll oa, ob;
		if (it == from) {
			oa = ma;
			ob = mab;
		} else {
			auto[_, noa, nob] = all[it - 1];
			oa = noa;
			ob = nob;
		}
		if (na < mid) {
			mid = na;
			if (mid == l) {
				break;
			}
		}
		double nowb = ob - ((double)(mid - oa)) / (na - oa) * (ob - nb);
		if (((double)Ma) / mid < (nowb == 0 ? INF : ((double)Mb) / nowb)) {
			r = mid;
			assign_max(ans, ((double)Ma) / mid);
		} else {
			l = mid;
			assign_max(ans, ((double)Mb) / nowb);
		}
	}
	return ans;
}

#ifdef LOCAL
int main() {
        std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);

        int n, q;
        std::cin >> n >> q;

        std::vector<int> A(n), B(n);
        for (int i = 0; i < n; i ++) {
                std::cin >> A[i] >> B[i];
        }
        init(A, B);

        for (int i = 0; i < q; i ++) {
                int a, b, l, r;
                std::cin >> a >> b >> l >> r;
                const auto ret = friendDrink(a, b, l, r);
                std::cout << ret << "\n";
        }

        return 0;
}
#endif
