#include<bits/stdc++.h>
#include "cycles.h"

using namespace std;

typedef int ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void sortPermutation(ll n) {
	performSwap(0, 1);
	ll start = performSwap(0, 1);
	if (start == n) {
		return;
	}
	ll ns = -1;
	for (ll i = 1; i < n; i++) {
		ll x = performSwap(0, i);
		if (x > start) {
			ns = i;
			for (ll j = i; j > 0; j--) {
				start = performSwap(0, j);
			}
			break;
		} else {
			start = x;
		}
	}
	for (ll i = 0; i < n; i++) {
		if (performSwap(i, ns) == n) {
			break;
		} else {
			performSwap(i, ns);
		}
	}
}

#ifdef LOCAL
static int64_t cnt = 0;
static std::vector<int> perm;
static int64_t n;

static int findPermCount() {
        std::vector<bool> used(n, false);
        int64_t cntc = 0;
        for (int64_t i = 0; i < n; i ++) {
                if (used[i]) { continue; }
                int64_t curr = i; cntc ++;
                while (!used[curr]) {
                        used[curr] = true;
                        curr = perm[curr];
                }
        }
    return cntc;
}

int performSwap(int i, int j) {
        ++cnt;

    bool valid_swap = true;
    valid_swap &= (0 <= i && i < n);
    valid_swap &= (0 <= j && j < n);
    valid_swap &= (i != j);

    if (!valid_swap) {
        std::cout << "WRONG. Your program made an invalid swap: (" << i << ", " << j << ")" << std::endl;
        exit(0);
    }

        std::swap(perm[i], perm[j]);
        return findPermCount();
}

int main() {
        std::cin >> n;
        perm.resize(n);
        for (int64_t i = 0; i < n; i ++) { std::cin >> perm[i]; }

        sortPermutation(n);
        if (findPermCount() != n) {
                std::cout << "WRONG. The final permutation is not sorted." << std::endl;
        } else {
                std::cout << "CORRECT with " << cnt << " swaps" << std::endl;
        }
        return 0;
}
#endif
