#include<bits/stdc++.h>
#include "cycles.h"

using namespace std;

typedef int ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

random_device rd;
mt19937 rnd(rd());

void rec(vector<ll> cy, ll& now) {
	if (cy.size() < 2) {
		return;
	}
	ll x = rnd() % (cy.size() - 1) + 1;
	now = performSwap(cy[0], cy[x]);
	vector<ll> fir(1, cy[0]), sec(1, cy[x]);
	for (ll i = 1; i < cy.size(); i++) {
		if (i != x) {
			ll nx = performSwap(cy[0], cy[i]);
			if (nx > now) {
				fir.push_back(cy[i]);
			} else {
				sec.push_back(cy[i]);
			}
			performSwap(cy[0], cy[i]);
		}
	}
	rec(fir, now);
	rec(sec, now);
}

void sortPermutation(ll n) {
	ll start = performSwap(0, 1);
	if (start == n) {
		return;
	}
	for (ll i = 1; i < n; i++) {
		ll x = performSwap(0, i);
		if (x > start) {
			start = performSwap(0, i);
			break;
		} else {
			start = x;
		}
	}
	vector<ll> cy;
	for (ll i = 0; i < n; i++) {
		cy.push_back(i);
	}
	rec(cy, start);
}

#ifdef LOCAL
static int64_t cnt = 0;
static std::vector<int> perm;
static int64_t n;

static int findPermCount() {
        std::vector<bool> used(n, false);
        int64_t cntc = 0;
        for (int64_t i = 0; i < n; i ++) {
                if (used[i]) { continue; }
                int64_t curr = i; cntc ++;
                while (!used[curr]) {
                        used[curr] = true;
                        curr = perm[curr];
                }
        }
    return cntc;
}

int performSwap(int i, int j) {
        ++cnt;

    bool valid_swap = true;
    valid_swap &= (0 <= i && i < n);
    valid_swap &= (0 <= j && j < n);
    valid_swap &= (i != j);

    if (!valid_swap) {
        std::cout << "WRONG. Your program made an invalid swap: (" << i << ", " << j << ")" << std::endl;
        exit(0);
    }

        std::swap(perm[i], perm[j]);
        return findPermCount();
}

int main() {
        std::cin >> n;
        perm.resize(n);
        for (int64_t i = 0; i < n; i ++) { std::cin >> perm[i]; }

        sortPermutation(n);
        if (findPermCount() != n) {
                std::cout << "WRONG. The final permutation is not sorted." << std::endl;
        } else {
                std::cout << "CORRECT with " << cnt << " swaps" << std::endl;
        }
        return 0;
}
#endif
