#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const ll INF = 10'000'000'000;

void dfs(ll v, ll p, vector<vector<pair<ll, ll>>>& to, vector<vector<ll>>& dp, ll need, ll md) {
	dp[v].push_back(0);
	for (auto[i, c] : to[v]) {
		if (i != p) {
			dfs(i, v, to, dp, need, md);
			dp[i].resize(min(md + 1, (ll)dp[i].size() + c), INF);
			for (ll j = dp[i].size() - 1; j >= 0; j--) {
				ll ndp = INF;
				for (ll k = 0; k <= c && j - k >= 0; k++) {
					assign_min(ndp, dp[i][j - k] + c - k);
				}
				dp[i][j] = INF;
				if (ndp <= need) {
					dp[i][j] = ndp;
				}
			}
			vector<ll> ndp(min((ll)dp[v].size() + (ll)dp[i].size() - 1, md + 1), INF);
			for (ll j = 0; j < dp[v].size(); j++) {
				for (ll k = 0; k < dp[i].size(); k++) {
					if (j + k <= md && dp[v][j] + dp[i][k] <= need) {
						assign_min(ndp[j + k], max(dp[v][j], dp[i][k]));
					}
				}
			}
			dp[v] = ndp;
		}
	}
}

ll dfs2(ll v, ll p, vector<ll>& h, vector<vector<pair<ll, ll>>>& to) {
	ll ans = 0;
	vector<ll> as;
	h[v] = 0;
	for (auto[i, c] : to) {
		if (i != p) {
			assign_max(ans, dfs2(i, v, h, to));
			h[i] += c;
			as.push_back(h[i]);
		}
	}
	sort(as.rbegin(), as.rend());
	if (as.size() >= 1) {
		assign_max(ans, as[0]);
	}
	if (as.size() >= 2) {
		assign_max(ans, as[0] + as[1]);
	}
	return ans;
}

void solve() {
	ll n, k;
	cin >> n >> k;
	assign_min(k, n);
	vector<vector<pair<ll, ll>>> to(n);
	ll sc = 0;
	for (ll i = 1; i < n; i++) {
		ll a, b, c;
		cin >> a >> b >> c;
		sc += c;
		a--;
		b--;
		to[a].emplace_back(b, c);
		to[b].emplace_back(a, c);
	}
	vector<ll> h(n, 0);
	ll d = dfs2(0, 0, h, to);
	ll l = d - k, r = d;
	while (r - l > 1) {
		ll mid = (l + r) / 2;
		vector<vector<ll>> dp(n);
		dfs(0, 0, to, dp, mid, k);
		if (dp[0].back() <= mid) {
			r = mid;
		} else {
			l = mid;
		}
	}
	cout << r << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
