#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const ll INF = 10'000'000'000;

pair<ll, ll> find(ll v, ll p, vector<vector<pair<ll, ll>>>& to, ll nh) {
	pair<ll, ll> ans(nh, v);
	for (auto[i, c] : to[v]) {
		if (i != p) {
			assign_max(ans, find(i, v, to, nh + c));
		}
	}
	return ans;
}

bool find_way(ll v, ll p, ll f, vector<vector<pair<ll, ll>>>& to, vector<pair<ll, ll>>& ans) {
	if (v == f) {
		return true;
	}
	for (auto[i, c] : to[v]) {
		if (i != p) {
			ans.emplace_back(i, c);
			if (find_way(i, v, f, to, ans)) {
				return true;
			}
			ans.pop_back();
		}
	}
	return false;
}

void dfs(ll v, ll p, vector<vector<pair<ll, ll>>>& to, vector<ll>& mh, vector<vector<ll>>& sons, vector<ll>& up) {
	for (auto[i, c] : to[v]) {
		if (i != p) {
			dfs(i, v, to, mh, sons, up);
			mh[i] += c;
			up[i] = c;
			assign_max(mh[v], mh[i]);
			sons[v].push_back(i);
		}
	}
}

void solve() {
	ll n, k;
	cin >> n >> k;
	vector<vector<pair<ll, ll>>> to(n);
	ll sc = 0;
	for (ll i = 1; i < n; i++) {
		ll a, b, c;
		cin >> a >> b >> c;
		sc += c;
		a--;
		b--;
		to[a].emplace_back(b, c);
		to[b].emplace_back(a, c);
	}
	ll v1 = find(0, 0, to, 0).second;
	ll v2 = find(v1, v1, to, 0).second;
	vector<pair<ll, ll>> way(1, make_pair(v1, 0));
	find_way(v1, v1, v2, to, way);
	ll len = 0;
	for (auto[v, c] : way) {
		len += c;
	}
	ll lh = len / 2;
	ll u1 = way.size() - 1;
	ll s1 = 0;
	while (s1 + way[u1].second <= lh) {
		s1 += way[u1].second;
		u1--;
	}
	ll v0 = way[u1 - 1].first;
	v1 = way[u1].first;
	ll nl = way[u1].second;
	if (len % 2 == 1 && k) {
		nl--;
		len--;
		k--;
		for (ll i = 0; i < n; i++) {
			for (auto&[j, c] : to[i]) {
				if ((i == v0 && j == v1) || (i == v1 && j == v0)) {
					c--;
				}
			}
		}
	}
	ll ls = s1, lp = len - s1 - nl;
	ll x = min(lh - ls, lh - lp) * 2;
	if (k >= x * 2) {
		if (lh - ls < lh - lp) {
			swap(v0, v1);
		}
		k -= x * 2;
		lh -= x;
		len -= x * 2;
		for (ll i = 0; i < n; i++) {
			for (auto&[j, c] : to[i]) {
				if ((i == v0 && j == v1) || (i == v1 && j == v0)) {
					c -= x * 2;
				}
			}
		}
		vector<ll> mh(n, 0);
		vector<vector<ll>> sons(n);
		vector<ll> up(n, 0);
		dfs(v0, v0, to, mh, sons, up);
		set<pair<ll, ll>> wd;
		set<pair<ll, ll>> vh;
		vh.emplace(mh[v0], v0);
		ll nt = 0;
		while (k && (!wd.empty() || !vh.empty())) {
			ll nxt = INF;
			if (!wd.empty()) {
				assign_min(nxt, wd.begin()->first - nt);
			}
			if (!vh.empty()) {
				assign_min(nxt, len / 2 - vh.begin()->first);
			}
			if (!wd.empty()) {
				ll dec = min(k / (ll)wd.size(), nxt);
				k -= dec * wd.size();
				nt += dec;
				len -= dec * 2;
				nxt -= dec;
				if (nxt) {
					if (k == wd.size() - 1) {
						len--;
					}
					break;
				}
			} else {
				nt += nxt;
				len -= nxt * 2;
				nxt = 0;
			}
			while (!wd.empty() && wd.begin()->first == nt) {
				auto[_, v] = *wd.begin();
				wd.erase(wd.begin());
				for (auto j : sons[v]) {
					vh.insert(make_pair(mh[j], j));
				}
			}
			while (!vh.empty() && vh.begin()->first == len / 2) {
				auto[_, v] = *vh.begin();
				vh.erase(vh.begin());
				wd.insert(make_pair(up[v] + nt, v));
			}
		}
	} else {
		len -= k;
	}
	cout << len << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
