#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = (int) 1e5 * 2 + 10;

struct Edge {
    int u, v, w;
};

vector<Edge> diam;
vector<pair<int, int>> g[N];

pair<int, int> farthest(int v, int p) {
    int res = v, cur = 0;
    for (auto [u, cost]: g[v]) {
        if (u == p) continue;
        auto vis = farthest(u, v);
        if (vis.second + cost > cur) {
            cur = vis.second + cost;
            res = vis.first;
        }
    }
    return {res, cur};
}

bool to_go(int v, int p, int go) {
    if (v == go) return true;
    for (auto [u, cost]: g[v]) {
        if (u == p) continue;
        diam.emplace_back(v, u, cost);
        if (to_go(u, v, go))
            break;
        diam.pop_back();
    }
    return false;
}

int get() {
    int v = farthest(0, -1).first;
    auto vis = farthest(v, -1);
    int u = vis.first, cost = vis.second;
    to_go(v, -1, u);
    return cost;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, K;
    cin >> n >> K;
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u - 1].emplace_back(v - 1, w);
        g[v - 1].emplace_back(u - 1, w);
    }
    cout << get();
    return 0;
}