#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = (int) 1e5 * 2 + 10;

struct Edge {
    int u, v, w;

    Edge() : u(0), v(0), w(0) {};

    Edge(int _u, int _v, int _w) : u(_u), v(_v), w(_w) {};
};

vector<Edge> diam;
vector<pair<int, int>> g[N];

pair<int, int> farthest(int v, int p) {
    int res = v, cur = 0;
    for (auto [u, cost]: g[v]) {
        if (u == p) continue;
        auto vis = farthest(u, v);
        if (vis.second + cost > cur) {
            cur = vis.second + cost;
            res = vis.first;
        }
    }
    return {res, cur};
}

bool to_go(int v, int p, int go) {
    if (v == go) return true;
    for (auto [u, cost]: g[v]) {
        if (u == p) continue;
        diam.push_back(Edge(v, u, cost));
        if (to_go(u, v, go))
            return true;
        diam.pop_back();
    }
    return false;
}

int get() {
    int v = farthest(0, -1).first;
    auto vis = farthest(v, -1);
    int u = vis.first, cost = vis.second;
    to_go(v, -1, u);
    return cost;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, K;
    cin >> n >> K;
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u - 1].emplace_back(v - 1, w);
        g[v - 1].emplace_back(u - 1, w);
    }
    if (K == 0) {
        cout << get();
        return 0;
    }
    if (K == 1) {
        int cost = get();
        int sumL = 0, sumR = cost, cur_ans = (int) 1e18;
        Edge e;
        for (auto x: diam) {
            sumR -= x.w;
            if (abs(sumR - sumL) < cur_ans) {
                cur_ans = abs(sumR - sumL);
                e = x;
            }
            sumL += x.w;
        }
        for (auto &c: g[e.u])
            if (c.first == e.v)
                c.second--;
        for (auto &c: g[e.v])
            if (c.first == e.u)
                c.second--;
        cout << get();
        return 0;
    }
    while (K > 0) {
        int cost = get();
        if (cost == 0) break;
        int sumL = 0, sumR = cost, cur_ans = (int) 1e18;
        Edge e;
        for (auto x: diam) {
            sumR -= x.w;
            if (x.w > 0 && abs(sumR - sumL) < cur_ans) {
                cur_ans = abs(sumR - sumL);
                e = x;
            }
            sumL += x.w;
        }
        for (auto &c: g[e.u])
            if (c.first == e.v)
                c.second--;
        for (auto &c: g[e.v])
            if (c.first == e.u)
                c.second--;
        K--;
    }
    cout << get();
    return 0;
}