#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = (int) 1e5 * 2 + 10;

struct Edge {
    int to, w, ind;

    Edge() : to(0), w(0), ind(0) {};

    Edge(int _to, int _w, int _ind) : to(_to), w(_w), ind(_ind) {};
};

vector<Edge> g[N];
vector<pair<int, int>> G[N];
vector<pair<int, int>> edges;
vector<bool> taken[N];

int n, K, mx[N], dist[N];
int D, cur_cnt;

int dfs(int v, int p, int ind) {
    mx[v] = dist[v];
    for (auto [to, cost, index]: g[v])
        if (to != p)
            dist[to] = dist[v] + 1,
                    mx[v] = max(mx[v], dfs(to, v, index));
    if (ind != -1 && mx[v] - D >= dist[v])
        taken[ind].emplace_back(true), cur_cnt++;
    return mx[v];
}

bool goV(int v, int p, int ind) {
    if (cur_cnt <= K)
        return true;
    multiset<int> diff;
    for (auto pr: g[v])
        if (pr.to != p)
            diff.insert(mx[pr.to]);
    for (auto [to, cost, i]: g[v]) {
        if (to == p) continue;
        diff.erase(diff.find(mx[to]));
        if (!taken[i].empty() && taken[i].back()) cur_cnt--;
        taken[i].emplace_back(false);
        if ((!diff.empty() && *diff.rbegin() >= D - 1) || D == 0)
            taken[i].back() = true;
        if (taken[i].back()) cur_cnt++;
        if (goV(to, v, i))
            return true;
        if (taken[i].back()) cur_cnt--;
        taken[i].pop_back();
        if (!taken[i].empty() && taken[i].back()) cur_cnt++;
        diff.insert(mx[to]);
    }
    return false;
}

bool checkV() {
    cur_cnt = 0, dfs(0, -1, -1);
    if (cur_cnt <= K) return true;
    return goV(0, -1, -1);
}

pair<int, int> farthest(int v, int p) {
    int res = v, cur = 0;
    for (auto [u, cost]: G[v]) {
        if (u == p) continue;
        auto vis = farthest(u, v);
        if (vis.second + cost > cur) {
            cur = vis.second + cost;
            res = vis.first;
        }
    }
    return {res, cur};
}

vector<pair<pair<int, int>, int>> diam;

bool to_go(int v, int p, int go) {
    if (v == go) return true;
    for (auto [u, cost]: G[v]) {
        if (u == p) continue;
        diam.push_back({{v, u}, cost});
        if (to_go(u, v, go))
            return true;
        diam.pop_back();
    }
    return false;
}

int get() {
    int v = farthest(0, -1).first;
    auto vis = farthest(v, -1);
    int u = vis.first, cost = vis.second;
    diam.clear(), to_go(v, -1, u);
    return cost;
}

bool checkE() {

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> K;
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        G[u - 1].emplace_back(v - 1, w);
        G[v - 1].emplace_back(u - 1, w);
        g[u - 1].emplace_back(v - 1, w, i);
        g[v - 1].emplace_back(u - 1, w, i);
        edges.emplace_back(u - 1, v - 1);
    }
    int KK = K, ans;
    while (KK > 0) {
        int cost = get();
        if (cost == 0) break;
        vector<pair<pair<int, int>, int>> ones;
        for (auto e: diam)
            if (e.second > 0)
                ones.emplace_back(e);
        auto e = ones[(int) ones.size() / 2];
        for (auto &c: G[e.first.first])
            if (c.first == e.first.second)
                c.second--;
        for (auto &c: G[e.first.second])
            if (c.first == e.first.first)
                c.second--;
        KK--;
    }
    ans = get();
//    cout << ans << "\n";
    int l = -1, r = (int) 2e9;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        D = mid / 2;
        if ((mid % 2 == 0 && checkV()) ||
            (mid % 2 == 1 && get() <= mid))
            r = mid;
        else    
            l = mid;
    }
    cout << r;
    return 0;
}