#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = (int) 1e5 * 2 + 10;

int t[8 * N], add[8 * N];

void push(int v, int l, int r) {
    if (add[v] == 0) return;
    t[v] += add[v];
    if (l != r)
        add[v * 2] += add[v], add[v * 2 + 1] += add[v];
    add[v] = 0;
}

void update(int v, int l, int r, int tl, int tr, int val) {
    push(v, l, r);
    if (l > tr || r < tl) return;
    if (l >= tl && r <= tr) {
        add[v] += val;
        push(v, l, r);
        return;
    }
    int mid = (l + r) / 2;
    update(v * 2, l, mid, tl, tr, val), update(v * 2 + 1, mid + 1, r, tl, tr, val);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

int get_max(int v, int l, int r, int tl, int tr) {
    push(v, l, r);
    if (l > tr || r < tl)
        return -(int) 1e18;
    if (l >= tl && r <= tr)
        return t[v];
    return max(get_max(v * 2, l, (l + r) / 2, tl, tr),
               get_max(v * 2 + 1, (l + r) / 2 + 1, r, tl, tr));
}

struct Edge {
    int to, w, ind;

    Edge() : to(0), w(0), ind(0) {};

    Edge(int _to, int _w, int _ind) : to(_to), w(_w), ind(_ind) {};
};

vector<Edge> g[N];
vector<pair<int, int>> G[N];
vector<pair<int, int>> edges;
vector<bool> taken[N];

int n, K, mx[N], dist[N], tin[N], tout[N], timer;
int D, cur_cnt;

int dfs(int v, int p, int ind) {
    tin[v] = timer++;
    mx[v] = dist[v];
    for (auto [to, cost, index]: g[v])
        if (to != p)
            dist[to] = dist[v] + 1,
                    mx[v] = max(mx[v], dfs(to, v, index));
    if (ind != -1) taken[ind].emplace_back(false);
    if (ind != -1 && mx[v] - D >= dist[v])
        taken[ind].back() = true, cur_cnt++;
    tout[v] = timer++;
    update(1, 0, 2 * N - 1, tin[v], tin[v], dist[v]);
    update(1, 0, 2 * N - 1, tout[v], tout[v], dist[v]);
    return mx[v];
}

int find_max(int tl, int tr) {
    if (tr < tl) return -(int) 1e18;
    return get_max(1, 0, 2 * N - 1, tl, tr);
}

int get_max(int tl, int tr) {
    return max(find_max(0, tl - 1), find_max(tr + 1, 2 * N - 1));
}

void update(int tl, int tr, int val) {
    if (tl > 0) update(1, 0, 2 * N - 1, 0, tl - 1, val);
    if (tr < 2 * N - 1) update(1, 0, 2 * N - 1, tr + 1, 2 * N - 1, val);
}

bool goV(int v, int p) {
    if (cur_cnt <= K)
        return true;
    for (auto [to, cost, i]: g[v]) {
        if (to == p) continue;
        update(tin[to], tout[to], 1);
        update(1, 0, 2 * N - 1, tin[to], tout[to], -1);
        if (!taken[i].empty() && taken[i].back()) cur_cnt--;
        taken[i].emplace_back(false);
        if (get_max(tin[to], tout[to]) >= D + 1)
            taken[i].back() = true;
        if (taken[i].back()) cur_cnt++;
        if (goV(to, v)) {
            update(tin[to], tout[to], -1);
            update(1, 0, 2 * N - 1, tin[to], tout[to], 1);
            return true;
        }
        update(tin[to], tout[to], -1);
        update(1, 0, 2 * N - 1, tin[to], tout[to], 1);
        if (taken[i].back()) cur_cnt--;
        taken[i].pop_back();
        if (!taken[i].empty() && taken[i].back()) cur_cnt++;
    }
    return false;
}

bool checkV() {
    cur_cnt = timer = 0, dfs(0, -1, -1);
    return goV(0, -1);
}

pair<int, int> farthest(int v, int p) {
    int res = v, cur = 0;
    for (auto [u, cost]: G[v]) {
        if (u == p) continue;
        auto vis = farthest(u, v);
        if (vis.second + cost > cur) {
            cur = vis.second + cost;
            res = vis.first;
        }
    }
    return {res, cur};
}

vector<pair<pair<int, int>, int>> diam;

bool to_go(int v, int p, int go) {
    if (v == go) return true;
    for (auto [u, cost]: G[v]) {
        if (u == p) continue;
        diam.push_back({{v, u}, cost});
        if (to_go(u, v, go))
            return true;
        diam.pop_back();
    }
    return false;
}

int get() {
    int v = farthest(0, -1).first;
    auto vis = farthest(v, -1);
    int u = vis.first, cost = vis.second;
    diam.clear(), to_go(v, -1, u);
    return cost;
}

bool checkE() {

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> K;
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        G[u - 1].emplace_back(v - 1, w);
        G[v - 1].emplace_back(u - 1, w);
        g[u - 1].emplace_back(v - 1, w, i);
        g[v - 1].emplace_back(u - 1, w, i);
        edges.emplace_back(u - 1, v - 1);
    }
    int KK = K, ans;
    while (KK > 0) {
        int cost = get();
        if (cost == 0) break;
        vector<pair<pair<int, int>, int>> ones;
        for (auto e: diam)
            if (e.second > 0)
                ones.emplace_back(e);
        auto e = ones[(int) ones.size() / 2];
        for (auto &c: G[e.first.first])
            if (c.first == e.first.second)
                c.second--;
        for (auto &c: G[e.first.second])
            if (c.first == e.first.first)
                c.second--;
        KK--;
    }
    ans = get();
//    cout << ans << "\n";
    int l = -1, r = (int) 2e9;
    while (r - l > 1) {
        for (int i = 0; i < n - 1; i++) taken[i].clear();
        int mid = (l + r) / 2;
        D = mid / 2;
        if ((mid % 2 == 0 && checkV()) ||
            (mid % 2 == 1 && ans <= mid))
            r = mid;
        else
            l = mid;
        for (int i = 0; i < n; i++)
            update(1, 0, 2 * N - 1, tin[i], tin[i], -dist[i]);
        for (int i = 0; i < n; i++)
            update(1, 0, 2 * N - 1, tout[i], tout[i], -dist[i]);
    }
    cout << r;
    return 0;
}