#include <bits/stdc++.h>

using namespace std;

const int N = (int) 1e5 * 2 + 10;

int t[8 * N], add[8 * N];

void push(int v, int l, int r) {
    if (add[v] == 0) return;
    t[v] += add[v];
    if (l != r)
        add[v * 2] += add[v], add[v * 2 + 1] += add[v];
    add[v] = 0;
}

void update(int v, int l, int r, int tl, int tr, int val) {
    push(v, l, r);
    if (l > tr || r < tl) return;
    if (l >= tl && r <= tr) {
        add[v] += val;
        push(v, l, r);
        return;
    }
    int mid = (l + r) / 2;
    update(v * 2, l, mid, tl, tr, val), update(v * 2 + 1, mid + 1, r, tl, tr, val);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

int get_max(int v, int l, int r, int tl, int tr) {
    push(v, l, r);
    if (l > tr || r < tl)
        return -(int) 1e9;
    if (l >= tl && r <= tr)
        return t[v];
    return max(get_max(v * 2, l, (l + r) / 2, tl, tr),
               get_max(v * 2 + 1, (l + r) / 2 + 1, r, tl, tr));
}

struct Edge {
    int to, w, ind;

    Edge() : to(0), w(0), ind(0) {};

    Edge(int _to, int _w, int _ind) : to(_to), w(_w), ind(_ind) {};
};

vector<Edge> g[N];
vector<pair<int, int>> edges;
vector<bool> taken[N];

int n, K, mx[N], dist[N], tin[N], tout[N], timer;
int D, cur_cnt;

int one;

void precalc(int v, int p) {
    tin[v] = timer++;
    mx[v] = dist[v];
    for (auto [to, cost, index]: g[v]) {
        if (to != p) {
            dist[to] = dist[v] + 1;
            precalc(to, v);
            mx[v] = max(mx[v], mx[to]);
        }
    }
    tout[v] = timer++;
    update(1, 0, 2 * N - 1, tin[v], tin[v], dist[v]);
    update(1, 0, 2 * N - 1, tout[v], tout[v], dist[v]);
}

void dfs(int v, int p, int ind) {
    for (auto [to, cost, index]: g[v])
        if (to != p)
            dfs(to, v, index);
    if (ind != -1) taken[ind].emplace_back(false);
    if (ind != -1 && mx[v] - D >= dist[v])
        taken[ind].back() = true, cur_cnt++;
}

int find_max(int tl, int tr) {
    if (tr < tl) return -(int) 1e9;
    return get_max(1, 0, 2 * N - 1, tl, tr);
}

int get_max(int tl, int tr) {
    return max(find_max(0, tl - 1), find_max(tr + 1, 2 * N - 1));
}

void update(int tl, int tr, int val) {
    if (tl > 0) update(1, 0, 2 * N - 1, 0, tl - 1, val);
    if (tr < 2 * N - 1) update(1, 0, 2 * N - 1, tr + 1, 2 * N - 1, val);
}

bool goV(int v, int p) {
    if (cur_cnt <= K)
        return true;
    for (auto [to, cost, i]: g[v]) {
        if (to == p) continue;
        update(tin[to], tout[to], 1);
        update(1, 0, 2 * N - 1, tin[to], tout[to], -1);
        if (!taken[i].empty() && taken[i].back()) cur_cnt--;
        taken[i].emplace_back(false);
        if (get_max(tin[to], tout[to]) >= D + 1)
            taken[i].back() = true;
        if (taken[i].back()) cur_cnt++;
        if (goV(to, v)) {
            update(tin[to], tout[to], -1);
            update(1, 0, 2 * N - 1, tin[to], tout[to], 1);
            return true;
        }
        update(tin[to], tout[to], -1);
        update(1, 0, 2 * N - 1, tin[to], tout[to], 1);
        if (taken[i].back()) cur_cnt--;
        taken[i].pop_back();
        if (!taken[i].empty() && taken[i].back()) cur_cnt++;
    }
    return false;
}

bool checkV() {
    cur_cnt = 0, dfs(one, -1, -1);
    return goV(one, -1);
}

void gfs(int v, int p, int ind) {
    if (p != one && v != one) {
        if (ind != -1)
            taken[ind].emplace_back(false);
        if (ind != -1 &&
            get_max(1, 0, 2 * N - 1, tin[v], tout[v]) - D >=
            get_max(1, 0, 2 * N - 1, tin[v], tin[v]))
            taken[ind].back() = true, cur_cnt++;
    }
    for (auto [to, cost, i]: g[v]) {
        if (to != p)
            gfs(to, v, i);
    }
}

bool goE(int v, int p, int i) {
    if (cur_cnt <= K)
        return true;
    for (auto [to, cost, ind]: g[v]) {
        if (to == p) continue;
        update(tin[v], tout[v], 1);
        update(1, 0, 2 * N - 1, tin[to], tout[to], -1);
        taken[i].emplace_back(false);
        if (get_max(tin[v], tout[v]) >= D + 1)
            taken[i].back() = true;
        if (taken[i].back()) cur_cnt++;
        if (!taken[ind].empty() && taken[ind].back()) cur_cnt--;
        taken[ind].emplace_back(false);
        if (goE(to, v, ind)) {
            update(tin[v], tout[v], -1);
            update(1, 0, 2 * N - 1, tin[to], tout[to], 1);
            return true;
        }
        taken[ind].pop_back();
        if (!taken[ind].empty() && taken[ind].back()) cur_cnt++;
        update(tin[v], tout[v], -1);
        update(1, 0, 2 * N - 1, tin[to], tout[to], 1);
        if (taken[i].back()) cur_cnt--;
        taken[i].pop_back();
    }
    return false;
}

bool checkE() {
    int to = g[one][0].to;
    update(1, 0, 2 * N - 1, tin[to], tout[to], -1);
    cur_cnt = 0, gfs(to, one, -1);
    bool good = goE(to, one, g[one][0].ind);
    update(1, 0, 2 * N - 1, tin[to], tout[to], 1);
    return good;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> K;
    for (int i = 0; i < n - 1; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u - 1].emplace_back(v - 1, w, i);
        g[v - 1].emplace_back(u - 1, w, i);
        edges.emplace_back(u - 1, v - 1);
    }
    if (K >= n - 1) {
        cout << 0;
        return 0;
    }
    for (int i = 0; i < n; i++)
        if ((int) g[i].size() == 1)
            one = i;
    precalc(one, -1);
    int l = -1, r = (int) 2e5;
    while (r - l > 1) {
        for (int i = 0; i < n - 1; i++) taken[i].clear();
        int mid = (l + r) / 2;
        D = mid / 2;
        if ((mid % 2 == 0 && checkV()) ||
            (mid % 2 == 1 && checkE()))
            r = mid;
        else
            l = mid;
    }
    cout << r;
    return 0;
}