#include "soft_drinks.h"
#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>

using namespace std;

int n;
vector<pair<int, int>> d;

void init(const std::vector<int>& A, const std::vector<int>& B) {
	n = A.size();
	d.resize(n);
	for (int i = 0; i < n; ++i) d[i] = {A[i], B[i]};
	sort(d.begin(), d.end());
}

double friendDrink(int Ma, int Mb, int La, int Ra) {
	if (La != 0) exit(1);
	return (1.0 * Mb) / d[0].second;
}

#ifdef LOCAL
int main() {
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);

	int n, q;
	std::cin >> n >> q;

	std::vector<int> A(n), B(n);
	for (int i = 0; i < n; i ++) {
		std::cin >> A[i] >> B[i];
	}
	init(A, B);

	for (int i = 0; i < q; i ++) {
		int a, b, l, r;
		std::cin >> a >> b >> l >> r;
		const auto ret = friendDrink(a, b, l, r);
		std::cout << ret << "\n";
	}

	return 0;
}
#endif