#include "soft_drinks.h"
#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>

using namespace std;

int n;
vector<pair<int, int>> d;

void init(const std::vector<int>& A, const std::vector<int>& B) {
	n = A.size();
	d.resize(n);
	for (int i = 0; i < n; ++i) d[i] = {A[i], B[i]};
	sort(d.begin(), d.end());
}

double friendDrink(int Ma, int Mb, int La, int Ra) {
	double ans = 0;
	for (auto e : d) {
		if (La > e.first || Ra < e.first) continue;
		double t = -1;
		if (e.first != 0) {
			if (t > Ma * 1.0 / e.first || t == -1) {
				t = Ma * 1.0 / e.first;
			}
		}
		if (e.second != 0) {
			if (t > Mb * 1.0 / e.second || t == -1) {
				t = Mb * 1.0 / e.second;
			}
		}
		ans = max(ans, t);
	}
	for (auto e : d) {
		if (La > e.first || Ra < e.first) continue;
		for (auto i : d) {
			if (La > i.first || Ra < i.first) continue;
			if (i <= e) continue;
			double l1 = 0, r1 = 1;
			auto check = [&](double x) -> double {
				pair<double, double> t2 = {e.first * x + i.first * (1 - x), e.second * x + i.second * (1 - x)};
				double t = -1;
				if (e.first != 0) {
					if (t > Ma * 1.0 / t2.first || t == -1) {
						t = Ma * 1.0 / t2.first;
					}
				}
				if (e.second != 0) {
					if (t > Mb * 1.0 / t2.second || t == -1) {
						t = Mb * 1.0 / t2.second;
					}
				}
				return t;
			};
			for (int i = 0; i < 100; ++i) {
				double m1 = (l1 + l1 + r1) / 3, m2 = (l1 + r1 + r1) / 3;
				if (check(m1) < check(m2)) l1 = m1;
				else r1 = m2;
			}
			ans = max(ans, check(l1));
		}
	}
	return ans;
}

#ifdef LOCAL
int main() {
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
	std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);

	int n, q;
	std::cin >> n >> q;

	std::vector<int> A(n), B(n);
	for (int i = 0; i < n; i ++) {
		std::cin >> A[i] >> B[i];
	}
	init(A, B);

	for (int i = 0; i < q; i ++) {
		int a, b, l, r;
		std::cin >> a >> b >> l >> r;
		const auto ret = friendDrink(a, b, l, r);
		std::cout << ret << "\n";
	}

	return 0;
}
#endif