#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int INF = 2e9 + 100;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<vector<pair<int, int>>> gr(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        gr[u].push_back({v, w});
        gr[v].push_back({u, w});
    }
    int s = 0;
    {
        vector<int> d(n, INF);
        d[0] = 0;
        vector<int> cur;
        cur.push_back(0);
        while (cur.size()) {
            int v = cur.back();
            cur.pop_back();
            for (auto e : gr[v]) {
                int u = e.first, w = e.second;
                if (d[v] + w < d[u]) {
                    d[u] = d[v] + w;
                    cur.push_back(u);
                }
            }
        }
        for (int i = 0; i < n; ++i) if (d[i] > d[s]) s = i;
    }
    vector<int> d(n, INF);
    d[s] = 0;
    vector<int> cur;
    cur.push_back(s);
    while (cur.size()) {
        int v = cur.back();
        cur.pop_back();
        for (auto e : gr[v]) {
            int u = e.first, w = e.second;
            if (d[v] + w < d[u]) {
                d[u] = d[v] + w;
                cur.push_back(u);
            }
        }
    }
    cout << *max_element(d.begin(), d.end()) - k << '\n';
}

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    solve();
}