#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int INF = 2e9 + 100;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<vector<pair<int, int>>> gr(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        gr[u].push_back({v, w});
        gr[v].push_back({u, w});
    }
    int s = 0;
    {
        vector<int> d(n, INF);
        d[0] = 0;
        vector<int> cur;
        cur.push_back(0);
        while (cur.size()) {
            int v = cur.back();
            cur.pop_back();
            for (auto e : gr[v]) {
                int u = e.first, w = e.second;
                if (d[v] + w < d[u]) {
                    d[u] = d[v] + w;
                    cur.push_back(u);
                }
            }
        }
        for (int i = 0; i < n; ++i) if (d[i] > d[s]) s = i;
    }
    int mxd = 0;
    {
        vector<int> d(n, INF);
        vector<int> p(n);
        d[s] = 0;
        vector<int> cur;
        cur.push_back(s);
        while (cur.size()) {
            int v = cur.back();
            cur.pop_back();
            for (auto e : gr[v]) {
                int u = e.first, w = e.second;
                if (d[v] + w < d[u]) {
                    p[u] = v;
                    d[u] = d[v] + w;
                    cur.push_back(u);
                }
            }
        }
        int l = 0;
        for (int i = 0; i < n; ++i) if (d[i] > d[l]) l = i;
        mxd = d[l];
        while (l != s) {
            for (auto &e : gr[p[l]]) {
                if (e.first == l) {
                    swap(e, gr[p[l]].back());
                    gr[p[l]].pop_back();
                    break;
                }
            }
            for (auto &e : gr[l]) {
                if (e.first == p[l]) {
                    swap(e, gr[l].back());
                    gr[l].pop_back();
                    break;
                }
            }
            l = p[l];
        }
    }
    int mxd2 = 0;
    vector<int> d(n, INF);
    vector<int> d2(n, INF);
    for (int i = 0; i < n; ++i) {
        if (d[i] < INF) continue;
        vector<int> cur2;
        d[i] = 0;
        vector<int> cur;
        cur.push_back(i);
        while (cur.size()) {
            int v = cur.back();
            cur2.push_back(v);
            cur.pop_back();
            for (auto e : gr[v]) {
                int u = e.first, w = e.second;
                if (d[v] + w < d[u]) {
                    d[u] = d[v] + w;
                    cur.push_back(u);
                }
            }
        }
        int l = i;
        for (auto e : cur2) {
            if (d[e] > d[l]) l = e;
        }
        swap(d, d2);
        d[l] = 0;
        cur.push_back(l);
        while (cur.size()) {
            int v = cur.back();
            cur.pop_back();
            for (auto e : gr[v]) {
                int u = e.first, w = e.second;
                if (d[v] + w < d[u]) {
                    d[u] = d[v] + w;
                    cur.push_back(u);
                }
            }
        }
        swap(d, d2);
    }
    mxd2 = *max_element(d2.begin(), d2.end());
    if (mxd2 == mxd) cout << mxd << '\n';
    else cout << mxd - k << '\n';
}

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    solve();
}