#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int INF = 2e9 + 100;
vector<vector<int>> gr;
int n, m, k;
vector<vector<int>> dp; // минимальное количество ребер чтобы максимальный путь снизу в i был длины не больше чем j

void dfs(int v, int pr) {
    for (auto e : gr[v]) {
        if (e == pr) continue;
        dfs(e, v);
        vector<int> olddp = dp[v];
        for (int d1 = 0; d1 <= m; ++d1) {
            int d2 = min(d1, m - d1);
            dp[v][d1] += dp[e][d2] + 1;
            if (d2) dp[v][d1] = min(dp[v][d1], olddp[d1] + dp[e][d2 - 1]);
        }
        for (int d1 = 0; d1 <= m; ++d1) {
            int d2 = m - d1;
            dp[v][max(d1, d2)] = min(dp[v][max(d1, d2)], olddp[d1] + dp[e][d2] + 1);
            if (d2) dp[v][max(d1, d2)] = min(dp[v][max(d1, d2)], olddp[d1] + dp[e][d2 - 1]);
            if (d1) dp[v][max(d1, d2)] = min(dp[v][max(d1, d2)], olddp[d1 - 1] + dp[e][d2]);
        }
    }
}

bool check() {
    dp.clear();
    dp.resize(n, vector<int>(m + 1));
    dfs(0, -1);
    return dp[0][m] <= k;
}

void solve() {
    cin >> n >> k;
    gr.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    if (k >= n - 1) {
        cout << "0\n";
        return;
    }
    int l = 0, r = n - 1;
    while (r - l > 1) {
        m = (l + r) / 2;
        if (check()) r = m;
        else l = m;
    }
    cout << r << '\n';
}

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    solve();
}