﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <array>
#include <random>
#include <queue>

#include "cycles.h"
using namespace std;
typedef long long ll;
typedef long double ld;
mt19937 rng(1432);

void make(vector<int> a) {
	if (a.size() <= 1) return;
	int n = a.size();
	int i = rng() % n, j = rng() % n;
	while (i == j) j = rng() % n;
	int cnt = performSwap(a[i], a[j]);
	vector<int> b = {a[i]}, c = {a[j]};
	for (int k : a) {
		if (k != a[i] && k != a[j]) {
			int x = performSwap(k, a[i]);
			if (x > cnt) b.push_back(k);
			else c.push_back(k);
			performSwap(k, a[i]);
		}
	}
	make(b);
	make(c);
}

void sortPermutation(int n) {
	int cnt = performSwap(0, 1);
	for (int i = 0; i + 1 < n; i++) {
		int x = performSwap(i, i + 1);
		if (x > cnt) {
			x = performSwap(i, i + 1);
		}
		cnt = x;
	}
	vector<int> a(n);
	for (int i = 0; i < n; i++) a[i] = i;
	make(a);
}

//int main() {
//	ios_base::sync_with_stdio(0);
//	cin.tie(0);
//	cout.tie(0);
//
//	return 0;
//}