﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <array>
#include <random>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
mt19937 rng(1432);
const ll N = 2e5 + 20;
ll n, k;
vector<pair<ll, ll>> g[N];
vector<ll> h[N];
ll dfs(ll v, ll p, ll d, ll& cnt) {
	h[v].clear();
	for (auto r : g[v]) {
		ll u = r.first, w = r.second;
		if (u == p) continue;
		h[v].push_back(dfs(u, v, d, cnt) + w);
	}
	sort(h[v].rbegin(), h[v].rend());
	if (h[v].size() == 1) {
		cnt -= h[v][0] - min(h[v][0], d);
		return min(h[v][0], d);
	} else if (h[v].size() >= 2) {
		if (h[v][1] * 2 >= d) {
			cnt -= h[v][0] - min(h[v][0], (d + 1) / 2);
			h[v][0] = min(h[v][0], (d + 1) / 2);
			for (int i = 1; i < h[v].size(); i++) {
				cnt -= h[v][i] - min(h[v][i], d / 2);
				h[v][i] = min(h[v][i], d / 2);
			}
		} else {
			cnt -= h[v][0] - min(h[v][0], d - h[v][1]);
			h[v][0] = min(h[v][0], d - h[v][1]);
		}
		return h[v][0];
	}
	return 0;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> k;
	for (ll i = 0; i < n - 1; i++) {
		ll u, v, w;
		cin >> u >> v >> w;
		g[u].push_back({v, w});
		g[v].push_back({u, w});
	}
	ll l = -1, r = 2e9;
	while (l + 1 < r) {
		ll m = (l + r) / 2;
		ll cnt = k;
		dfs(1, 0, m, cnt);
		if (cnt >= 0) r = m;
		else l = m;
	}
	cout << r << "\n";
	return 0;
}