﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cmath>
#include <array>
#include <random>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
mt19937 rng(1432);
const ll N = 2e5 + 20;
ll n, k, p[N], nom[N];
vector<pair<ll, ll>> g[N];
ll h[N];
vector<ll> top;
void predfs(ll v, ll pr) {
	p[v] = pr;
	nom[v] = 0;
	for (auto u : g[v]) {
		if (u.first != pr) {
			predfs(u.first, v);
			nom[v]++;
		}
	}
	top.push_back(v);
}
void dfs(ll v, ll p, ll d, ll& cnt) {
	ll mx1u = -1, mx2u = -1;
	for (auto r : g[v]) {
		ll u = r.first, w = r.second;
		if (u == p) continue; 
		dfs(u, v, d, cnt);
		h[u] += w;
		if (mx1u == -1 || h[u] > h[mx1u]) {
			mx2u = mx1u;
			mx1u = u;
		} else if (mx2u == -1 || h[u] > h[mx2u]) {
			mx2u = u;
		}
	}
	if (mx1u >= 0 && mx2u == -1) {
		cnt -= h[mx1u] - min(h[mx1u], d);
		h[v] = min(h[mx1u], d);
		return;
	} else if (mx2u >= 0) {
		if (h[mx2u] * 2 >= d) {
			cnt -= h[mx1u] - min(h[mx1u], (d + 1) / 2);
			h[mx1u] = min(h[mx1u], (d + 1) / 2);
			for (auto r : g[v]) {
				ll u = r.first, w = r.second;
				if (u == p) continue;
				cnt -= h[u] - min(h[u], d / 2);
				h[u] = min(h[u], d / 2);
			}
		} else {
			cnt -= h[mx1u] - min(h[mx1u], d - h[mx2u]);
			h[mx1u] = min(h[mx1u], d - h[mx2u]);
		}
		h[v] = h[mx1u];
		return;
	}
	h[v] = 0;
	return;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> k;
	for (ll i = 0; i < n - 1; i++) {
		ll u, v, w;
		cin >> u >> v >> w;
		g[u].push_back({v, w});
		g[v].push_back({u, w});
	}
	predfs(1, 0);
	ll l = -1, r = 2e9;
	while (l + 1 < r) {
		ll m = (l + r) / 2;
		ll cnt = k;
		dfs(1, 0, m, cnt);
		if (cnt >= 0) r = m;
		else l = m;
	}
	cout << r << "\n";
	return 0;
}