#include <bits/stdc++.h>
#include "soft_drinks.h"

using namespace std;

struct Sparse_table{
    vector<vector<pair<long long, long long>>> ans;
    Sparse_table() {}
    Sparse_table(vector<pair<long long, long long>> &v) {
        long long n = v.size();
        ans.resize(__lg(n) + 1, vector<pair<long long, long long>> (n));
        for (long long i = 0; i < n; i++) {
            ans[0][i] = {v[i].second, i};
        }
        for (long long i = 1; i <= __lg(n); i++) {
            for (long long j = 0; (j + (1 << i)) <= n; j++) {
                ans[i][j] = min(ans[i - 1][j], ans[i - 1][j + (1 << (i - 1))]);
            }
        }
    }
    pair<long long, long long> get_min(long long l, long long r) {
        return min(ans[__lg(r - l)][l], ans[__lg(r - l)][r - (1 << (__lg(r - l)))]);
    }
};

vector<pair<long long, long long>> v;
vector<vector<long long>> binupl, binupr;
Sparse_table mn;

#define st1 st.back().first
#define st2 st[st.size() - 2].first

void init(const std::vector<int>& A, const std::vector<int>& B) {
    //swap(A, B);
    long long n = A.size();
    v.resize(n);
    binupl.resize(__lg(n) + 1, vector<long long> (n, -1));
    binupr.resize(__lg(n) + 1, vector<long long> (n, -1));
    for (long long i = 0; i < n; i++) {
        v[i] = {A[i], B[i]};
    }
    sort(v.begin(), v.end());
    mn = Sparse_table(v);
    vector<pair<pair<long long, long long>, long long>> st;
    for (long long i = 0; i < n; i++) {
        if (st.size() > 0 && st1.second <= v[i].second) continue;
        while (st.size() > 1 && (st2.first - st1.first) * (st1.second - v[i].second) < (st1.first - v[i].first) * (st2.second - st1.second)) {
            st.pop_back();
        }
        //cout << i << " " << st.size() << "\n";
        for (long long j = 0; (1 << j) <= st.size(); j++) {
            binupl[j][i] = st[st.size() - (1 << j)].second;
        }
        if (st.size() > 0) {
            //cout << binupl[0][i] << " " << st[st.size() - 1].second << "\n";
        }
        st.push_back({v[i], i});
    }
    st.clear();
    for (long long i = n - 1; i >= 0; i--) {
        while (st.size() > 0 && st1.second >= v[i].second) st.pop_back();
        while (st.size() > 1 && (st2.first - st1.first) * (st1.second - v[i].second) > (st1.first - v[i].first) * (st2.second - st1.second)) {
            st.pop_back();
        }
        for (long long j = 0; (1 << j) <= st.size(); j++) {
            binupr[j][i] = st[st.size() - (1 << j)].second;
        }
        st.push_back({v[i], i});
    }
}

double ans(int Ma, int Mb, int La, int Ra) {
    //cout << "que\n";
    long long n = v.size();
    long long x = lower_bound(v.begin(), v.end(), make_pair((long long)La, 0ll)) - v.begin();
    long long ri = lower_bound(v.begin(), v.end(), make_pair(Ra + 1ll, 0ll)) - v.begin();
    if (x == ri) return 0;
    long long y = mn.get_min(x, ri).second;
    if (Ma == 0) {
        if (v[x].first > 0) return 0;
        return ((Mb + 0.0) / (v[x].second));
    }
    if (Mb == 0) {
        if (v[y].second > 0) return 0;
        return ((Ma + 0.0) / v[y].first);
    }
    if (v[x].first * Mb >= v[x].second * Ma) {
        return ((Ma + 0.0) / v[x].first);
    }
    if (v[y].first * Mb <= v[y].second * Ma) {
        return ((Mb + 0.0) / (v[y].second));
    }
    //cout << "aa\n";
    for (long long i = __lg(n); i >= 0; i--) {
        long long nx = binupr[i][x];
        if (nx == -1) continue;
        if (v[nx].first > Ra) continue;
        if (v[nx].first * Mb > v[nx].second * Ma) continue;
        x = nx;
    }
    for (long long i = __lg(n); i >= 0; i--) {
        long long ny = binupl[i][y];
        if (ny == -1) continue;
        if (v[ny].first < La) continue;
        if (v[ny].first * Mb < v[ny].second * Ma) continue;
        y = ny;
    }
    //cout << x << " " << y << "\n";
    //cout << binupr[0][x] << " " << binupl[0][y] << "\n";
    if (x == y) {
        return ((Ma + 0.0l) / v[x].first);
    }
    long double k1 = ((Mb + 0.0l) / Ma);
    long double k2 = (((v[x].second - v[y].second + 0.0l) / (v[x].first - v[y].first)));
    long double c = (v[x].second - k2 * v[x].first);
    long double ansa = c / (k1 - k2);
    return Ma / ansa;
}


double friendDrink(int Ma, int Mb, int La, int Ra) {
    vector<pair<long long, long long>> v1 = v;
    long long x = lower_bound(v.begin(), v.end(), make_pair((long long)La, 0ll)) - v.begin();
    long long ri = lower_bound(v.begin(), v.end(), make_pair(Ra + 1ll, 0ll)) - v.begin();
    v.clear();
    binupl.clear();
    binupr.clear();
    vector<int> a, b;
    for (int i = x; i < ri; i++) {
        a.push_back(v1[i].first);
        b.push_back(v1[i].second);
    }
    init(a, b);
    double lans = ans(Ma, Mb, La, Ra);
    v = v1;
    return lans;
}