#include <vector>
#include <algorithm>

using namespace std;

constexpr int INF = 1e9 + 7;

int n;

vector<int> a, b;

void init(const vector<int>& A, const vector<int>& B) {
    n = A.size();
    a = A, b = B;
}

double friendDrinkPart(const int Ma, const int Mb, vector<pair<int, int>> nw) {
    sort(nw.begin(), nw.end());
    int pos = 0;
    int mn_b = INF;
    while (pos < (int)nw.size() && nw[pos].first == 0) {
        mn_b = min(mn_b, nw[pos].second);
        pos++;
    }
    if (pos == nw.size()) {
        return Mb / (double)mn_b;
    }
    double ans = Ma / (double)nw[pos].first;
    if (pos != 0) {
        ans += Mb / (double)mn_b;
    }
    while (pos + 1 < (int)nw.size()) {
        pos++;
        double y1 = 1 / (double)nw[pos].first;
        double y2 = 0;
        for (int i = 0; i < pos; ++i) {
            if (nw[i].second == 0) {
                y2 = INF;
                break;
            }
            y2 = max(y2, (1 - y1 * nw[i].first) / nw[i].second);
        }
        if (y2 >= INF - 1) {
            break;
        }
        ans = min(ans, Ma / (double)nw[pos].first + Mb * y2);
    }
    return ans;
}

double friendDrink(const int Ma, const int Mb, const int La, const int Ra) {
    vector<pair<int, int>> nw;
    for (int i = 0; i < n; ++i) {
        if (La <= a[i] && a[i] <= Ra) {
            nw.emplace_back(a[i], b[i]);
        }
    }
    double ans = friendDrinkPart(Ma, Mb, nw);
    for (int i = 0; i < (int)nw.size(); ++i) {
        swap(nw[i].first, nw[i].second);
    }
    ans = min(ans, friendDrinkPart(Mb, Ma, nw));
    return ans;
}
