#include <vector>
#include <assert.h>

#include "cycles.h"

using namespace std;

void sortRecursive(int l, int r) {
    if (r - l <= 2) {
        performSwap(0, 1);
        int cnt_nw = performSwap(0, 1);
        for (int i = l + 1; i < r; ++i) {
            for (int j = l; j < i; ++j) {
                int val_nw = performSwap(i, j);
                if (val_nw > cnt_nw) {
                    cnt_nw = val_nw;
                    break;
                }
                performSwap(i, j);
            }
        }
        return;
    }
    int m = (l + r) / 2;
    sortRecursive(l, m);
    sortRecursive(m, r);
    int cnt_nw = 0;
    for (int i = l + 1; i < m; ++i) {
        cnt_nw = performSwap(l, i);
    }
    vector<pair<int, int>> lr(r);
    for (int i = m; i < r; ++i) {
        int vl = performSwap(l, i);
        performSwap(l, i);
        if (vl > cnt_nw) {
            lr[i] = make_pair(l - 1, m - 1);
        } else {
            lr[i] = make_pair(-1, -1);
        }
    }
    for (int i = m - 1; i > l; --i) {
        cnt_nw = performSwap(l, i);
    }
    while (true) {
        vector<vector<int>> qs(m);
        bool check = false;
        for (int i = m; i < r; ++i) {
            if (lr[i].second > lr[i].first + 1) {
                qs[lr[i].first + (lr[i].second - lr[i].first + 3) / 4].push_back(i);
                check = true;
            }
        }
        if (!check) {
            break;
        }
        for (int nw = l; nw + 1 < m; ++nw) {
            for (auto ind : qs[nw]) {
                int vl = performSwap(l, ind);
                performSwap(l, ind);
                if (vl > cnt_nw) {
                    lr[ind].second = nw;
                } else {
                    lr[ind].first = nw;
                    if (lr[ind].second > lr[ind].first + 1) {
                        qs[(lr[ind].first + lr[ind].second) / 2].push_back(ind);
                    }
                }
            }
            cnt_nw = performSwap(l, nw + 1);
        }
        for (int nw = m - 1; nw > l; --nw) {
            cnt_nw = performSwap(l, nw);
        }
    }
    for (int i = m; i < r; ++i) {
        if (lr[i].second != -1) {
            performSwap(lr[i].second, i);
        }
    }
}

void sortPermutation(int n) {
    sortRecursive(0, n);
}
