#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

constexpr int maxn = 2e5 + 5;

vector<int> g[maxn];

vector<int> add[maxn];

void calc_dp(int v, int pr, int mx_d) {
    add[v].clear();
    for (auto u : g[v]) {
        if (u != pr) {
            calc_dp(u, v, mx_d);
            if (add[u].size() > add[v].size()) {
                swap(add[u], add[v]);
            }
        }
    }
    if (add[v].empty()) {
        add[v] = {0};
    } else {
        add[v].push_back(add[v].back() + 1);
        add[v].rbegin()[1] = -1;
    }
    for (auto u : g[v]) {
        if (u != pr && !add[u].empty()) {
            vector<pair<int, pair<int, int>>> scanline;
            int cnt_nw = 0;
            for (int l = 0; l < (int)add[u].size() && l <= mx_d; ++l) {
                cnt_nw += add[u].rbegin()[l];
                int ll = l + 1, rr = min((int)add[v].size(), mx_d - l);
                if (ll < rr) {
                    scanline.emplace_back(ll, make_pair(1, cnt_nw));
                    scanline.emplace_back(rr, make_pair(-1, cnt_nw));
                }
                ll = l, rr = min((int)add[v].size(), mx_d - l + 1);
                if (ll < rr) {
                    scanline.emplace_back(ll, make_pair(1, cnt_nw + 1));
                    scanline.emplace_back(rr, make_pair(-1, cnt_nw));
                }
            }
            sort(scanline.begin(), scanline.end());
            int pos_prv = 0;
            multiset<int> adds;
            for (auto [p, addp] : scanline) {
                if (p == (int)add[v].size()) {
                    break;
                }
                if (p != pos_prv) {
                    add[v].rbegin()[pos_prv] += *adds.begin();
                    add[v].rbegin()[p] -= *adds.begin();
                }
                auto [tp, add_val] = addp;
                if (tp == 1) {
                    adds.insert(add_val);
                } else {
                    adds.erase(add_val);
                }
                pos_prv = p;
            }
            if (pos_prv < (int)add[v].size()) {
                add[v].rbegin()[pos_prv] += *adds.begin();
            }
        }
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    k = min(k, n - 1);
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int l = -1, r = n - 1;
    while (l < r - 1) {
        int m = (l + r) / 2;
        calc_dp(0, -1, m);
        int cnt_nw = 0;
        bool check = false;
        for (int i = 0; i <= m && i < (int)add[0].size(); ++i) {
            cnt_nw += add[0].rbegin()[i];
            if (cnt_nw <= k) {
                check = true;
                break;
            }
        }
        if (check) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << r << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
