#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

constexpr int maxn = 2e5 + 5;

vector<pair<int, int>> g[maxn];

map<int, pair<int, int>> dp[maxn];

void calc_dp1(int v, int pr) {
    dp[v][pr] = make_pair(0, 0);
    for (auto [u, w] : g[v]) {
        if (u != pr) {
            calc_dp1(u, v);
            dp[v][pr].second = max(dp[v][pr].second, dp[v][pr].first + dp[u][v].first + w);
            dp[v][pr].second = max(dp[v][pr].second, dp[u][v].second);
            dp[v][pr].first = max(dp[v][pr].first, dp[u][v].first + w);
        }
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }
    calc_dp1(0, -1);
    cout << dp[0][-1].second << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
