#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

constexpr int maxn = 2e5 + 5;

vector<pair<int, int>> g[maxn];

map<int, pair<int, int>> dp[maxn];

void calc_dp1(int v, int pr) {
    dp[v][pr] = make_pair(0, 0);
    for (auto [u, w] : g[v]) {
        if (u != pr) {
            calc_dp1(u, v);
            dp[v][pr].second = max(dp[v][pr].second, dp[v][pr].first + dp[u][v].first + w);
            dp[v][pr].second = max(dp[v][pr].second, dp[u][v].second);
            dp[v][pr].first = max(dp[v][pr].first, dp[u][v].first + w);
        }
    }
}

void calc_dp2(int v, int pr) {
    int mx1 = 0, mx2 = 0, mx3 = 0;
    int mxa1 = 0, mxa2 = 0;
    for (auto [u, w] : g[v]) {
        int nw = dp[u][v].first + w;
        if (nw > mx1) {
            mx3 = mx2;
            mx2 = mx1;
            mx1 = nw;
        } else if (nw > mx2) {
            mx3 = mx2;
            mx2 = nw;
        } else {
            mx3 = max(mx3, nw);
        }
        if (dp[u][v].second > mxa1) {
            mxa2 = mxa1;
            mxa1 = dp[u][v].second;
        } else {
            mxa2 = max(mxa2, dp[u][v].second);
        }
    }
    dp[v][-1] = make_pair(mx1, max(mxa1, mx1 + mx2));
    for (auto [u, w] : g[v]) {
        if (u != pr) {
            dp[v][u] = make_pair(0, 0);
            int nw = dp[u][v].first + w;
            if (nw == mx1) {
                dp[v][u].first = mx2;
                dp[v][u].second = mx2 + mx3;
            } else if (nw == mx2) {
                dp[v][u].first = mx1;
                dp[v][u].second = mx1 + mx3;
            } else {
                dp[v][u].first = mx1;
                dp[v][u].second = mx1 + mx2;
            }
            if (dp[u][v].second == mxa1) {
                dp[v][u].second = max(dp[v][u].second, mxa2);
            } else {
                dp[v][u].second = max(dp[v][u].second, mxa1);
            }
            calc_dp2(u, v);
        }
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n - 1; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }
    calc_dp1(0, -1);
    calc_dp2(0, -1);
    int d_nw = dp[0][-1].second;
    bool check = false;
    for (int i = 0; i < n; ++i) {
        bool check_nw = true;
        for (auto [j, w] : g[i]) {
            if (dp[j][i].second == d_nw) {
                check_nw = false;
                break;
            }
        }
        if (!check_nw) {
            continue;
        }
        vector<int> ds;
        for (auto [j, w] : g[i]) {
            ds.push_back(dp[j][i].first + w);
        }
        sort(ds.rbegin(), ds.rend());
        if (ds.size() <= 2) {
            check = true;
        } else if (ds[0] + ds[1] - 1 < d_nw && ds[1] + ds[2] < d_nw) {
            check = true;
        }
    }
    if (check) {
        cout << d_nw - 1 << '\n';
    } else {
        cout << d_nw << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
