#include <bits/stdc++.h>
#include <vector>
#include "soft_drinks.h"
#include <cassert>

using namespace std;
using ll = long long;

#define all(x) (x).begin(), (x).end()
#define pb push_back
#define sz(x) (int)(x).size()

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

vector<pair<ll, ll>> dr;
vector<int> id_s, id_oth;
vector<vector<int>> sp, sp_minB, sp_minA;

const int BB = 350;

vector<vector<double>> bestkoef;
vector<vector<int>> vh;
vector<vector<vector<ll>>> sp_pairs;

pair<ll, ll> cmp(pair<ll, ll> A, pair<ll, ll> B) {
    return (max(A.first, A.second) < max(B.first, B.second) ? A : B);
}

const double eps = 1e-6;

struct cht {
    struct line {
        double a, b;
    };
    double inter(line A, line B) {
        return (A.b - B.b) / (B.a - A.a);
    }
    vector<line> ls;
    vector<double> its;

    void add_line(line L) {
        while (!ls.empty() && abs(L.a - ls.back().a) < eps && L.b > ls.back().b) {
            ls.pop_back(); if (!its.empty()) its.pop_back();
        }
        while (ls.size() >= 2 && inter(ls.back(), L) < its.back()) {
            ls.pop_back(); its.pop_back();
        }
        ls.pb(L);
        if (ls.size() >= 2) its.pb(inter(ls.back(), ls.end()[-2]));
    }

    double get(double x) {
        assert(!ls.empty());
        int L = -1, R = sz(its);
        while (R - L > 1) {
            int M = (L + R) / 2;
            if (its[M] <= x) L = M;
            else R = M;
        }
        return ls[R].a * x + ls[R].b;
    }
};

struct segtree {
    int n;
    vector<pair<double, double>> a;
    vector<vector<pair<double, double>>> t1;
    vector<cht> t;
    segtree() = default;
    segtree(int n_, vector<pair<double, double>> a_) {
        n = n_;
        a = a_;
        t1.resize(4 * n); t.resize(4 * n);
        build(1, 0, n);
    }

    void build(int v, int tl, int tr) {
        if (tl + 1 == tr) {
            t1[v] = {a[tl]};
            t[v].add_line({a[tl].first, a[tl].second});
            return;
        }
        int tm = (tl + tr) / 2;
        build(v << 1, tl, tm); build(v << 1 | 1, tm, tr);
        t1[v].resize(tr - tl);
        merge(all(t1[v << 1]), all(t1[v << 1 | 1]), t1[v].begin());
        t1[v << 1].clear(); t1[v << 1 | 1].clear();
        for (auto u : t1[v]) t[v].add_line({u.first, u.second});
    }

    double get(int v, int tl, int tr, int l, int r, double x) {
        if (tr <= l || tl >= r) return -1;
        if (l <= tl && tr <= r) return t[v].get(x);
        int tm = (tl + tr) / 2;
        return max(get(v << 1, tl, tm, l, r, x), get(v << 1 | 1, tm, tr, l, r, x));
    }
};

segtree sg1, sg2;

void init(const std::vector<int>& A, const std::vector<int>& B) {
    int n = sz(A);
    for (int i = 0; i < n; i++) dr.pb({(ll)A[i], (ll)B[i]});
    sort(all(dr));
    vector<pair<ll, ll>> lol;
    for (int j = 0; j < n; j++) {
        ll g = gcd(dr[j].first, dr[j].second);
        lol.pb({dr[j].first / g, dr[j].second / g});
    }
    sort(all(lol));
    lol.resize(unique(all(lol)) - lol.begin());
    map<pair<ll, ll>, int> pos;
    for (int i = 0; i < sz(lol); i++) pos[lol[i]] = i;
    id_oth.assign(sz(lol), -1);
    for (int i = 0; i < sz(lol); i++) {
        if (pos.find({lol[i].second, lol[i].first}) != pos.end()) id_oth[i] = pos[{lol[i].second, lol[i].first}];
    }
    id_s.resize(n);
    vector<pair<int, int>> normalized(n);
    vh.resize(n);
    for (int i = 0; i < n; i++) {
        normalized[i] = {dr[i].first / gcd(dr[i].first, dr[i].second), dr[i].second / gcd(dr[i].first, dr[i].second)};
        id_s[i] = pos[{dr[i].first / gcd(dr[i].first, dr[i].second), dr[i].second / gcd(dr[i].first, dr[i].second)}];
        vh[id_s[i]].pb(i);
    }
    sp.assign(17, vector<int>(n)); sp_minB.assign(17, vector<int>(n, 1e9 + 1)); sp_minA = sp_minB;
    for (int i = 0; i < n; i++) {
        sp[0][i] = max(lol[i].first, lol[i].second);
        sp_minA[0][i] = (dr[i].second == 0 ? dr[i].first : 1e9 + 1);
        sp_minB[0][i] = (dr[i].first == 0 ? dr[i].second : 1e9 + 1);
    }
    for (int i = 1; i < 17; i++) {
        for (int j = 0; j + (1 << i) - 1 < n; j++) {
            sp[i][j] = min(sp[i - 1][j], sp[i - 1][j + (1 << (i - 1))]);
            sp_minA[i][j] = min(sp_minA[i - 1][j], sp_minA[i - 1][j + (1 << (i - 1))]);
            sp_minB[i][j] = min(sp_minB[i - 1][j], sp_minB[i - 1][j + (1 << (i - 1))]);
        }
    }

    vector<pair<double, double>> lines1, lines2;
    for (int i = 0; i < n; i++) {
        if (dr[i].first == 0) {
            lines1.pb({-1, -1e9});
        } else {
            lines1.pb({1 - double(dr[i].second) / double(dr[i].first), double(1) / double(dr[i].first)});
        }
        if (dr[i].second == 0) {
            lines2.pb({-1, -1e9});
        } else {
            lines2.pb({1 - double(dr[i].first) / double(dr[i].second), double(1) / double(dr[i].second)});
        }
    }
    // sg1 = segtree(n, lines1);
    // sg2 = segtree(n, lines2);
    sp_pairs.resize(sz(lol));
    for (int i = 0; i < sz(lol); i++) {
        int ML = 31 - __builtin_clz(sz(vh[i]));

        sp_pairs[i].resize(ML + 1, vector<ll>(sz(vh[i])));
        for (int j = 0; j < sz(vh[i]); j++) {
            sp_pairs[i][0][j] = dr[vh[i][j]].first + dr[vh[i][j]].second;
        }
        for (int st = 1; st < ML + 1; st++) {
            for (int j = 0; j + (1 << st) - 1 < sz(vh[i]); j++) {
                sp_pairs[i][st][j] = min(sp_pairs[i][st - 1][j], sp_pairs[i][st - 1][j + (1 << (st - 1))]);
            }
        }
    }
    bestkoef.assign((n + BB - 1) / BB, vector<double>((n + BB - 1) / BB));
    for (int i = 0; i < n; i += BB) {
        int curid = i / BB;
        //bestkoef.pb({});
        double best = 0;
        vector<ll> bsum(sz(lol), 2e9 + 1);
        for (int j = curid; j < sz(bestkoef) && j * BB + BB <= n; j++) {
            for (int jj = j * BB; jj < (j + 1) * BB; jj++) {
                if (dr[jj].first != 0 && dr[jj].second != 0) {
                    bsum[id_s[jj]] = min(bsum[id_s[jj]], dr[jj].first + dr[jj].second);
                    if (id_oth[id_s[jj]] != -1 && bsum[id_oth[id_s[jj]]] != 2e9 + 1) {
                        best = max(best, double(1) / double(bsum[id_s[jj]]) + double(1) / double(bsum[id_oth[id_s[jj]]]));
                    }
                }
            }
            bestkoef[curid][j] = best;
        }
    }
}

ll get_pairs(int id, int l, int r) {
    int lg = 31 - __builtin_clz(r - l + 1);
    return min(sp_pairs[id][lg][l], sp_pairs[id][lg][r - (1 << lg) + 1]);
}

ll get_pairs_seg(int id, int l, int r) {
    int L = -1, R = sz(vh[id]);
    while (R - L > 1) {
        int M = (L + R) / 2;
        if (vh[id][M] >= l) R = M;
        else L = M;
    }
    int lf = R;
    L = -1; R = sz(vh[id]);
    while (R - L > 1) {
        int M = (L + R) / 2;
        if (vh[id][M] <= r) L = M;
        else R = M;
    }
    int rg = L;
    if (lf <= rg) {
        return get_pairs(id, lf, rg);
    } else {
        return -1e9;
    }
}

int get(int l, int r) {
    int lg = 31 - __builtin_clz(r - l + 1);
    return min(sp[lg][l], sp[lg][r - (1 << lg) + 1]);
}

int getminb(int l, int r) {
    int lg = 31 - __builtin_clz(r - l + 1);
    return min(sp_minB[lg][l], sp_minB[lg][r - (1 << lg) + 1]);
}

int getmina(int l, int r) {
    int lg = 31 - __builtin_clz(r - l + 1);
    return min(sp_minA[lg][l], sp_minA[lg][r - (1 << lg) + 1]);
}

double friendDrink(const int Ma, const int Mb, const int La, const int Ra) {
    int L = -1, R = sz(dr);
    while (R - L > 1) {
        int M = (L + R) / 2;
        if (dr[M].first >= La) R = M;
        else L = M;
    }
    int lf = R;
    L = -1; R = sz(dr);
    while (R - L > 1) {
        int M = (L + R) / 2;
        if (dr[M].first <= Ra) L = M;
        else R = M;
    }
    int rg = L;
    if (lf > rg) return 0;

    double ans = double(Ma) / double(get(lf, rg));
    int minb = getminb(lf, rg), mina = getmina(lf, rg);
    // if (minb != 1e9 + 1) {
    //     ans = max(ans, sg1.get(1, 0, sz(dr), lf, rg + 1, 1 / double(minb)) * double(Ma));
    // }
    // if (mina != 1e9 + 1) {
    //     ans = max(ans, sg2.get(1, 0, sz(dr), lf, rg + 1, 1 / double(mina)) * double(Mb));
    // }
    //return ans;
    for (int j = lf; j < min(rg + 1, lf + BB); j++) {
        if (id_oth[id_s[j]] != -1) {
            int bs1 = get_pairs_seg(id_s[j], lf, rg), bs2 = get_pairs_seg(id_oth[id_s[j]], lf, rg);
            if (min(bs1, bs2) > 0) {
                ans = max(ans, Ma * (double(1) / double(bs1) + double(1) / double(bs2)));
            }
        }
    }
    for (int j = rg; j > max(lf - 1, rg - BB); j--) {
        if (id_oth[id_s[j]] != -1) {
            int bs1 = get_pairs_seg(id_s[j], lf, rg), bs2 = get_pairs_seg(id_oth[id_s[j]], lf, rg);
            if (min(bs1, bs2) > 0) {
                ans = max(ans, Ma * (double(1) / double(bs1) + double(1) / double(bs2)));
            }
        }
    }

    int lb = (lf + BB - 1) / BB;
    int rb = (rg - 1) / BB;
    // if (lb < 0 || rb >= bestkoef.size() || (lb <= rb && rb >= bestkoef[lb].size())) {
    //     while (true) {

    //     }
    // }
    if (lb <= rb) ans = max(ans, Ma * bestkoef[lb][rb]);

    return ans;
}
