#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

using ll = long long;

#ifndef _DEBUG
#include "soft_drinks.h"
#endif

vector<pair<ll, ll>> v, x, y;

void init(const std::vector<int>& A, const std::vector<int>& B) {
	for (int i = 0; i < A.size(); ++i) {
		v.push_back({ A[i], B[i] });
	}
	sort(v.begin(), v.end());
	y.push_back(v[0]);
	for (int i = 1; i < v.size(); ++i) {
		if (v[i].second < y.back().second) {
			y.push_back(v[i]);
		}
	}
	x.push_back(y[0]);
	for (int i = 1; i < y.size(); ++i) {
		ll x1 = 0, x2 = 0, x3 = 0, y1 = 0, y2 = 0, y3 = 0;
		if (x.size() > 2) {
			x1 = x[x.size() - 2].first, y1 = x[x.size() - 2].second;
			x2 = x.back().first, y2 = x.back().second;
			x3 = y[i].first, y3 = y[i].second;
		}
		while (x.size() > 2 && y2 * (x3 - x1) >= y1 * (x3 - x1) + (x2 - x1) * (y3 - y1)) {
			x.pop_back();
			if (x.size() > 2) {
				x1 = x[x.size() - 2].first, y1 = x[x.size() - 2].second;
				x2 = x.back().first, y2 = x.back().second;
			}
		}
		x.push_back(y[i]);
	}
}

bool ch(long double v, int Ma, int Mb, int lx, int rx) {
	long double xt = Ma / v;
	long double yt = Mb / v;
	int id = lower_bound(x.begin(), x.end(), make_pair((ll)xt, (ll)1e9 + 1)) - x.begin() - 1;
	if (id < lx) return 0;
	id = min(id, rx);
	if (id != x.size() - 1) {
		return x[id].second + (x[id + 1].second - x[id].second) * (xt - x[id].first) / (x[id + 1].first - x[id].first) <= yt;
	}
	return x.back().second <= yt;
}

double friendDrink(int Ma, int Mb, int La, int Ra) {
	int lx = lower_bound(x.begin(), x.end(), make_pair((ll)La, (ll) -1)) - x.begin();
	int rx = lower_bound(x.begin(), x.end(), make_pair((ll)Ra, (ll)1e9 + 1)) - x.begin() - 1;
	long double lt = 0, rt = min(Ma, Mb) + 1;
	int cnt = 50;
	while (cnt--) {
		long double md = (lt + rt) / 2;
		if (ch(md, Ma, Mb, lx, rx)) {
			lt = md;
		}
		else {
			rt = md;
		}
	}
	return lt;
}

#ifdef _DEBUG
int main() {
	std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);

	int n, q;
	std::cin >> n >> q;

	std::vector<int> A(n), B(n);
	for (int i = 0; i < n; i++) {
		std::cin >> A[i] >> B[i];
	}
	init(A, B);

	for (int i = 0; i < q; i++) {
		int a, b, l, r;
		std::cin >> a >> b >> l >> r;
		const auto ret = friendDrink(a, b, l, r);
		std::cout << ret << "\n";
	}

	return 0;
}
#endif
