#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

using ll = long long;

#ifndef _DEBUG
#include "soft_drinks.h"
#endif

vector<pair<ll, ll>> x, y, a;

void init(const std::vector<int>& A, const std::vector<int>& B) {
	for (int i = 0; i < A.size(); ++i) {
		y.push_back({ A[i], B[i] });
	}
	sort(y.begin(), y.end());
	for (int i = 0; i < y.size(); ++i) {
		if (x.empty() || x.back().first != y[i].first)
			x.push_back(y[i]);
	}
	a.push_back(x[0]);
	for (int i = 1; i < x.size(); ++i) {
		ll x1 = 0, x2 = 0, x3 = x[i].first, y1 = 0, y2 = 0, y3 = x[i].second;
		if (a.size() >= 2) {
			x1 = a[a.size() - 2].first;
			y1 = a[a.size() - 2].second;
			x2 = a.back().first;
			y2 = a.back().second;
		}
		while (a.size() >= 2 && (x2 - x1) * (y3 - y2) - (x3 - x2) * (y2 - y1) <= 0) {
			a.pop_back();
			if (a.size() >= 2) {
				x1 = a[a.size() - 2].first;
				y1 = a[a.size() - 2].second;
				x2 = a.back().first;
				y2 = a.back().second;
			}
		}
		a.push_back(x[i]);
	}
}

bool ch(long double v, int Ma, int Mb, int lx, int rx) {
	if (rx < lx) return 0;
	long double xt = Ma / v;
	long double yt = Mb / v;
	int id = lower_bound(a.begin(), a.end(), make_pair((ll)xt, (ll)1e9 + 1)) - a.begin() - 1;
	if (id == -1) return 0;
	if (a[id].second <= yt) return 1;
	if (id == a.size() - 1) return 0;
	return a[id].second - (a[id].second - a[id + 1].second) * (xt - a[id].first) / (a[id + 1].first - a[id].first) <= yt;
}

double friendDrink(int Ma, int Mb, int La, int Ra) {
	int lx = lower_bound(x.begin(), x.end(), make_pair((ll)La, (ll)-1)) - x.begin();
	int rx = lower_bound(x.begin(), x.end(), make_pair((ll)Ra, (ll)1e9 + 1)) - x.begin() - 1;
	long double lt = 0, rt = 1e9 + 1;
	int cnt = 50;
	while (cnt--) {
		long double md = (lt + rt) / 2;
		if (ch(md, Ma, Mb, lx, rx)) {
			lt = md;
		}
		else {
			rt = md;
		}
	}
	return lt;
}

#ifdef _DEBUG
int main() {
	std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);

	int n, q;
	std::cin >> n >> q;

	std::vector<int> A(n), B(n);
	for (int i = 0; i < n; i++) {
		std::cin >> A[i] >> B[i];
	}
	init(A, B);

	for (int i = 0; i < q; i++) {
		int a, b, l, r;
		std::cin >> a >> b >> l >> r;
		const auto ret = friendDrink(a, b, l, r);
		std::cout << ret << "\n";
	}

	return 0;
}
#endif