#include <vector>
#include <iostream>

using namespace std;
using ll = long long;

const int maxn = 2e5;
vector<pair<int, int>> g[maxn];
int e[maxn];

pair<int, ll> dfs(int v, int p = -1) {
	ll mx = 0; int vr = v;
	for (auto u : g[v]) {
		if (u.first != p) {
			auto rs = dfs(u.first, v);
			if (rs.second + e[u.second] > mx) {
				mx = rs.second + e[u.second];
				vr = rs.first;
			}
		}
	}
	return { vr, mx };
}

vector<int> sr;

bool go(int v, int t, int p = -1) {
	if (v == t) return 1;
	for (auto u : g[v]) {
		if (u.first != p && go(u.first, t, v)) {
			sr.push_back(u.second);
			return 1;
		}
	}
	return 0;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	ll n, k;
	cin >> n >> k;
	ll sm = 0;
	for (int i = 0; i < n - 1; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		--u;
		--v;
		sm += w;
		e[i] = w;
		g[u].push_back({ v, i });
		g[v].push_back({ u, i });
	}
	for (int i = 0; i < min(sm, k); ++i) {
		int v = dfs(0).first;
		int u = dfs(v).first;
		go(u, v);
		ll s = 0, cc = 0;
		for (auto j : sr) {
			s += e[j];
		}
		for (int j = 0; j < sr.size(); ++j) {
			cc += e[sr[j]];
			if (e[sr[j]] >= 1 && 2 * cc >= s) {
				e[sr[j]]--;
				break;
			}
		}
		sr.clear();
	}
	int v = dfs(0).first;
	cout << dfs(v).second;

	return 0;
}
