#include <bits/stdc++.h>

using namespace std;

//#define int ll
using ll = long long;
using vi = vector<int>;
using ii = pair<int, int>;
using pl = pair<ll, ll>;
using vll = vector<ll>;
using ld = long double;
using pct = pair<ld, ld>;

const ld INF = 1e9;
const ld EPS = 1e-8;

int n;
vector<pct> V;

int max_a0 = -1, max_b0 = -1;
void init(const vi &A, const vi &B) {
    for(int i = 0; i < (int)A.size(); ++i) {
        V.push_back({A[i] + EPS, B[i] + EPS});
        if(A[i] && B[i]);
        else if(A[i]) {
            if(max_a0 == -1)
                max_a0 = A[i];
            else
                max_a0 = min(max_a0, A[i]);
        } else {
            if(max_b0 == -1) max_b0 = B[i];
            else max_b0 = min(max_b0, B[i]);
        }
    }
    n = (int)V.size();
    sort(V.begin(), V.end());
}

struct fun {
    ld a, b; /// a x + b

    fun(ld a0 = 0., ld b0 = 0.) : a(a0), b(b0) {}
    ld operator()(ld x) { return a * x + b; }
};

ld intersect(fun f1, fun f2) {
    if(abs(f1.a - f2.a) < EPS) return 0;
    return (f1.b - f2.b) / (f2.a - f1.a);
}

ld get_val(pct p1, pct p2, int Ma, int Mb) {
    auto [x1, y1] = p1; auto [x2, y2] = p2;
    fun f1{ld(x1 - x2) / Ma, ld(x2) / Ma},
        f2{ld(y1 - y2) / Mb, ld(y2) / Mb};

    auto get_f = [&](ld x) { /// functii de lambda !!! (interpolare intre x1 si x2)
        /// 0 <= x <= 1 !!
        return max(f1(x), f2(x));
    };
    ld re = INF;

    if(abs(f1.a - f2.a) > EPS) {
        ld x_i = intersect(f1, f2);
        if(x_i > 0. && x_i < 1.)
            re = get_f(x_i);
    }
    re = min({re, get_f(0.), get_f(1.)});

    return 1. / re;
}

ld get_val(pct p1, int Ma, int Mb) {
    return min(ld(Ma) / p1.first, ld(Mb) / p1.second);
}


double friendDrink(int Ma, int Mb, int La, int Ra) {
    if(!Ma) {
        if(max_b0 == -1) return 0;
        return double(Mb) / max_b0;
    }
    if(!Mb) {
        if(max_a0 == -1) return 0;
        return double(Ma) / max_a0;
    }
    ld re = 0;
    if(max_a0 != -1) re = max(re, ld(Ma) / max_a0);
    if(max_b0 != -1) re = max(re, ld(Mb) / max_b0);

    for(int i = 0; i < n; ++i) {
        auto [x1, y1] = V[i];
        if(x1 < La || x1 > Ra) continue;
        re = max(re, get_val(V[i], Ma, Mb));
        for(int j = i + 1; j < n; ++j) {
            auto [x2, y2] = V[j];
            if(x2 < La || x2 > Ra) continue;
            re = max(re, get_val(V[i], V[j], Ma, Mb));
        }
    }
    return re;
}

//int main() {
////	std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);
//
//	int n, q;
//	std::cin >> n >> q;
//
//	std::vector<int> A(n), B(n);
//	for (int i = 0; i < n; i ++) {
//		std::cin >> A[i] >> B[i];
//	}
//	init(A, B);
//
//	for (int i = 0; i < q; i ++) {
//		int a, b, l, r;
//		std::cin >> a >> b >> l >> r;
//		const auto ret = friendDrink(a, b, l, r);
//		std::cout << fixed << setprecision(9) << ret << "\n";
//	}
//
//	return 0;
//}
