#include "cycles.h"
#include <bits/stdc++.h>

using namespace std;

//#define int ll
using ll = long long;
using vi = vector<int>;
using ii = pair<int, int>;
using pl = pair<ll, ll>;
using vll = vector<ll>;

mt19937 rng(71);
void solve(vi P) { 
    if(P.empty()) return;
    /// solve(vector) se asigura ca la final, toti din P sunt in ciclii diferiti
    int n = (int) P.size();
    shuffle(P.begin(), P.end(), rng);
    auto performSwap2 = [&](int a, int b) {
        return performSwap(P[a], P[b]);
    };
    auto nr = [&](int a, int b) {
        return uniform_int_distribution<int>(a, b)(rng); 
    };

    if(P.size() == 1) return;
    if(P.size() < 3) {
        int nr_cyc = performSwap2(0, 1);
        for(int p1 = 0; p1 < n; ++p1) {
            for(int p2 = p1 + 1; p2 < n; ++p2) {
                int v = performSwap2(p1, p2);
                if(v > nr_cyc) {
                    nr_cyc = v;
                } else {
                    performSwap2(p1, p2);
                }
            }
        }
        return;
    }

    for(int i = 0; i < n; ++i) {
        int v = nr(0, n - 1);
        if(v > i) performSwap2(i, v);
    }

    vi Repr, Oth;
    Repr.push_back(0);
    int ult = 0, nr_cyc;
    nr_cyc = performSwap2(0, 1);
    int nr_exp = nr_cyc;
    for(int i = 1; i < n; ++i) {
        int v = performSwap2(i, Repr.back());
        --nr_exp;
        if(v == nr_exp) { 
            Repr.push_back(i);
        } else {
            performSwap2(i, Repr.back());
            Oth.push_back(i);
            ++nr_exp;
        }
    }

    int len = (int)Repr.size();
    for(int i = len - 2; i >= 0; --i) {
        nr_cyc = performSwap2(Repr[i], Repr[i + 1]);
    }

    int m = (int)Oth.size();
    vi Val(m, 0);
    if(!m) return; /// sorted this part

    for(int b = 0; (1 << b) < len; ++b) {
        vi B[2];
        for(int i = 0; i < len; ++i) {
            B[!!(i & (1 << b))].push_back(Repr[i]);
        }
        int nr_re = nr_cyc;
        for(int tip = 0; tip < 1; ++tip)
            for(int i = 0; i + 1 < (int)B[tip].size(); ++i) {
                nr_re = performSwap2(B[tip][i], B[tip][i + 1]);
            }

        for(int i = 0; i < m; ++i) {
            int v = performSwap2(B[0][0], Oth[i]);
            if(v != nr_re + 1) {
                Val[i] |= (1 << b);
            }
            performSwap2(B[0][0], Oth[i]);
        }
        for(int tip = 0; tip < 1; ++tip) {
            for(int i = (int)B[tip].size() - 2; i >= 0; --i) 
                nr_cyc = performSwap2(B[tip][i], B[tip][i + 1]);
        }
    }
    //Val[i] este chiar ciclul la fiecare
    vector<vi> Urm(len);
    for(int i = 0; i < len; ++i) {
        Urm[i].push_back(P[Repr[i]]);
    }
    for(int i = 0; i < m; ++i) {
        Urm[Val[i]].push_back(P[Oth[i]]);
    }
    for(auto sir : Urm)
        solve(sir);
}
void sortPermutation(int n) {
    if(n < 2) return;
    int nr_cyc = performSwap(0, 1);
    for(int i = 0; i + 1 < n; i += 2) {
        int v = performSwap(i, i + 1);
        if(v > nr_cyc) nr_cyc = v;
        else performSwap(i, i + 1);
    }
}


#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
#include "cycles.h"

static int64_t cnt = 0;
static std::vector<int> perm;
static int64_t n;

static int findPermCount() {
	std::vector<bool> used(n, false);
	int64_t cntc = 0;
	for (int64_t i = 0; i < n; i ++) {
		if (used[i]) { continue; }
		int64_t curr = i; cntc ++;
		while (!used[curr]) {
			used[curr] = true;
			curr = perm[curr];
		}
	}
    return cntc;
}

int performSwap(int i, int j) {
	++cnt;

    bool valid_swap = true;
    valid_swap &= (0 <= i && i < n);
    valid_swap &= (0 <= j && j < n);
    valid_swap &= (i != j);

    if (!valid_swap) {
        std::cout << "WRONG. Your program made an invalid swap: (" << i << ", " << j << ")" << std::endl;
        exit(0);
    }

	std::swap(perm[i], perm[j]);
	return findPermCount();
}

int main() {
	std::cin >> n;
	perm.resize(n);
	for (int64_t i = 0; i < n; i ++) { std::cin >> perm[i]; }

	sortPermutation(n);
	if (findPermCount() != n) {
		std::cout << "WRONG. The final permutation is not sorted." << std::endl;
	} else {
		std::cout << "CORRECT with " << cnt << " swaps" << std::endl;
	}
	return 0;
}