#include "cycles.h"
// int performSwap(int i, int j);

#include <vector>
#include <algorithm>
#include <random>

namespace __Sol__ {
  int curr = 0;
  int performSwap( int i, int j ){ return curr = ::performSwap( i, j ); }

  bool query( int i, int j ) {
    int oldcyc = curr;
    int newcyc = performSwap( i, j );
    return (newcyc == oldcyc + 1);
  }

  bool peek( int i, int j ) {
    bool ret = query( i, j );
    performSwap( i, j );
    return ret;
  }

  std::mt19937 rng(42);

  void decompose( const std::vector<int> &poz ) {
    if( (int)poz.size() <= 1 )
      return;

    // do a random swap
    int n = (int)poz.size(); {
      int i = rng() % n;
      int j = rng() % (n - 1);
      if( j >= i )
        j++;
      performSwap( poz[i], poz[j] );
    }

    if( n == 2 ) // ma scapa de niste query-uri
      return;

    // now partition nodes into the two cycles and repeat
    std::vector<int> left, right;
    for( int idx : poz ){
      if( left.empty() ){
        left.push_back( idx );
        continue;
      }

      if( peek( idx, left.back() ) )
        left.push_back( idx );
      else
        right.push_back( idx );
    }

    decompose( left );
    decompose( right );
  }

  void solve( int n ){
    performSwap( 0, 1 ); // initialize curr

    // unite all cycles into one big one:
    for( int i = 1; i < n; i++ )
      if( query( i, i - 1 ) )
        performSwap( i, i - 1 );

    std::vector<int> all;
    for( int i = 0; i < n; i++ )
      all.push_back( i );

    decompose( all );
  }
}

void sortPermutation(int n) { __Sol__::solve( n ); }
