#include <bits/stdc++.h>
using namespace std;

#define endl "\n"
#define out(x) #x << " = " << x << " "

#ifndef LOCAL
#define cerr \
    if (false) cerr
#endif

const int MAX_N = 2 * 1e5 + 10;
const int INF = 1e9 + 10;

int n, k;
vector<pair<int, int>> v[MAX_N];
int dist[MAX_N];

pair<int, int> longestInPath;
int lngst = 0;

int bfs(int start) {
    for (int i = 0; i < n; i++) dist[i] = INF;

    queue<int> q;
    q.push(start);
    dist[start] = 0;

    int maxDist = 0, maxDistInd = -1;

    while (!q.empty()) {
        int current = q.front();
        q.pop();

        for (int i = 0; i < v[current].size(); i++) {
            int sus = v[current][i].first;
            int ds = v[current][i].second;
            if (dist[sus] < dist[current] + ds) continue;
            dist[sus] = dist[current] + ds;
            q.push(sus);

            if (ds > lngst) {
                lngst = ds;
                longestInPath = {current, i};
            }

            if (maxDist < dist[sus]) {
                maxDist = dist[sus];
                maxDistInd = sus;
            }
        }
    }

    return maxDistInd;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> k;
    for (int i = 0; i < n - 1; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;

        v[a].push_back({b, c});
        v[b].push_back({a, c});
    }

    int start = bfs(0);
    int end = bfs(start);

    if (k > 0) {
        int current = longestInPath.first;
        int sus = v[current][longestInPath.second].first;
        v[current][longestInPath.second].second -= k;
        for (int i = 0; i < v[sus].size(); i++) {
            if (v[sus][i].first != current) continue;
            v[sus][i].second -= k;
            break;
        }

        start = bfs(0);
        end = bfs(start);
    }

    cout << dist[end] << endl;

    return 0;
}