# include <iostream>
# include <vector>
# include <algorithm>
using namespace std;
# include "soft_drinks.h"
//# include "Lgrader.cpp"

const int INF=1e9+1;
const int MAX=1e5+11,LOG=20;

struct drink
{
    long long x,y;
    drink(){}
    drink(long long _x, long long _y)
    {
        x=_x;
        y=_y;
    }

    drink friend operator + (drink A, drink B)
    {
        drink res;
        res.x=A.x+B.x;
        res.y=A.y+B.y;
        return res;
    }

    bool friend operator < (drink A, drink B)
    {
        if(A.x!=B.x) return A.x<B.x;
        return A.y<B.y;
    }
};

int n;
pair<int,int> a[MAX];
long long st[MAX][LOG];

void sparse_table()
{
    for(int i=1;i<=n;i++) st[i][0]=max(a[i].first,a[i].second);

    for(int j=1;j<LOG;j++)
    {
        for(int i=1;i<=n;i++)
        {
            if(i+(1<<j)-1>n) break;
            st[i][j]=min(st[i][j-1],st[i+(1<<(j-1))][j-1]);
        }
    }
}

int query(int l, int r)
{
    int j=31-__builtin_clz(r-l+1);
    return min(st[l][j],st[r-(1<<j)+1][j]);
}

void init(const std::vector<int>& A, const std::vector<int>& B)
{
    n=A.size();
    for(int i=0;i<n;i++) a[i+1]={A[i],B[i]};
    sort(a+1,a+n+1);
    sparse_table();

}

double calc(double Ma, double Mb, drink A)
{
    double ans=1e9;
    if(A.x!=0) ans=min(ans,Ma/A.x);
    if(A.y!=0) ans=min(ans,Mb/A.y);
    return ans;
}

double friendDrink(int Ma, int Mb, int La, int Ra)
{
    int l=lower_bound(a+1,a+n+1,make_pair(La,-INF))-a;
    int r=upper_bound(a+1,a+n+1,make_pair(Ra,INF))-a-1;
    if(l>r) return 0;

    int mn=query(l,r);
    return (double)Ma/mn;
}

