# include <iostream>
# include <vector>
# include <algorithm>
using namespace std;
# include "soft_drinks.h"
//# include "Lgrader.cpp"

const int INF=1e9+1;
const int MAX=1e5+11,LOG=20;

int n,p,q;
pair<int,int> a[MAX];
pair<int,int> A[MAX];
pair<int,int> B[MAX];
int st[MAX][LOG];
int stA[MAX][LOG];
int stB[MAX][LOG];

void sparse_table()
{
    for(int i=1;i<=n;i++) st[i][0]=max(a[i].first,a[i].second);
    for(int i=1;i<=p;i++) stA[i][0]=A[i].second;
    for(int i=1;i<=q;i++) stB[i][0]=B[i].first;

    for(int j=1;j<LOG;j++)
    {
        for(int i=1;i<=n;i++)
        {
            if(i+(1<<j)-1>n) break;
            st[i][j]=min(st[i][j-1],st[i+(1<<(j-1))][j-1]);
        }
    }

    for(int j=1;j<LOG;j++)
    {
        for(int i=1;i<=p;i++)
        {
            if(i+(1<<j)-1>p) continue;
            stA[i][j]=min(stA[i][j-1],stA[i+(1<<(j-1))][j-1]);
        }
    }

    for(int j=1;j<LOG;j++)
    {
        for(int i=1;i<=q;i++)
        {
            if(i+(1<<j)-1>q) continue;
            stB[i][j]=min(stB[i][j-1],stB[i+(1<<(j-1))][j-1]);
        }
    }
}

int query(int l, int r)
{
    int j=31-__builtin_clz(r-l+1);
    return min(st[l][j],st[r-(1<<j)+1][j]);
}

int queryA(int l, int r)
{
    int j=31-__builtin_clz(r-l+1);
    return min(stA[l][j],stA[r-(1<<j)+1][j]);
}

int queryB(int l, int r)
{
    int j=31-__builtin_clz(r-l+1);
    return min(stB[l][j],stB[r-(1<<j)+1][j]);
}

void init(const std::vector<int>& AA, const std::vector<int>& BB)
{
    n=AA.size();
    p=0;
    q=0;
    for(int i=0;i<n;i++) a[i+1]={AA[i],BB[i]};
    for(int i=1;i<=n;i++)
    {
        if(a[i].first==0)
        {
            p++;
            A[p]=a[i];
        }
        if(a[i].second==0)
        {
            q++;
            B[q]=a[i];
        }
    }

    sort(a+1,a+n+1);
    sort(A+1,A+p+1);
    sort(B+1,B+q+1);

    sparse_table();

}

double friendDrink(int Ma, int Mb, int La, int Ra)
{
    int l=lower_bound(a+1,a+n+1,make_pair(La,-INF))-a;
    int r=upper_bound(a+1,a+n+1,make_pair(Ra,INF))-a-1;
    if(l>r) return 0;

    int mn=query(l,r);
    double ans=(double)max(Ma,Mb)/mn;
    if(p!=0 and q!=0)
    {
        //cout<<"Here"<<p<<" "<<q<<"\n";

        int lA=lower_bound(A+1,A+p+1,make_pair(La,-INF))-A;
        int rA=upper_bound(A+1,A+p+1,make_pair(Ra,INF))-A-1;
        int lB=lower_bound(B+1,B+q+1,make_pair(La,-INF))-B;
        int rB=upper_bound(B+1,B+q+1,make_pair(Ra,INF))-B-1;
        if(lA<=rA and lB<=rB)
        {
            ans=max(ans,(double)Ma/queryA(lA,rA)+(double)Mb/queryB(lB,rB));
        }
    }

    return ans;
}

