# include <iostream>
# include <vector>
using namespace std;

const int MAX=2e5+11;

int n,k;
vector<pair<int,int>> adj[MAX];

int dist[MAX];

void reset_dist()
{
    for(int i=1;i<=n;i++)
    {
        dist[i]=0;
    }
}

void dfs_dist(int curr, int par)
{
    for(pair<int,int> nxt: adj[curr])
    {
        if(nxt.first==par) continue;
        dist[nxt.first]=dist[curr]+nxt.second;
        dfs_dist(nxt.first,curr);
    }
}

int find_diam()
{
    reset_dist();
    dfs_dist(1,0);

    int u=1;
    for(int i=1;i<=n;i++) if(dist[u]<dist[i]) u=i;

    reset_dist();
    dfs_dist(u,0);

    int v=1;
    for(int i=1;i<=n;i++) if(dist[v]<dist[i]) v=i;

    return dist[v];
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>k;
    for(int i=1;i<n;i++)
    {
        int u,v,w;
        cin>>u>>v>>w;
        adj[u].push_back({v,w});
        adj[v].push_back({u,w});
    }

    cout<<find_diam()-1<<"\n";

    return 0;
}
