# include <iostream>
# include <vector>
# include <algorithm>
using namespace std;

const int MAX=2e5+11;

int n,k;
vector<pair<int,int>> adj[MAX];

int from[MAX];
int dist[MAX];
int mxd[MAX];
bool on_diam[MAX];

void reset_dist()
{
    for(int i=1;i<=n;i++)
    {
        dist[i]=0;
        from[i]=-1;
    }
}

void dfs_dist(int curr, int par)
{
    mxd[curr]=max(mxd[curr],dist[curr]);
    for(pair<int,int> nxt: adj[curr])
    {
        if(nxt.first==par) continue;

        from[nxt.first]=curr;
        dist[nxt.first]=dist[curr]+nxt.second;
        dfs_dist(nxt.first,curr);
    }
}

int dfsH(int curr, int par)
{
    int ans=0;
    for(pair<int,int> nxt: adj[curr])
    {
        if(nxt.first==par) continue;
        ans=max(ans,dfsH(nxt.first,curr)+nxt.second);
    }
    return ans;
}

int find_diam()
{
    reset_dist();
    dfs_dist(1,0);

    int u=1;
    for(int i=1;i<=n;i++) if(dist[u]<dist[i]) u=i;

    reset_dist();
    dfs_dist(u,0);

    int v=1;
    for(int i=1;i<=n;i++) if(dist[v]<dist[i]) v=i;

    int ans=dist[v];
    if(ans==0) return 0;

    int curr=v;
    while(curr!=-1)
    {
        on_diam[curr]=1;
        curr=from[curr];
    }

    int C=1;
    for(int i=1;i<=n;i++) if(mxd[i]<mxd[C]) C=i;

    reset_dist();
    vector<int> ve;
    for(pair<int,int> nxt: adj[C])
    {
        ve.push_back(dfsH(nxt.first,C)+nxt.second);
    }

    sort(ve.begin(),ve.end(),greater<int>());
    if((int)ve.size()<=2) return ans-1;
    if(ve[0]>ve[1]) return ans-1;
    if(ve[1]>ve[2]) return ans-1;
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>k;
    for(int i=1;i<n;i++)
    {
        int u,v,w;
        cin>>u>>v>>w;
        adj[u].push_back({v,w});
        adj[v].push_back({u,w});
    }

    cout<<max(0,find_diam())<<"\n";

    return 0;
}
