# include <iostream>
# include <vector>
# include <algorithm>
# include <set>
using namespace std;

const int MAX=2e5+11;

int n,k;
set<pair<int,int>> adj[MAX];
bool killed[MAX];

void merge_node(int u, int v)
{
    //cout<<"Merge:"<<u<<" "<<v<<endl;

    if((int)adj[u].size()>(int)adj[v].size()) swap(u,v);

    for(pair<int,int> pa: adj[v])
    {
        adj[u].insert(pa);
        adj[pa.first].insert({u,pa.second});
        adj[pa.first].erase({v,pa.second});
    }

    adj[u].erase({v,0});
    killed[v]=1;
}

int from[MAX];
int dist[MAX];
int mxd[MAX];

void init()
{
    for(int i=1;i<=n;i++)
    {
        if(killed[i]) continue;
        mxd[i]=0;
    }
}

void reset_dist()
{
    for(int i=1;i<=n;i++)
    {
        if(killed[i]) continue;
        dist[i]=0;
        from[i]=-1;
    }
}

void dfs_dist(int curr, int par)
{
    mxd[curr]=max(mxd[curr],dist[curr]);
    for(pair<int,int> nxt: adj[curr])
    {
        if(nxt.first==par) continue;

        from[nxt.first]=curr;
        dist[nxt.first]=dist[curr]+nxt.second;
        dfs_dist(nxt.first,curr);
    }
}

int dfsH(int curr, int par)
{
    int ans=0;
    for(pair<int,int> nxt: adj[curr])
    {
        if(nxt.first==par) continue;
        ans=max(ans,dfsH(nxt.first,curr)+nxt.second);
    }
    return ans;
}

int find_diam()
{
    init();
    reset_dist();
    dfs_dist(1,0);

    int u=0;
    for(int i=1;i<=n;i++)
    {
        if(killed[i]) continue;
        if(u==0 or dist[u]<dist[i]) u=i;
    }

    reset_dist();
    dfs_dist(u,0);

    int v=0;
    for(int i=1;i<=n;i++)
    {
        if(killed[i]) continue;
        if(v==0 or dist[v]<dist[i]) v=i;
    }

    int ans=dist[v];
    reset_dist();
    dfs_dist(v,0);

    if(k<=-1) return ans;

    int C=0;
    for(int i=1;i<=n;i++)
    {
        if(killed[i]) continue;
        if(C==0 or mxd[i]<mxd[C]) C=i;
    }

    reset_dist();
    vector<pair<int,int>> ve;
    for(pair<int,int> nxt: adj[C])
    {
        ve.push_back({dfsH(nxt.first,C)+nxt.second,nxt.first});
    }

    sort(ve.begin(),ve.end(),greater<pair<int,int>>());

    int toK=-1;
    ans=0;
    for(int i=0;i<(int)ve.size();i++)
    {
        if(i==(int)ve.size()-1 or ve[i].first>ve[i+1].first)
        {
            toK=ve[i].second;
            ve[i].first--;
            break;
        }
    }
    if((int)ve.size()>=1) ans+=ve[0].first;
    if((int)ve.size()>=2) ans+=ve[1].first;

    cout<<ans<<":"<<endl;

    if(toK==-1) return ans;
    pair<int,int> P={-1,-1};
    for(pair<int,int> pa: adj[C])
    {
        if(pa.first==toK)
        {
            P=pa;
            break;
        }
    }

    //cout<<C<<" "<<P.first<<"->"<<P.second-1<<"\n";

    adj[C].erase(P);
    adj[P.first].erase({C,P.second});
    adj[C].insert({P.first,P.second-1});
    adj[P.first].insert({C,P.second-1});
    if(P.second-1==0) merge_node(C,P.first);

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>k;
    for(int i=1;i<n;i++)
    {
        int u,v,w;
        cin>>u>>v>>w;
        adj[u].insert({v,w});
        adj[v].insert({u,w});
    }

    int ans=1e9;
    while(k>=0)
    {
         k--;
         ans=min(ans,find_diam());
         if(ans<=0) break;
    }

    ans=max(ans,0);
    cout<<ans<<"\n";

    return 0;
}


