# include <bits/stdc++.h>
# define ll long long
using namespace std;

struct Edge
{
    ll To, W;
};

const int MAXN = 2 * 1e5 + 1;
ll N, K;
ll dp[MAXN];
ll From[MAXN];
vector<Edge> Graph[MAXN];
ll Answer = 0;

void Dfs(int U, int Parent)
{
    for(auto& [V, W] : Graph[U])
    {
        if(V == Parent) continue;
        Dfs(V, U);
        int Current = dp[V] + W;

        if(dp[U] < Current)
        {
            dp[U] = Current;
            From[U] = V;
        }

        Answer = max(Answer, dp[U]);
    }
}

void Find(int U, int Parent)
{
    for(auto& [V, W] : Graph[U])
    {
        if(V == Parent) continue;
        if(V != From[U])
        {
            Answer = max(Answer, dp[U] + dp[V] + W);
        }
        Find(V, U);
    }
}

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> K;

    for(int i = 0; i < N - 1; i++)
    {
        ll U, V, W;
        cin >> U >> V >> W;
        Graph[U].push_back({V, W});
        Graph[V].push_back({U, W});
    }
}

void Solve()
{
    if(K >= N - 1) cout << 0 << '\n';
    Dfs(1, 0);
    Find(1, 0);
    cout << Answer - K;
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}
