# include <bits/stdc++.h>
# define ll long long
using namespace std;

struct Edge
{
    ll To, W;
};

const int MAXN = 2 * 1e5 + 1;
ll N, K;
ll dp[MAXN];
ll From[MAXN];
vector<Edge> Graph[MAXN];
ll Answer;
ll Counter;

void Dfs(int U, int Parent)
{
    for(auto& [V, W] : Graph[U])
    {
        if(V == Parent) continue;
        Dfs(V, U);
        int Current = dp[V] + W;

        if(dp[U] < Current)
        {
            dp[U] = Current;
            From[U] = V;
        }

        if(Answer < dp[U])
        {
            Answer = dp[U];
            Counter = 1;
        }
        else if(Answer == dp[U]) Counter++;
    }
}

void Find(int U, int Parent)
{
    for(auto& [V, W] : Graph[U])
    {
        if(V == Parent) continue;
        if(V != From[U])
        {
            if(Answer < dp[U] + dp[V] + W)
            {
                Answer = dp[U] + dp[V] + W;
                Counter = 1;
            }
            else if(Answer == dp[U] + dp[V] + W) Counter++;
        }
        Find(V, U);
    }
}

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> K;

    for(int i = 0; i < N - 1; i++)
    {
        ll U, V, W;
        cin >> U >> V >> W;
        Graph[U].push_back({V, W});
        Graph[V].push_back({U, W});
    }
}

void Solve()
{
    Dfs(1, 0);
    Find(1, 0);

    if(K == 1)
    {
        if(Counter <= 2)
        {
            cout << Answer - 1;
        }
        else
        {
            cout << Answer;
        }

        return;
    }

    cout << Answer - K;
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}
