#include "soft_drinks.h"
#include<bits/stdc++.h>

#define endl '\n'
#define x first
#define y second

using namespace std;

typedef long long ll;

const int MAXN = 1e5 + 10;
const int MAXLOG = 17;
const double INF = 1000000000.0 + 10.0;
const double EPS = 0.0000001;

struct drink
{
    double a;
    double b;

    drink(){};
    
    drink(double _a, double _b)
    {
        a = _a;
        b = _b;
    }

    bool operator<(const drink&d)const
    {
        return a < d.a;
    }
};

drink drinks[MAXN];
double st[MAXN][MAXLOG];
int lg[MAXN];
int n;


void init(const std::vector<int>& A, const std::vector<int>& B)
{
    n = A.size();

    for(int i = 0; i < n; i++)
    {
        drinks[i] = drink((double)(A[i]), (double)(B[i]));
    }

    sort(drinks, drinks + n);

    for(int i = 0; i < n; i++)
    {
        st[i][0] = max(drinks[i].a, drinks[i].b);
    }

    for(int j = 1; (1 << j) <= n; j++)
    {
        for(int i = 0; i + (1 << j) - 1 < n; i++)
        {
            st[i][j] = min(st[i][j - 1], st[i + (1 << (j - 1))][j - 1]);
        }
    }

    for(int i = 2; i <= n; i++)
    {
        lg[i] = lg[i / 2] + 1;
    }
}

double query(int left, int right)
{
    int len = right - left + 1;
    int k = lg[len];

    return min(st[left][k], st[right - (1 << k) + 1][k]);
}

double friendDrink(const int Ma, const int Mb, const int La, const int Ra)
{
    //cout << "zaqwka" << endl;
    int left = lower_bound(drinks, drinks + n, drink((double)(La), 0)) - drinks;
    int right = upper_bound(drinks, drinks + n, drink((double)(Ra), 0)) - drinks - 1;

    if(left > right)
        return 0.0;

    if(!(0 <= left && left < n))
        return 0.0;
    
    if(!(0 <= right && right < n))
        return 0.0;

    return (double)(Mb) / query(left, right);
}
