#include "cycles.h"
#include<iostream>
#include<ctime>
#include<random>

using namespace std;

typedef long long ll;

mt19937 rng(time(nullptr));

void sortPermutation(int n)
{
    int best = 0;

    vector < int > cnt(n);

    while(1)
    {
        if(best == n)
            return;

        int first = rng() % n;

        while(cnt[first] == n - 1)
            first = rng() % n;

        int second = rng() % n;

        while(first == second || cnt[second] == n - 1)
            second = rng() % n;

        int cycles = performSwap(first, second);

        cnt[first]++;
        cnt[second]++;

        if(cycles > best)
        {
            best = cycles;
        }
        else
        {
            performSwap(first, second);
        }
    }
}