#include "cycles.h"
#include<iostream>
#include<ctime>
#include<random>

using namespace std;

typedef long long ll;

mt19937 rng(time(nullptr));

void sortPermutation(int n)
{
    int best = n - 1;

    vector < vector < bool > > tried(n, vector < bool >(n, false));

    for(int i = 0; i < n; i++)
        tried[i][i] = true;

    while(1)
    {
        if(best == n)
            return;

        int first = rng() % n;

        int second = rng() % n;

        while(tried[first][second])
            second = rng() % n;

        tried[first][second] = tried[second][first] = true;

        int cycles = performSwap(first, second);

        if(cycles > best)
        {
            best = cycles;
        }
        else
        {
            performSwap(first, second);
        }
    }
}