#include "cycles.h"
#include<iostream>
#include<ctime>
#include<random>

using namespace std;

typedef long long ll;

mt19937 rng(time(nullptr));

void sortPermutation(int n)
{
    vector < vector < bool > > tried(n, vector < bool >(n, false));
    vector < int > cnt(n, 1);

    for(int i = 0; i < n; i++)
        tried[i][i] = true;

    while(1)
    {
        int first = rng() % n;

        while(cnt[first] == n)
            first = rng() % n;

        int second = rng() % n;

        while(cnt[second] == n || tried[first][second] || tried[second][first])
            second = rng() % n;

        tried[first][second] = tried[second][first] = true;
        cnt[first]++;
        cnt[second]++;

        int cycles = performSwap(first, second);

        if(cycles == n)
            return;
        
        performSwap(first, second);
    }
}