#include "cycles.h"
#include<iostream>
#include<ctime>
#include<random>

using namespace std;

typedef long long ll;

mt19937 rng(time(nullptr));

void sortPermutation(int n)
{
    vector < vector < bool > > tried(n, vector < bool >(n, false));
    vector < int > cnt(n, 0);

    for(int i = 0; i < n; i++)
    {
        tried[i][i] = true;
        cnt[i] = 1;
    }

    int best = 0;
    while(1)
    {
        if(best == n)
            return;

        int first = rng() % n;

        while(cnt[first] == n)
            first = rng() % n;

        int second = rng() % n;

        while(cnt[second] == n || tried[first][second])
            second = rng() % n;

        int cycles = performSwap(first, second);

        if(cycles > best)
        {
            best = cycles;
            for(int i = 0; i < n; i++)
            {
                for(int j = 0; j < n; j++)
                {
                    tried[i][j] = false;
                }
                tried[i][i] = true;
                cnt[i] = 1;
            }
        }
        else
        {
            performSwap(first, second);
        }
    }
}