#include<iostream>
#include<vector>

#define endl '\n'

using namespace std;

typedef long long ll;

const int MAXN = 2e5 + 10;

int n, k;
vector < pair < int, int > > adj[MAXN];
int d[MAXN];

void read()
{
    cin >> n >> k;
    for(int i = 1; i <= n - 1; i++)
    {
        int u, v, cost;
        cin >> u >> v >> cost;

        adj[u].push_back({v, cost});
        adj[v].push_back({u, cost});
    }
}

void dfs(int u, int par)
{
    for(pair < int, int > e : adj[u])
    {
        int v = e.first;
        int cost = e.second;

        if(v == par)
            continue;

        d[v] = d[u] + cost;
        dfs(v, u);
    }
}

pair < int, int > find_diameter()
{
    dfs(1, 1);

    int fart = 0;

    for(int i = 1; i <= n; i++)
    {
        if(d[fart] < d[i])
            fart = i;
    }

    for(int i = 1; i <= n; i++)
    {
        d[i] = 0;
    }

    dfs(fart, fart);

    fart = 0;
    int fart2 = 0;

    for(int i = 1; i <= n; i++)
    {
        if(d[fart2] < d[i])
            fart2 = i;

        if(d[fart2] > d[fart])
            swap(fart, fart2);
    }

    return {d[fart], d[fart2]};
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    pair < int, int > ans = find_diameter();

    //cout << ans.first << " " << ans.second << endl;

    cout << max(ans.first - k, ans.second) << endl;

    return 0;
}