#include<iostream>
#include<vector>
#include<algorithm>

#define endl '\n'

using namespace std;

typedef long long ll;

const int MAXN = 2e5 + 10;

int n, k;
vector < pair < int, int > > adj[MAXN];
int d[MAXN];
int w[MAXN];
pair < ll, int > edges[MAXN];
int sz[MAXN];

void read()
{
    cin >> n >> k;
    for(int i = 1; i <= n - 1; i++)
    {
        int u, v, cost;
        cin >> u >> v >> w[i];

        adj[u].push_back({v,  i});
        adj[v].push_back({u, i});
    }
}

void dfs(int u, int par)
{
    sz[u] = 1;

    for(pair < int, int > e : adj[u])
    {
        int v = e.first;
        int idx = e.second;

        if(v == par)
            continue;

        dfs(v, u);

        sz[u] += sz[v];

        edges[idx] = {-sz[v] * (n - sz[v]), idx};
    }
}

void find_d(int u, int par)
{
    for(pair < int, int > e : adj[u])
    {
        int v = e.first;
        int idx = e.second;

        if(v == par)
            continue;

        d[v] = d[u] + w[idx];
        find_d(v, u);
    }
}

void solve()
{
    dfs(1, 1);

    sort(edges + 1, edges + n - 1 + 1);

    for(int i = 1; i <= k; i++)
    {
        ll cnt = edges[i].first;
        int idx = edges[i].second;

        w[idx]--;
    }

    for(int i = 1; i <= n; i++)
    {
        d[i] = 0;
    }

    find_d(1, 1);

    int fart = 0;

    for(int i = 1; i <= n; i++)
    {
        if(d[fart] < d[i])
            fart = i;
    }

    for(int i = 1; i <= n; i++)
    {
        d[i] = 0;
    }

    find_d(fart, fart);

    fart = 0;

    for(int i = 1; i <= n; i++)
    {
        if(d[fart] < d[i])
            fart = i;
    }

    cout << d[fart] << endl;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return 0;
}