#include <bits/stdc++.h>
using namespace std;
const int maxN = 2e5 + 1;
#define w first
#define dest second
vector<pair<int, int>> adj[maxN];
vector<int> path;
int dist[maxN];
int maxH[maxN];
int n, k, diam;
void dfs(int cur, int par, int curDist) {
    dist[cur] = curDist;
    for (auto e : adj[cur]) {
        if (e.dest == par) { continue; }
        maxH[cur] = max(maxH[cur], maxH[e.dest] + e.w);
        dfs(e.dest, cur, curDist + e.w);
    }
}

bool findPath(int cur, int pEnd, int par = -1) {
    if (cur == pEnd) {
        path.push_back(cur);
        return 1;
    }
    for (auto e : adj[cur]) {
        if (e.dest == par) { continue; }
        if (findPath(e.dest, pEnd, cur)) {
            path.push_back(cur);
            return 1;
        }
    }
    return 0;
}

void init() {
    cin >> n >> k;
    for (int i = 0; i < n - 1; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        adj[a].push_back({ c, b });
        adj[b].push_back({ c, a });
    }
    dfs(0, -1, 0);
    int maxD = 0, maxDVert = 0;
    for (int i = 0; i < n; i++) {
        if (maxD < dist[i]) {
            maxD = dist[i];
            maxDVert = i;
        }
    }
    dfs(maxDVert, -1, 0);
    maxD = 0;
    int root = maxDVert;
    for (int i = 0; i < n; i++) {
        if (maxD < dist[i]) {
            maxD = dist[i];
            maxDVert = i;
        }
    }
    diam = maxD;
    findPath(root, maxDVert);
    reverse(path.begin(), path.end());
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    init();

    bool test = false;
    for (int i = 0; i < path.size() - 1; i++) {
        if (dist[path[i]] * 2 == diam) {
            for (auto e : adj[path[i]]) {
                if (e.dest != path[i + 1] && (maxH[e.dest] + e.w) * 2 == diam) {
                    test = true;
                    break;
                }
            }
        }
    }
    cout << diam - (k == 1 ? k - test : 0) << '\n';
}
