#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll maxN = 2e5 + 1;
#define w first
#define dest second
vector<pair<ll, ll>> adj[maxN];
vector<ll> path;
ll dist[maxN];
ll maxH[maxN];
ll n, k, diam;
void dfs(ll cur, ll par, ll curDist) {
    dist[cur] = curDist;
    for (auto e : adj[cur]) {
        if (e.dest == par) { continue; }
        maxH[cur] = max(maxH[cur], maxH[e.dest] + e.w);
        dfs(e.dest, cur, curDist + e.w);
    }
}

bool findPath(ll cur, ll pEnd, ll par = -1) {
    if (cur == pEnd) {
        path.push_back(cur);
        return 1;
    }
    for (auto e : adj[cur]) {
        if (e.dest == par) { continue; }
        if (findPath(e.dest, pEnd, cur)) {
            path.push_back(cur);
            return 1;
        }
    }
    return 0;
}

void init() {
    cin >> n >> k;
    for (ll i = 0; i < n - 1; i++) {
        ll a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        adj[a].push_back({ c, b });
        adj[b].push_back({ c, a });
    }
    dfs(0, -1, 0);
    ll maxD = 0, maxDVert = 0;
    for (ll i = 0; i < n; i++) {
        if (maxD < dist[i]) {
            maxD = dist[i];
            maxDVert = i;
        }
    }
    for (ll i = 0; i < n; i++) { maxH[i] = 0; }
    dfs(maxDVert, -1, 0);
    maxD = 0;
    ll root = maxDVert;
    for (ll i = 0; i < n; i++) {
        if (maxD < dist[i]) {
            maxD = dist[i];
            maxDVert = i;
        }
    }
    diam = maxD;
    findPath(root, maxDVert);
    reverse(path.begin(), path.end());
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    init();

    bool test = false;
    for (ll i = 1; i < path.size() - 1; i++) {
        if (dist[path[i]] * 2 == diam) {
            for (auto e : adj[path[i]]) {
                if (e.dest != path[i - 1] && e.dest != path[i + 1] && (maxH[e.dest] + e.w) * 2 == diam) {
                    test = true;
                    break;
                }
            }
        }
    }
    cout << diam - k << '\n';
}
