#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll maxN = 2e5 + 1;
#define w first
#define dest second
bitset<maxN> used;
vector<pair<ll, ll>> adj[maxN];
vector<ll> path;
ll edgeIdx[maxN];///In paths
ll dist[maxN];
ll maxH[maxN];
ll n, k, diam, root, sumW = 0;
priority_queue<pair<ll, ll>> pq;
int findMid() {
    int l = -1, r = path.size();
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        if (dist[path[mid]] * 2 < diam) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return r;
}

void dfs(ll cur, ll par, ll curDist) {
    dist[cur] = curDist;
    for (auto e : adj[cur]) {
        if (e.dest == par) { continue; }
        dfs(e.dest, cur, curDist + e.w);
        maxH[cur] = max(maxH[cur], maxH[e.dest] + e.w);
    }
}

bool findPath(ll cur, ll pEnd, ll par = -1) {
    if (cur == pEnd) {
        path.push_back(cur);
        return 1;
    }
    for (int i = 0; i < adj[cur].size(); i++) {
        auto e = adj[cur][i];
        if (e.dest == par) { continue; }
        if (findPath(e.dest, pEnd, cur)) {
            edgeIdx[cur] = i;
            path.push_back(cur);
            return 1;
        }
    }
    return 0;
}

void init() {
    cin >> n >> k;
    for (ll i = 0; i < n - 1; i++) {
        ll a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        adj[a].push_back({ c, b });
        adj[b].push_back({ c, a });
        sumW += c;
    }
    dfs(0, -1, 0);
    ll maxD = 0, maxDVert = 0;
    for (ll i = 0; i < n; i++) {
        if (maxD < dist[i]) {
            maxD = dist[i];
            maxDVert = i;
        }
    }
    for (ll i = 0; i < n; i++) { maxH[i] = 0; }
    root = maxDVert;
    dfs(maxDVert, -1, 0);
    maxD = 0;
    for (ll i = 0; i < n; i++) {
//        cout << dist[i] << ' ';
        if (maxD < dist[i]) {
            maxD = dist[i];
            maxDVert = i;
        }
    }
    diam = maxD;
//    cout << '\n' << maxDVert << '\n';
    findPath(root, maxDVert);
    reverse(path.begin(), path.end());
}

int main () {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);
    init();
    if (k >= sumW) {
        cout << "0\n";
        return 0;
    }
    int mid = findMid();
    for (auto e : adj[mid]) {
        if (mid != 0 && e.dest == path[mid - 1]) { continue; }
        if (mid != path.size() - 1 && e.dest == path[mid + 1]) { continue; }
        pq.push(e);
    }

    while (k > 0) {
//        cout << k << ' ' << diam << ' ' << mid << ' ' << dist[mid] << '\n';
//        for (int v : path) {
//            cout << v + 1 << ' ';
//        }
//        cout << "\n\n";
        if (dist[path[mid]] * 2 > diam) {
//            cout << "???\n";
            adj[path[mid - 1]][edgeIdx[path[mid - 1]]].w--;
            k--;
            dist[path[mid]]--;
            diam--;
            if (dist[path[mid]] * 2 == diam || dist[path[mid - 1]] * 2 == diam) {
                ///Triggers only once: recompute
                for (ll i = 0; i < n; i++) { maxH[i] = 0; }
                dfs(root, -1, 0);
                diam = 0;
                for (ll i = 0; i < n; i++) { diam = max(diam, dist[i]); }
                ///If edge has weight 0, this will be taken care of on the else statement
//                cout << "st2\n";
            }
        } else {
            //assert(dist[mid] * 2 == diam);
//            cout << "a\n";
            if (mid != 0 && adj[path[mid - 1]][edgeIdx[path[mid - 1]]].w == 0) {
//                cout << "ml\n";
                ///Merge mid with left vertex
                for (auto e : adj[mid - 1]) {
                    if (e.dest == path[mid] || (mid > 1 && e.dest == path[mid - 2])) { continue; }
                    pq.push({ e.w, e.dest });
                }
                path.erase(path.begin() + mid - 1);
                mid--;
                if (mid != 0) {
                    adj[path[mid - 1]][edgeIdx[path[mid - 1]]].dest = mid;
                }
            }
//            cout << "b\n";
            if (mid != path.size() - 1 && adj[path[mid + 1]][edgeIdx[path[mid + 1]]].w == 0) {
//                cout << "mr\n";
                ///Merge mid with right vertex
                for (auto e : adj[mid + 1]) {
                    if (e.dest == path[mid] || (mid < path.size() - 2 && e.dest == path[mid + 2])) { continue; }
                    pq.push({ e.w, e.dest });
                }
                path.erase(path.begin() + mid + 1);
                if (mid != path.size() - 1) {
                    adj[path[mid]][edgeIdx[path[mid]]].dest = path[mid + 1];
                }
            }
//            cout << "dm\n";

            if (!pq.empty() && pq.top().w * 2 == diam) {
                auto t = pq.top();
                t.w--;
                k--;
                pq.pop();
                if (t.w == 0) {
//                    cout << "ms\n";
                    ///Merge mid with son
                    used[t.dest] = 1;
                    for (auto e : adj[t.dest]) {
                        if (e.dest == path[mid] || !used[e.dest]) { continue; }
                        pq.push(e);
                    }
                } else {
                    pq.push(t);
                }
            } else {
//                cout << "rw\n";
                if (mid == 0) {
                    adj[path[mid]][edgeIdx[path[mid]]].w--;
                    k--;
                    diam--;
                    continue;
                }
                if (mid == path.size() - 1) {
                    adj[path[mid - 1]][edgeIdx[path[mid - 1]]].w--;
                    k--;
                    diam--;
                    continue;
                }
                if (k <= 1) { diam--; k--; break; }
                adj[path[mid]][edgeIdx[path[mid]]].w--;
                adj[path[mid - 1]][edgeIdx[path[mid - 1]]].w--;
                k -= 2;
                dist[path[mid]]--;
                diam -= 2;
            }
        }
    }
    cout << diam << '\n';
}
