#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll maxN = 2e5 + 1;
#define w first
#define dest second
bitset<maxN> used;
vector<pair<ll, ll>> adj[maxN];
vector<ll> path;
ll edgeIdx[maxN];///In paths
ll dist[maxN];
ll maxH[maxN];
ll n, k, diam, root, sumW = 0;
priority_queue<pair<ll, ll>> pq;
struct LLNode {
    LLNode() { next = prev = nullptr; }
    ~LLNode() {}
    int val;
    LLNode* next;
    LLNode* prev;
};

int findMid() {
    int l = -1, r = path.size();
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        if (dist[path[mid]] * 2 < diam) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return r;
}

void dfs(ll cur, ll par, ll curDist) {
    dist[cur] = curDist;
    for (auto e : adj[cur]) {
        if (e.dest == par) { continue; }
        dfs(e.dest, cur, curDist + e.w);
        maxH[cur] = max(maxH[cur], maxH[e.dest] + e.w);
    }
}

bool findPath(ll cur, ll pEnd, ll par = -1) {
    if (cur == pEnd) {
        path.push_back(cur);
        return 1;
    }
    for (int i = 0; i < adj[cur].size(); i++) {
        auto e = adj[cur][i];
        if (e.dest == par) { continue; }
        if (findPath(e.dest, pEnd, cur)) {
            edgeIdx[cur] = i;
            path.push_back(cur);
            return 1;
        }
    }
    return 0;
}

void init() {
    cin >> n >> k;
    for (ll i = 0; i < n - 1; i++) {
        ll a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        adj[a].push_back({ c, b });
        adj[b].push_back({ c, a });
        sumW += c;
    }
    dfs(0, -1, 0);
    ll maxD = 0, maxDVert = 0;
    for (ll i = 0; i < n; i++) {
        if (maxD < dist[i]) {
            maxD = dist[i];
            maxDVert = i;
        }
    }
    for (ll i = 0; i < n; i++) { maxH[i] = 0; }
    root = maxDVert;
    dfs(maxDVert, -1, 0);
    maxD = 0;
    for (ll i = 0; i < n; i++) {
//        cout << dist[i] << ' ';
        if (maxD < dist[i]) {
            maxD = dist[i];
            maxDVert = i;
        }
    }
    diam = maxD;
//    cout << '\n' << maxDVert << '\n';
    findPath(root, maxDVert);
    reverse(path.begin(), path.end());
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    init();
    if (k >= sumW) {
        cout << "0\n";
        return 0;
    }
    for (int v : path) { used[v] = 1; }
    int mid = findMid();
    for (auto e : adj[path[mid]]) {
        if (mid != 0 && e.dest == path[mid - 1]) { continue; }
        if (mid != path.size() - 1 && e.dest == path[mid + 1]) { continue; }
//        cout << e.dest << ' ' << maxH[e.dest] << '\n';
        pq.push({ e.w + maxH[e.dest], e.dest });
    }
    LLNode* rNode = new LLNode();
    LLNode* curNode = rNode;
    LLNode* midNode = nullptr;
    for (int i = 0; i < path.size(); i++) {
        if (i == mid) { midNode = curNode; }
        curNode->val = path[i];
        if (i != path.size() - 1) {
            curNode->next = new LLNode();
            curNode->next->prev = curNode;
        }
        curNode = curNode->next;
    }

    while (k > 0) {
        int mVal = midNode->val;
        if (dist[mVal] * 2 > diam) {
            int rem = min(min(diam - dist[midNode->prev->val] * 2, dist[mVal] * 2 - diam), k);
            adj[midNode->prev->val][edgeIdx[midNode->prev->val]].w -= rem;
            k -= rem;
            dist[mVal] -= rem;
            diam -= rem;
            if (dist[mVal] * 2 == diam || dist[midNode->prev->val] * 2 == diam) {
                if (dist[midNode->prev->val] * 2 == diam) {
                    midNode = midNode->prev;
                    mVal = midNode->val;
                    while (!pq.empty()) { pq.pop(); }
                    for (auto e : adj[mVal]) {
                        if (midNode->prev != nullptr && e.dest == midNode->prev->val) { continue; }
                        if (midNode->next != nullptr && e.dest == midNode->next->val) { continue; }
                        pq.push({ e.w + maxH[e.dest], e.dest });
                    }
                }
                ///Triggers only once: recompute
                for (ll i = 0; i < n; i++) { maxH[i] = 0; }
                dfs(root, -1, 0);
                diam = 0;
                for (ll i = 0; i < n; i++) { diam = max(diam, dist[i]); }
                ///If edge has weight 0, this will be taken care of on the else statement
            }
        } else {
            //assert(dist[mid] * 2 == diam);
            if (midNode->prev != nullptr && adj[midNode->prev->val][edgeIdx[midNode->prev->val]].w == 0) {
                used[midNode->prev->val] = 1;
                ///Merge mid with left vertex
                for (auto e : adj[midNode->prev->val]) {
                    if (e.dest == mVal || (midNode->prev->prev != nullptr && e.dest == midNode->prev->prev->val) || used[e.dest]) { continue; }
                    pq.push({ e.w + maxH[e.dest], e.dest });
                }
                int edgeW = (midNode->prev->prev ? adj[midNode->prev->prev->val][edgeIdx[midNode->prev->prev->val]].w : 0);
                midNode->prev = midNode->prev->prev;///Erase left
                if (midNode->prev != nullptr) {
                    midNode->prev->next = midNode;
                    adj[midNode->prev->val][edgeIdx[midNode->prev->val]].dest = mVal;
                    adj[midNode->prev->val][edgeIdx[midNode->prev->val]].w = edgeW;
                }
            }
            if (midNode->next != nullptr && adj[mVal][edgeIdx[mVal]].w == 0) {
                used[midNode->next->val] = 1;
//                cout << "mr\n";
                ///Merge mid with right vertex
                for (auto e : adj[midNode->next->val]) {
                    if (e.dest == mVal || (midNode->next->next != nullptr && e.dest == midNode->next->next->val) || used[e.dest]) { continue; }
                    pq.push({ e.w + maxH[e.dest], e.dest });
                }
                int edgeW = (midNode->next->next != nullptr ? adj[midNode->next->val][edgeIdx[midNode->next->val]].w : 0);
                midNode->next = midNode->next->next;
                if (midNode->next != nullptr) {
                    midNode->next->prev = midNode;
                    adj[mVal][edgeIdx[mVal]].dest = midNode->next->val;
                    adj[mVal][edgeIdx[mVal]].w = edgeW;
                }
            }
//            cout << "dm\n";

            int lBound = 0;
            if (!pq.empty()) {
                lBound = pq.top().w;
            }

            if (!pq.empty() && pq.top().w * 2 == diam) {
                vector<pair<ll, ll>> tv;
                while (!pq.empty() && pq.top().w * 2 == diam) {
                    tv.push_back(pq.top());
                    pq.pop();
                }
                int cnt = tv.size();
                int remCnt = min((midNode->prev == nullptr ? 100000 : adj[midNode->prev->val][edgeIdx[midNode->prev->val]].w),
                                 (midNode->next == nullptr ? 100000 : adj[mVal][edgeIdx[mVal]].w));
                for (auto x : tv) {
                    remCnt = min<ll>(remCnt, x.w - maxH[x.dest]);
                }
                remCnt = min<ll>(remCnt, k / (cnt + 2));
                if (remCnt == 0) { if (k == cnt + 1) { diam--; } break; }
                k -= remCnt * (cnt + 2);
                diam -= remCnt * 2;
                dist[mVal] -= remCnt;
                adj[mVal][edgeIdx[mVal]].w -= remCnt;
                adj[midNode->prev->val][edgeIdx[midNode->prev->val]].w -= remCnt;
                for (auto t : tv) {
                    t.w -= remCnt;
                    if (t.w == maxH[t.dest]) {
    //                    cout << "ms\n";
                        ///Merge mid with son
                        used[t.dest] = 1;
                        for (auto e : adj[t.dest]) {
                            if (e.dest == mVal || used[e.dest]) { continue; }
                            pq.push({ e.w + maxH[e.dest], e.dest });
                        }
                    } else {
                        pq.push(t);
                    }
                }
            } else {
                int remCnt = min(adj[mVal][edgeIdx[mVal]].w - lBound, adj[midNode->prev->val][edgeIdx[midNode->prev->val]].w - lBound);
                remCnt = min(remCnt, k / 2);
                if (k == 1) { diam--; k--; break; }
                adj[mVal][edgeIdx[mVal]].w -= remCnt;
                adj[midNode->prev->val][edgeIdx[midNode->prev->val]].w -= remCnt;
                k -= 2 * remCnt;
                diam -= 2 * remCnt;
                dist[mVal] -= remCnt;
            }
        }
    }
    cout << diam << '\n';
}
