#include <bits/stdc++.h>

using namespace std;

const int maxn = 2e5 + 5;

int n, k;
vector<pair<int, int>> g[maxn];

pair<long long, int> longest;
int diameter;
int highestNotRoot = -1;

void dfsCalc(int node, int par, int w)
{
    if (longest.first < w)
    {
        longest = {w, node};
    }

    for (auto [to, add] : g[node])
    {
        if (to != par) dfsCalc(to, node, w + add);
    }
}

void dfs(int node, int par, int w, int rootChild)
{
    if (w == diameter && highestNotRoot == -1)
    {
        highestNotRoot = rootChild;
    }
    else if (w == diameter)
    {
        if (highestNotRoot != rootChild)
        {
            cout << diameter << endl;
            exit(0);
        }
    }

    for (auto [to, add] : g[node])
    {
        if (to != par)
        {
            if (par == -1) dfs(to, node, w + add, to);
            else dfs(to, node, w + add, rootChild);
        }
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> k;

    for (int i = 1; i < n; ++i)
    {
        int x, y, w;
        cin >> x >> y >> w;

        g[x].push_back({y, w});
        g[y].push_back({x, w});
    }

    longest = {0, -1};
    dfsCalc(1, -1, 0);

    int node = longest.second;
    int root = node;

    longest = {0, -1};

    dfsCalc(node, -1, 0);
    diameter = longest.first;

    dfs(root, -1, 0, -1);
    cout << diameter - 1 << endl;

    return 0;
}
