#include <bits/stdc++.h>
using namespace std;

#ifdef GIGO_DEBUG
#include "Lgrader.cpp"
#else
#include "soft_drinks.h"
#define cout if(false)cout
#endif // GIGO_DEBUG

typedef valarray<double> Vec;
typedef vector<Vec> Matrix;

const double EPSOLON = 1e-6;

Matrix D(3);
int n;

Matrix getValid(double La, double Ra){
    Matrix ret = D;
    valarray<bool> idxs = ret[0] >= La && ret[0] <= Ra;
    for(int i = 0; i < 3; i++){
        ret[i] = valarray<double>(ret[i][idxs]);
    }
    return ret;
}

Vec mul(const Matrix& m, const Vec v){
    return {(m[0]*v).sum(), (m[1]*v).sum(), (m[2]*v).sum()};
}

void init(const vector<int>& A, const vector<int>& B){
    n = A.size();
    D[0].resize(n);
    D[1].resize(n);
    D[2] = Vec(1, n);
    for(int i = 0; i < n; i++){
        D[0][i] = (double)A[i];
        D[1][i] = (double)B[i];
    }
}

const double DELTA = 0.001;
const int STEPS = 1000;

double friendDrink(const int Ma, const int Mb, const int La, const int Ra){ /// gradient ~des~ascent
    Matrix L = getValid(La, Ra);
    int n = L[0].size();

    Vec v(n);
    double currV = v.sum();
    Vec dV(n);
    for(int step = 0; step < STEPS; step++){
        for(int i = 0; i < n; i++){
            v[0] += DELTA;
            Vec res = mul(L, v);
            if(res[0] <= Ma && res[1] <= Mb){
                dV[i] = res[2] - currV;
            }else{
                dV[i] = 0;
            }
            v[0] -= DELTA;
        }
        v += dV;
        currV = v.sum();
    }

    return currV;
}
