#include <bits/stdc++.h>
using namespace std;

#ifdef GIGO_DEBUG
#include "Lgrader.cpp"
#else
#include "soft_drinks.h"
#define cout if(false)cout
#endif // GIGO_DEBUG

typedef valarray<double> Vec;
typedef vector<Vec> Matrix;

const double EPSILON = 1e-6;
const int MAXN = 100007;

int mxA = INT_MIN, mnB = INT_MAX;
Matrix D(3);
int n;

ostream& operator<<(ostream& os, const Vec& v){
    os << "| ";
    for(int i = 0; i < v.size(); i++){ cout << v[i] << ' '; }
    return os << '|';
}

ostream& operator<<(ostream& os, const Matrix& m){
    os << "/----\n";
    for(int i = 0; i < m.size(); i++){ os << m[i] << '\n'; }
    os << "\\----\n";
}

Matrix getValid(double La, double Ra){
    Matrix ret = D;
    valarray<bool> idxs = ret[0] >= La && ret[0] <= Ra;
    for(int i = 0; i < 3; i++){
        ret[i] = valarray<double>(ret[i][idxs]);
    }
    return ret;
}

Vec mul(const Matrix& m, const Vec v){
    return {(m[0]*v).sum(), (m[1]*v).sum(), (m[2]*v).sum()};
}

void init(const vector<int>& A, const vector<int>& B){
    n = A.size();
    D[0].resize(n);
    D[1].resize(n);
    D[2] = Vec(1, n);
    for(int i = 0; i < n; i++){
        D[0][i] = (double)A[i];
        mxA = max(mxA, A[i]);
        D[1][i] = (double)B[i];
        mnB = min(mnB, B[i]);
    }
}

bool canDoWith(const Matrix& L, double Ma, double Mb, double v){
    if(L[0].max() > 0 && Ma == 0){ return false; }
    if(L[1].max() > 0 && Mb == 0){ return false; }

    int n = L[0].size();



//    vector<double> vi(n);
//    double totA = 0, totB = 0;
//    for(int i = 0; i < n; i++){
//        vi[i] = max(v, max((Ma-totA)/L[0][i], (Mb-totB)/L[1][i]));
//        v -= vi[i];
//        totA += vi[i]*L[0][i];
//        totB += vi[i]*L[1][i];
//    }
//    return v == 0;
}

double friendDrink(const int Ma, const int Mb, const int La, const int Ra){ /// gradient ~desc~ ascent
    if(Ma == 0 && mxA == 0){ /// subtask 3
        return Mb / mnB;
    }

    Matrix L = getValid(La, Ra);
    int n = L[0].size();
    if(n == 0){ return 0; }

    double left = 0, right = max(Ma, Mb);
    while(right-left > EPSILON){
        double mid = (right+left)/2;

        if(canDoWith(L, Ma, Mb, mid)){
            left = mid;
        }else{
            right = mid;
        }
    }

    return left;
}
/*
const double DELTA = 0.001;
const int STEPS = 20000;

double friendDrink(const int Ma, const int Mb, const int La, const int Ra){ /// gradient ~desc~ ascent
    Matrix L = getValid(La, Ra);
    int n = L[0].size();

    if(Ma == 0 && L[0].max() == 0){ /// subtask 3
        return Mb;
    }

    Vec v(n);
    double currV = v.sum();
    Vec dV((double)-1, n);
    for(int step = 0; step < STEPS; step++){
        for(int i = 0; i < n; i++){
            v[0] += DELTA;
            Vec res = mul(L, v);
            dV[i] = (res[2] - currV);
            if(res[0] > Ma || res[1] > Mb){
                dV[i] = 0;
            }
            v[0] -= DELTA;
        }
        if(step % 1000 == 0) cout << currV << ' ' << dV << '\n';
        v += dV;
        currV = v.sum();
    }

    return currV;
}
*/
