#include <bits/stdc++.h>
using namespace std;

#ifdef GIGO_DEBUG
#include "Lgrader.cpp"
#else
#include "soft_drinks.h"
#define cout if(false)cout
#endif // GIGO_DEBUG

typedef valarray<double> Vec;
typedef vector<Vec> Matrix;

const double EPSILON = 1e-6;
const int MAXN = 100007;
const int MAXLOG = 18;

vector<int> A, B;
vector<pair<int, int>> drinksA, drinksB;
int mxA = INT_MIN;
Matrix D(3);
int n;

struct SparseTable{
    vector<double> table[MAXLOG];
    int n = -1, k = -1;
    int getPow(int n){
        int k = 1;
        while(1<<k <= n){ k ++; }
        return k;
    }
    void build(const vector<int>& v){
        n = v.size(); k = getPow(n);
        table[0].resize(n);
        for(int i = 0; i < n; i++){
            table[0][i] = v[i];
        }
        construct();
    }
    void build(const vector<pair<int, int>>& v){
        n = v.size(); k = getPow(n);
        table[0].resize(n);
        for(int i = 0; i < n; i++){
            table[0][i] = v[i].second;
        }
        construct();
    }
    void construct(){
        cout << "--\n";
        for(int i = 1; i <= k; i++){
            table[i].resize(n);
            int len = 1<<i;
            for(int j = 0; j < n-len+1; j++){
                table[i][j] = min(table[i-1][j], table[i-1][ j + len/2]);
                cout << table[i][j] << ' ';
            }
            cout << '\n';
        }
        cout << "--\n";
    }
    int query(int l, int r){
        int pow = getPow(r-l+1)-1;
        cout << l << ' ' << r << ": " << pow << '\n';
        return min(table[pow][l], table[pow][r-(1<<pow)+1]);
    }
};

ostream& operator<<(ostream& os, const Vec& v){
    os << "| ";
    for(int i = 0; i < v.size(); i++){ cout << v[i] << ' '; }
    return os << '|';
}
ostream& operator<<(ostream& os, const pair<int, int>& v){
    return os << "(" << v.first << ", " << v.second << ")";
}
template<typename T>
ostream& operator<<(ostream& os, const vector<T>& v){
    os << "{";
    for(int i = 0; i < v.size(); i++){ cout << v[i] << ", "; }
    return os << '}';
}

ostream& operator<<(ostream& os, const Matrix& m){
    os << "/----\n";
    for(int i = 0; i < m.size(); i++){ os << m[i] << '\n'; }
    return os << "\\----\n";
}

Matrix getValid(double La, double Ra){
    Matrix ret = D;
    valarray<bool> idxs = ret[0] >= La && ret[0] <= Ra;
    for(int i = 0; i < 3; i++){
        ret[i] = valarray<double>(ret[i][idxs]);
    }
    return ret;
}

Vec mul(const Matrix& m, const Vec v){
    return {(m[0]*v).sum(), (m[1]*v).sum(), (m[2]*v).sum()};
}

SparseTable drinksASpTab;

void init(const vector<int>& _A, const vector<int>& _B){
    A = _A; B = _B;

    n = A.size();
    D[0].resize(n);
    D[1].resize(n);
    D[2] = Vec(1, n);

    for(int i = 0; i < n; i++){
        D[0][i] = (double)A[i];
        mxA = max(mxA, A[i]);
        D[1][i] = (double)B[i];
        drinksA.push_back({A[i], B[i]});
    }
//    drinksB = drinksA;

    sort(drinksA.begin(), drinksA.end(), [](pair<int, int> a, pair<int, int> b)->bool{
        if(a.first != b.first){ return a.first < b.first; }
        return a.second < b.second;
     });
     drinksASpTab.build(drinksA);
//     sort(drinksB.begin(), drinksB.end(), [](pair<int, int> a, pair<int, int> b)->bool{
//        if(a.second != b.second){ return a.second < b.second; }
//        return a.first < b.first;
//     });
}

bool canDoWith(const Matrix& L, double Ma, double Mb, double v){
    if(L[0].max() > 0 && Ma == 0){ return false; }
    if(L[1].max() > 0 && Mb == 0){ return false; }

    int n = L[0].size();



//    vector<double> vi(n);
//    double totA = 0, totB = 0;
//    for(int i = 0; i < n; i++){
//        vi[i] = max(v, max((Ma-totA)/L[0][i], (Mb-totB)/L[1][i]));
//        v -= vi[i];
//        totA += vi[i]*L[0][i];
//        totB += vi[i]*L[1][i];
//    }
//    return v == 0;
}

double friendDrink(const int Ma, const int Mb, const int La, const int Ra){ /// gradient ~desc~ ascent
    if(Ma == 0 && mxA == 0){ /// subtask 3
        cout << "MAZNA\n";
        pair<int, int> p1 = {La, -1}, p2 = {Ra, -1};
        int from = distance(drinksA.begin(), lower_bound(drinksA.begin(), drinksA.end(), p1));
        if(from == drinksA.size()){ return 0; }
        int to = distance(drinksA.begin(), upper_bound(drinksA.begin(), drinksA.end(), p2)-1);
        cout << drinksA << ' ' << La << ' ' << Ra << ' ' << from << ' ' << to << '\n';
        double mnB = drinksASpTab.query(from, to);
        cout << mnB << '\n';
        return Mb / mnB;
    }

    Matrix L = getValid(La, Ra);
    int n = L[0].size();
    if(n == 0){ return 0; }

    double left = 0, right = max(Ma, Mb);
    while(right-left > EPSILON){
        double mid = (right+left)/2;

        if(canDoWith(L, Ma, Mb, mid)){
            left = mid;
        }else{
            right = mid;
        }
    }

    return left;
}
/*
const double DELTA = 0.001;
const int STEPS = 20000;

double friendDrink(const int Ma, const int Mb, const int La, const int Ra){ /// gradient ~desc~ ascent
    Matrix L = getValid(La, Ra);
    int n = L[0].size();

    if(Ma == 0 && L[0].max() == 0){ /// subtask 3
        return Mb;
    }

    Vec v(n);
    double currV = v.sum();
    Vec dV((double)-1, n);
    for(int step = 0; step < STEPS; step++){
        for(int i = 0; i < n; i++){
            v[0] += DELTA;
            Vec res = mul(L, v);
            dV[i] = (res[2] - currV);
            if(res[0] > Ma || res[1] > Mb){
                dV[i] = 0;
            }
            v[0] -= DELTA;
        }
        if(step % 1000 == 0) cout << currV << ' ' << dV << '\n';
        v += dV;
        currV = v.sum();
    }

    return currV;
}
*/
