#include "soft_drinks.h"
#include <bits/stdc++.h>

int A1, A2;
int B1, B2;

double line_max_value(float l, float r, float slope, float inter) {
    float lval = slope*l + inter;
    float rval = slope*r + inter;

    return std::max(lval, rval);
}

double compute(int A1, int A2, int B1, int B2, int Ma, int Mb) {
    double max_x = std::min(Ma/A1, Mb/B1);
    double boundary = (Mb*B2 - Ma*A2) / (B1*B2-A1*A2);

    float s1_slope =  1 - A1/A2;
    float s1_inter = Ma/A2;

    float s2_slope = 1 - B1/B2;
    float s2_inter = Mb/B2;

    if (boundary >= max_x) {
        return line_max_value(0, max_x, s1_slope, s1_inter);
    } else if (boundary <= 0) {
        return line_max_value(0, max_x, s2_slope, s2_inter);
    } else {
        return std::max(
            line_max_value(0, boundary,     s1_slope, s1_inter),
            line_max_value(boundary, max_x, s2_slope, s2_inter)
        );
    }
}

void init(const std::vector<int>& A, const std::vector<int>& B) {
	A1 = A[0]; A2 = A[1];
	B1 = B[0]; B2 = B[1];
}

double friendDrink(int Ma, int Mb, int La, int Ra) {
	return compute(A1, A2, B1, B2, Ma, Mb);
}
