#include <iostream>
#include <cstring>
#include <vector>
#define endl '\n'

using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
}

struct edge
{
    int to;
    long long weight;

    edge(int _to, long long _weight)
    {
        to = _to;
        weight = _weight;
    }

    edge()
    {
        to = 0;
        weight = 0;
    }
};

const int MAXN = (int)2e5 + 5;

vector < edge > v[MAXN];
long long dist[MAXN];
long long n, k, d;

void read()
{
    cin >> n >> k;

    int a, b, w;

    for(int i = 1 ; i < n ; i++)
    {
        cin >> a >> b >> w;

        v[a].push_back({b, w});
        v[b].push_back({a, w});
    }
}

void dfs(edge node, edge parent)
{
    for(edge nb : v[node.to])
    {
        if(nb.to == parent.to)
            continue;

        dist[nb.to] = dist[node.to] + nb.weight;

        dfs(nb, node);
    }
}

void findDiameter()
{
    dfs({1, 0}, {0, 0});

    long long hight = -1;
    int hIdx;
    for(int i = 1 ; i <= n ; i++)
    {
        if(hight < dist[i])
        {
            hight = dist[i];
            hIdx = i;
        }
    }

    memset(dist, 0, sizeof(dist));

    long long diameter = -1;
    int dIdx = 0;

    dfs({hIdx, 0}, {0, 0});

    for(int i = 1 ; i <= n ; i++)
    {
        if(diameter < dist[i])
        {
            diameter = dist[i];
            dIdx = i;
        }
    }

    d = diameter;
}

int main()
{
    speed();

    read();

    findDiameter();

    if(d == 0)
    {
        cout << 0 <<endl;
        return 0;
    }

    cout << d - k << endl;

    return 0;
}
/**
8 0
1 2 1
1 7 1
8 3 1
1 6 1
6 2 1
6 5 1
5 4 1

5 6
1 2 1
2 3 1
2 4 1
4 5 1
**/
