#include <iostream>
#include <cstring>
#include <queue>
#define endl '\n'

using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
}

struct edge
{
    int to;
    long long weight;

    edge(int _to, long long _weight)
    {
        to = _to;
        weight = _weight;
    }

    edge()
    {
        to = 0;
        weight = 0;
    }
};

const int MAXN = (int)2e5 + 5;

vector < edge > v[MAXN];
int dIdx = 0, num = 0;
long long dist[MAXN];
long long used[MAXN];
long long n, k, d;
int parent[MAXN];
vector < int > c;

void read()
{
    cin >> n >> k;

    int a, b, w;

    for(int i = 1 ; i < n ; i++)
    {
        cin >> a >> b >> w;

        v[a].push_back({b, w});
        v[b].push_back({a, w});
        parent[b] = a;
    }
}

void dfs(edge node, edge parent)
{
    for(edge nb : v[node.to])
    {
        if(nb.to == parent.to)
            continue;

        dist[nb.to] = dist[node.to] + nb.weight;

        dfs(nb, node);
    }
}

void bfs(edge start)
{
    queue < edge > q;

    used[start.to] = 1;
    q.push(start);
    while(!q.empty())
    {
        edge node = q.front();
        q.pop();

        for(edge nb : v[node.to])
        {
            if(!used[nb.to])
            {
                q.push(nb);
                used[nb.to] = used[node.to] + 1;
            }
        }
    }

}

void findDiameter()
{
    bfs({1, 0});

    long long height = -1;
    int hIdx = 0;
    for(int i = 1 ; i <= n ; i++)
    {
        if(height < used[i] - 1)
        {
            height = used[i] - 1;
            hIdx = i;
        }
    }

    memset(used, 0, sizeof(used));
    bfs({hIdx, 0});

    long long diameter = -1;
    dIdx = 0;
    num = 0;
    for(int i = 1 ; i <= n ; i++)
    {
        if(diameter < used[i] - 1)
        {
            diameter = used[i] - 1;
            dIdx = i;
            num = 0;
            c.clear();
            c.push_back(i);
        }
        else if(diameter == used[i] - 1)
        {
            num++;
            c.push_back(i);
        }
    }

    d = diameter;
}

int main()
{
    speed();

    read();

    int k1 = k;

    while(true)
    {
        if(k1 == 0 || d == 0)
            break;

        findDiameter();

        for(int i : c)
        {
            if(k1 == 0)
                break;

            for(edge j : v[i])
            {
                if(k1 == 0)
                    break;

                if(j.to == parent[dIdx])
                {
                    j.weight = 0;
                    k1--;
                }
            }
        }
    }

    findDiameter();

    cout << d <<endl;

    return 0;
}
/**
8 0
1 2 1
1 7 1
8 3 1
1 6 1
6 2 1
6 5 1
5 4 1

5 6
1 2 1
2 3 1
2 4 1
4 5 1

7 3
1 3 1
3 2 1
1 5 1
5 7 1
1 4 1
4 6 1

9 3
1 3 1
3 2 1
1 5 1
5 7 1
1 4 1
4 6 1
1 8 1
8 9 1
**/
