#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 200008
using namespace std;

int ans = 0;
int dpr[MAXN];
vector<pair<int,int> >edges[MAXN];

void dfs1(int s, int p)
{
    for (auto [next,w] : edges[s])
    {
        if ( next != p )
        {
            dpr[next] = dpr[s] + w;
            dfs1(next, s);

        }
    }
}
int n;
int depth[MAXN];
const int LOG = 18;
int parent[MAXN][LOG];
void dfsDepths(int s, int p)
{
    depth[s] = depth[p]+1;
    parent[s][0] = p;
    for (auto [next,w] : edges[s])
    {
        if ( next != p )
        {
            dfsDepths(next, s);
        }
    }
}
void lca_code()
{
    dfsDepths(1, 0);

    ///precomputing
    for (int j=1; j<LOG; j++)
    {
        for (int i=1; i<=n; i++)
        {
            if ( parent[i][j-1] != -1 ) /// never happening
            {
                parent[i][j] = parent[ parent[i][j-1] ][j-1];
            }
        }
    }
}
int findLCAnode(int v, int u)
{
    if ( depth[v] > depth[u] ) swap(v, u);

    int diff = depth[u] - depth[v];

    for ( int st = 18; st>=0; st--)
    {
        if ( diff & (1<<st) )
        {
            u = parent[u][st];
            v = parent[v][st];
        }
    }
    return u;
}
unordered_set<int> leaves;
void findLeaves()
{
    for (int i=1; i<=n; i++)
    {
        if ( edges[i].size() == 1 ) leaves.insert(i);
    }
}


int sum;

void dfsDia(int s, int p)
{
    if ( sum > ans ) ans = sum;
    for (auto [next,w] : edges[s])
    {
        if ( next != p )
        {
            sum += w;
            dfsDia(next, s);
            sum -= w;
        }
    }
}



int main()
{

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int k;
    cin >> n >> k;

    for (int j=0; j<n-1; j++)
    {
        int b, e, w;
        cin >> b >> e >> w;
        edges[b].push_back({e, w});
        edges[e].push_back({b, w});
    }

    if ( n <= 2000 )
    {
        for (int i=1; i<=n; i++)
        {
            if ( edges[i].size() == 1 )
            {
                sum = 0;
                dfsDia(i, -1);
            }
        }
        cout << ans << endl;
        return 0;
    }

    dfs1(1, 0);

    lca_code();
    //cerr << "lca" << endl;
    //cerr << findLCAnode(1, 2) << endl;
    //cerr << findLCAnode(2, 3) << endl;
    //cerr << findLCAnode(2, 5) << endl;
    //cerr << findLCAnode(1, 5) << endl;
    //cerr << findLCAnode(5, 5) << endl;

    findLeaves();

    for ( auto l1 : leaves)
        for (auto l2 : leaves)
        {
            //cerr << l1 << " " << l2 << endl;
            int r = findLCAnode(l1, l2);

            int dia = dpr[l1] - dpr[r] + dpr[l2] - dpr[r];

            if ( dia > ans ) ans = dia;
        }
    //cerr << "ANS:: ";
    cout << ans << endl;
}
/**
5 0
1 2 5
2 3 4
2 4 3
4 5 2
----------------
lca
1
2
2
1
5
ans
10
*/
