/**
    az sum silata
    retro mashinata
*/

#include <iostream>
#include "soft_drinks.h"
#include <algorithm>

#define maxn 200005
#define maxlog 20
#define control std::cout << "passed" << "\n";
#define X first
#define Y second

typedef std::pair <int , int> pii;

int n;
int best;

int tree[maxn * 4];
pii a[maxn];

void update(int node , int l , int r , int qp , int qval)
{
    if(l == r)
    {
        tree[node] = qval;
        return;
    }

    int mid = (l + r) / 2;

    if(qp <= mid)
        update(node * 2 , l , mid , qp , qval);
    else
        update(node * 2 + 1 , mid + 1 , r , qp , qval);

    tree[node] = std::min(tree[node * 2] , tree[node * 2 + 1]);
}


int query(int node , int l , int r , int ql , int qr)
{
    if(a[l].X > qr || a[r].X < ql)
        return 1e9;

    if(a[l].X >= ql && a[r].X <= qr)
        return tree[node];

    int mid = (l + r) / 2;

    return std::min(query(node * 2 , l , mid , ql , qr) ,
                        query(node * 2 + 1 , mid + 1 , r , ql , qr));
}



void init(const std::vector<int>& A, const std::vector<int>& B)
{
    n = A.size();
    best = 1e9;

    for(int i = 0; i < n; i++)
        a[i] = {A[i] , B[i]};

    std::sort(a , a + n);

    for(int i = 0; i < n; i++)
    {
        update(1 , 0 , n - 1 , i , std::max(a[i].X , a[i].Y));
    }
}


double friendDrink(int Ma, int Mb, int La, int Ra)
{
    if(La > a[n - 1].X || Ra < a[0].X)
        return 0;

    int bb = query(1 , 0 , n - 1 , La , Ra);

    return ((double)(Ma) / (double)(bb));
}

