/**
    az sum silata
    retro mashinata
*/

#include <iostream>
#include "soft_drinks.h"
#include <algorithm>

#define maxn 200005
#define maxlog 20
#define control std::cout << "passed" << "\n";
#define X first
#define Y second

typedef long long ll;
typedef std::pair <ll , ll> pii;

ll n;
ll best;

ll tree[maxn * 4];
pii a[maxn];

void update(ll node , ll l , ll r , ll qp , ll qval)
{
    if(l == r)
    {
        tree[node] = qval;
        return;
    }

    ll mid = (l + r) / 2;

    if(qp <= mid)
        update(node * 2 , l , mid , qp , qval);
    else
        update(node * 2 + 1 , mid + 1 , r , qp , qval);

    tree[node] = std::min(tree[node * 2] , tree[node * 2 + 1]);
}


ll query(ll node , ll l , ll r , ll ql , ll qr)
{
    if(a[l].X > qr || a[r].X < ql)
        return 1e9;

    if(a[l].X >= ql && a[r].X <= qr)
        return tree[node];

    ll mid = (l + r) / 2;

    return std::min(query(node * 2 , l , mid , ql , qr) ,
                        query(node * 2 + 1 , mid + 1 , r , ql , qr));
}



void init(const std::vector<ll>& A, const std::vector<ll>& B)
{
    n = A.size();
    best = 1e9;

    for(ll i = 0; i < n; i++)
        a[i] = {A[i] , B[i]};

    std::sort(a , a + n);

    //for(ll i = 0; i < n; i++)
      //  std::cout << "-> " << a[i].X << " " << a[i].Y << "\n";

    for(ll i = 0; i < n; i++)
    {
        update(1 , 0 , n - 1 , i , std::max(a[i].X , a[i].Y));
    }
}


double friendDrink(ll Ma, ll Mb, ll La, ll Ra)
{
    if(La > a[n - 1].X || Ra < a[0].X)
        return 0;

    ll bb = query(1 , 0 , n - 1 , La , Ra);

    double ans = (double)Mb / (double)(bb);
    return ans;
}

