/**
    az sum silata
    retro mashinata
*/

#include <iostream>
#include "soft_drinks.h"
#include <algorithm>

#define maxn 200005
#define maxlog 20
#define control std::cout << "passed" << "\n";
#define X first
#define Y second

typedef long long ll;
typedef std::pair <ll , ll> pii;

ll n;
ll best;

ll tree[maxn * 4];
pii a[maxn];

void build(ll node , ll l , ll r)
{
    if(l == r)
    {
        tree[node] = std::max(a[l].X , a[l].Y);
        return;
    }

    int mid = (l + r) / 2;

    build(node * 2 , l , mid);
    build(node * 2 + 1 , mid + 1 , r);

    tree[node] = std::min(tree[node * 2] , tree[node * 2 + 1]);
}


ll query(ll node , ll l , ll r , ll ql , ll qr)
{
    if(a[l].X > qr || a[r].X < ql)
        return 1e9 + 1;

    if(a[l].X >= ql && a[r].X <= qr)
        return tree[node];

    ll mid = (l + r) / 2;

    return std::min(query(node * 2 , l , mid , ql , qr) ,
                        query(node * 2 + 1 , mid + 1 , r , ql , qr));
}



void init(const std::vector<int>& AA, const std::vector<int>& BB)
{
    n = AA.size();
    best = 1e9;

    for(ll i = 0; i < n; i++)
        a[i] = {AA[i] , BB[i]};

    std::sort(a , a + n);

    //for(ll i = 0; i < n; i++)
      //  std::cout << "-> " << a[i].X << " " << a[i].Y << "\n";

    build(1 , 0 , n - 1);
}


double friendDrink(int Ma, int Mb, int La, int Ra)
{
    if(La > a[n - 1].X || Ra < a[0].X)
        return 0;

    ll bb = query(1 , 0 , n - 1 , La , Ra);

    if(bb == 1e9 + 1)
        return 0;

    double ans = (double)Mb / (double)(bb);
    return ans;
}

