#include<bits/stdc++.h>
#include "soft_drinks.h"
using namespace std;

vector<pair<int,int>> drinks;
void init(const std::vector<int>& A, const std::vector<int>& B) {
    drinks.reserve(A.size());
    for(int i = 0; i < A.size(); i++) {
        drinks.push_back({A[i],B[i]});
    }
    sort(drinks.begin(),drinks.end());
    //for(pair<int,int> p: drinks) printf("{%d,%d}\n",p.first,p.second);
}

double solveV(int i, int j, int Ma, int Mb, int zA, int zB) {

    int a = drinks[i].first;
    int b = drinks[i].second;
    int c = drinks[j].first;
    int d = drinks[j].second;
    //printf("try drinks (%d,%d), values (%d,%d) and (%d,%d) for [%d,%d]\n",i,j,a,b,c,d,Ma,Mb);
    if(a == 0 && c == 0) return Mb / min(b, d);
    if(b == 0 && d == 0) return Ma / min(a, c);

    if(a > c) {
        swap(a,c);
        swap(b,d);
    }
    if(a == c && b > d) swap(b,d);
    /// Strictly Superior
    if(b <= d) {
        double limA = double(Ma) / a;
        double limB = double(Mb) / b;
        if(limA < limB) {
            if(zB != 0) return limA + (Mb - limA * b) / zB;
            else return limA;
        }
        else
            if(zA != 0) return limB + (Ma - limB * a) / zA;
            else return limB;
    }
    /// Linearly Independent
    if(b * Ma <= a * Mb) {
        if(zB == 0) return double(Ma) / a;
        else return double(Ma) / a + (Mb - b * double(Ma) / a) / zB;
    }
    if(d * Ma >= c * Mb) {
        if(zA == 0) return double(Mb) / d;
        else return double(Mb) / d + (Ma - c * double(Mb) / d) / zA;
    }
    double x = double(c * Mb - d * Ma) / (b * c - a * d);
    double y = double(a * Mb - b * Ma) / (a * d - b * c);
    return x + y;
}

double friendDrink(const int Ma, const int Mb, const int La, const int Ra) {
    int lb = -1, rb = drinks.size();
    for(int i = 0; i < rb; i++) {
        if(lb == -1 && drinks[i].first >= La) lb = i;
        if(drinks[i].first > Ra) {
            rb = i;
        }
    }
    if(lb == -1) lb = 0;
    int minzA = 1000000009;
    int minzB = 1000000009;
    for(int i = lb; i < rb; i++) {
        if(drinks[i].first == 0) minzB = min(minzB, drinks[i].second);
        if(drinks[i].second == 0) minzA = min(minzA, drinks[i].first);
    }
    if(minzA == 1000000009) minzA = 0;
    if(minzB == 1000000009) minzB = 0;

    double maxV = 0;
    for(int i = lb; i < rb; i++) {
        for(int j = i + 1; j < rb; j++) {
            auto res = solveV(i, j, Ma, Mb, minzA, minzB);
            //printf("res %f\n",res);
            maxV = max(maxV, res);
        }
    }
    return maxV;
}
