#include <bits/stdc++.h>
using namespace std;
#define endl '\n'

const int maxn = 1 + 2e5;
int dist[maxn], depth[maxn], up[25][maxn], ans = 0, node;
vector<pair<int, int>> edges[maxn];
bool visited[maxn];

int lca(int u, int v) {
  if (depth[u] < depth[v])
    swap(u, v);

  for (int i = 25; i >= 0; i--)
    if (up[i][u] != 0 && depth[u] - (1 << i) >= depth[v])
      u = up[i][u];
  if (u == v)
    return u;

  for (int i = 25; i >= 0; i--)
    if (up[i][u] != up[i][v] && up[i][u] != 0)
      u = up[i][u], v = up[i][v];
  return up[0][u];
}

void dfs(int u) {
  visited[u] = true;
  if (dist[u] > ans)
    ans = dist[u], node = u;

  for (auto &e : edges[u]) {
    int next = e.first, w = e.second;
    if (!visited[next]) {
      depth[next] = depth[u] + 1;
      dist[next] = dist[u] + w;
      dfs(next);
    }
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, k;
  cin >> n >> k;

  for (int i = 1; i < n; i++) {
    int u, v, w;
    cin >> u >> v >> w;
    edges[u].push_back({v, w});
    edges[v].push_back({u, w});
  }
  dfs(1);
  for (int i = 1; i < 25; i++)
    for (int j = 1; j <= n; j++)
      up[i][j] = up[i - 1][up[i - 1][j]];

  auto clear = []() {
    fill_n(visited, maxn, false);
    fill_n(dist, maxn, 0);
    ans = 0;
  };

  clear();
  int start = node;
  dfs(node);
  int old_ans = ans;

  int anc = lca(start, node);
  pair<int, int> edge{-1, -1};
  for (auto &e : edges[anc]) {
    if (depth[e.first] < depth[anc]) {
      edge = e;
      break;
    }
  }

  clear();
  if (edge.first != -1) {
    int v = edge.first;
    edges[anc].erase(find(begin(edges[anc]), end(edges[anc]), edge));
    edges[v].erase(
        find(begin(edges[v]), end(edges[v]), make_pair(v, edge.second)));
  }
  dfs(1);
  clear();
  dfs(node);

  if (old_ans == ans)
    cout << ans - k << endl;
  else
    cout << old_ans << endl;
}