#include<bits/stdc++.h>
#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")

#define MAXN 100007
using namespace std;

struct drink{
    long double a,b;

    inline friend bool operator < (drink fr,drink sc){
        if(fr.a!=sc.a)return fr.a < sc.a;
        return fr.b<sc.b;
    }
}s[MAXN];

int n;

void init(const vector<int>& A, const vector<int>& B){
    n=int(A.size());


    for(int i=1;i<=n;i++){
        s[i]={A[i-1],B[i-1]};
    }

    sort(s+1,s+n+1);
}

long double calc(long double x,long double y,drink t){
    if(t.a==0)return y/t.b;
    if(t.b==0)return x/t.a;
    return min(x/t.a,y/t.b);
}

long double bro(drink s,drink t,long double x,long double y,long double c){
    if(c<0)return 0.0;

    return c + calc(x-s.a*c,y-s.b*c,t);
}

const long double eps=0.0000005;

long double solve(drink s,drink t,long double x,long double y){
    long double up=calc(x,y,s);
    long double l=0,r=up;

    for(int i=1;i<=80;i++){
        long double mid=(r-l)/3.0;

        if(bro(s,t,x,y,l+mid) > bro(s,t,x,y,r-mid)){
            r-=mid;
        }else{
            l+=mid;
        }
    }

    long double res=0.0;
    for(int i=-5;i<=5 and r+i*eps<=up;i++){
        res=max(res,bro(s,t,x,y,r+i*eps));
    }

    return res;
}

double friendDrink(int Ma, int Mb, int La, int Ra){
    vector<drink> d;
    drink t={Ma,Mb};

    for(int i=1;i<=n;i++){
        if(s[i].a<La or s[i].a>Ra)continue;

        if(!d.empty() and d.back().b<=s[i].b)continue;
        d.push_back(s[i]);
    }

    if(d.empty())return 0.0;

    long double ans=0.0;

    int pt=d.size()-1;
    for(int i=0;i<d.size();i++){
        long double last=solve(d[i],d[pt],Ma,Mb);
        //if(i>pt)break;
        while(pt>0){
            long double s=solve(d[i],d[pt-1],Ma,Mb);
            if(s>=last){
                pt--;
                last=s;
            }else break;
        }

        for(int f=-12;f<=0;f++){
            if(pt+f<0 or pt+f>=d.size())continue;
            ans=max(ans,solve(d[i],d[pt+f],Ma,Mb));
        }
    }

    reverse(d.begin(),d.end());

    pt=d.size()-1;
    for(int i=0;i<d.size();i++){

        long double last=solve(d[i],d[pt],Ma,Mb);
        //if(i>pt)break;
        while(pt>0){
            long double s=solve(d[i],d[pt-1],Ma,Mb);
            if(s>=last){
                pt--;
                last=s;
            }else break;
        }

        for(int f=-12;f<=0;f++){
            if(pt+f<0 or pt+f>=d.size())continue;
            ans=max(ans,solve(d[i],d[pt+f],Ma,Mb));
        }
    }

    return ans;
}

/*int main(){

    init({4, 2, 6, 3}, {0, 8, 4, 6});
    cout<<friendDrink(8, 2, 4, 6)<<":\n";
    cout<<friendDrink(8, 2, 3, 6)<<":\n";
    cout<<friendDrink(0, 10, 0, 10)<<":\n";

    return 0;
}*/