#include<bits/stdc++.h>
#define MAXN 200007
using namespace std;

const int inf=2e9;

struct SegmentTree{
    pair<int,int> tree[4*MAXN];
    int lazy[4*MAXN];

    pair<int,int> combine(pair<int,int> fr,pair<int,int> sc){
        if(fr.first<sc.first)return fr;
        return sc;
    }

    void psh(int v){
        if(lazy[v]==0)return;

        tree[2*v].first-=lazy[v];
        lazy[2*v]+=lazy[v];

        tree[2*v+1].first-=lazy[v];
        lazy[2*v+1]+=lazy[v];

        lazy[v]=0;
    }

    int getval(int v,int l,int r,int pos){
        if(l==r)return tree[v].first;

        int tt=(l+r)/2;
        psh(v);

        if(pos<=tt)return getval(2*v,l,tt,pos);
        else return getval(2*v+1,tt+1,r,pos);
    }

    void update(int v,int l,int r,int pos,int cap){
        if(l==r){
            tree[v]={cap,l};
        }else{
            int tt=(l+r)/2;
            psh(v);

            if(pos<=tt)update(2*v,l,tt,pos,cap);
            else update(2*v+1,tt+1,r,pos,cap);

            tree[v]=combine(tree[2*v],tree[2*v+1]);
        }
    }

    void rem(int v,int l,int r,int ll,int rr,int val){
        if(ll>rr)return;

        if(l==ll and r==rr){
            tree[v].first-=val;
            lazy[v]+=val;
        }else{
            int tt=(l+r)/2;
            psh(v);

            rem(2*v,l,tt,ll,min(tt,rr),val);
            rem(2*v+1,tt+1,r,max(tt+1,ll),rr,val);

            tree[v]=combine(tree[2*v],tree[2*v+1]);
        }
    }

    int mins(){
        return tree[1].first;
    }
}tree;

int n,a,b,c,deg[MAXN];

vector< pair<int,int> > v[MAXN];
vector< pair<int,int> > w[MAXN];
queue<int> q;

long long total,k;

int center,diameter,x,y,parent[MAXN];
int cost[MAXN],num,pos[MAXN],ret[MAXN],edge[MAXN];
bool vis[MAXN];

void dfs(int x,int p,int d){
    if(d>diameter){
        diameter=d;
        y=x;
    }

    for(auto nxt:w[x]){
        if(nxt.first==p)continue;
        dfs(nxt.first,x,d+nxt.second);
    }
}

void dfss(int x,int p){
    parent[x]=p;

    for(auto nxt:v[x]){
        if(nxt.first==p or vis[nxt.first])continue;
        dfss(nxt.first,x);
    }
}

int main(){

    //ios_base::sync_with_stdio(0);

    //cin.tie(0);
   // cout.tie(0);

    cin>>n>>k;

    int sum=0;
    for(int i=1;i<=n-1;i++){
        cin>>a>>b>>c;
        sum+=c;

        v[a].push_back({b,c});
        v[b].push_back({a,c});

        deg[a]++; deg[b]++;
    }

    if(k>=sum){
        cout<<0<<"\n";
        return 0;
    }

    k=sum-k;
    for(int i=1;i<=n;i++)tree.update(1,1,n,i,inf);

    for(int i=1;i<=n;i++){
        if(deg[i]==1){

            num++; pos[i]=num; ret[num]=i; vis[i]=true;
            cost[i]=v[i][0].second;
            parent[i]=v[i][0].first;

            tree.update(1,1,n,num,cost[i]);
            total++; 
        }
    }

    while(k>0){

        long long val=tree.mins();
        
        if(total*val>=k){

            long long tims=k/total;
            tree.rem(1,1,n,1,num,tims);

            k%=total;

            for(int i=1;i<=num and k>0;i++){
                if(tree.getval(1,1,n,i)<=10000){
                    tree.rem(1,1,n,i,i,1);
                    k--;
                }
            }

            for(int i=1;i<=num;i++){
                if(tree.getval(1,1,n,i)<=10000){
                    edge[ret[i]]=cost[ret[i]] - tree.getval(1,1,n,i);
                }
            }
        }else{
            k-=total*val;

            tree.rem(1,1,n,1,num,val);
            int ver=ret[tree.tree[1].second];

            tree.update(1,1,n,pos[ver],inf);
            edge[ver]=cost[ver]; total--;

            int sp=0;
            for(auto nxt:v[ver]){
                deg[nxt.first]--;

                if(deg[nxt.first]==1)sp=nxt.first;
                if(!vis[nxt.first])parent[ver]=nxt.first;
            }

            if(sp==0)continue;

            for(auto nxt:v[sp]){
                if(!vis[nxt.first]){
                    cost[sp]=nxt.second;
                    parent[sp]=nxt.first;
                }
            }

            num++; pos[sp]=num; ret[num]=sp; vis[sp]=true;
            tree.update(1,1,n,num,cost[sp]);
            total++;
        }
    }

    for(int i=1;i<=n;i++)vis[i]=true;

    vector<int> z;
    for(int i=1;i<=n;i++){
        if(parent[i]==0){
            z.push_back(i);
            vis[i]=false;
        }
    }
    
    if(!z.empty())dfss(z[0],0);

    for(int i=1;i<=n;i++){
        if(parent[i]==0)continue;

        w[i].push_back({parent[i],edge[i]});
        w[parent[i]].push_back({i,edge[i]});
    }

    dfs(1,0,0);
    x=y;
    dfs(x,0,0);

    cout<<diameter<<"\n";

    return 0;
}