/*
    Zarad tebe vdigam vurtoleta
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <random>
#include <chrono>
#include <vector>
#include <stack>
#include <queue>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

template <typename T>
using OSet = __gnu_pbds::tree <T, __gnu_pbds::null_type, std::less <T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

typedef long long llong;
// const llong TIME = std::chrono::steady_clock::now().time_since_epoch().count();
const int MAXN = 1000000 + 10;
const int MAXLOG = 20;
const int INF  = 2e9 + 1;

int n;
int a[MAXN];
int b[MAXN];
double checkTwo(double a1, double b1, double a2, double b2, double mA, double mB)
{
    if (mA == 0) return 0;
    if (mB == 0) return 0;
    if (a1 <= a2 && b1 <= b2)
    {
        return 0;
    }

    if (a2 <= a1 && b2 <= b1)
    {
        return 0;
    }

    if (a1 < a2)
    {
        std::swap(a1, a2);
        std::swap(b1, b2);
    }

    return (double)(mA * (b2 - b1) + mB * (a1 - a2)) / (a1 * b2 - a2 * b1);
}

double checkOne(double a, double b, double mA, double mB)
{
    return std::min(mA / a, mB / b);
}

void init(const std::vector <int> &A, const std::vector <int> &B)
{
    n = A.size();
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] = A[i - 1];
        b[i] = B[i - 1];
    }
}

double friendDrink(int mA, int mB, int lA, int rA)
{
    std::vector <std::pair <int,int>> candidates;
    for (int i = 1 ; i <= n ; ++i)
    {
        if (lA <= a[i] && a[i] <= rA)
        {
            candidates.push_back({a[i], b[i]});
        }
    }

    double ans = 0.0;
    for (int i = 0 ; i < candidates.size() ; ++i)
    {
        ans = std::max(ans, checkOne(candidates[i].first, candidates[i].second, mA, mB));
        for (int j = i + 1 ; j < candidates.size() ; ++j)
        {
            ans = std::max(ans, checkTwo(candidates[i].first, candidates[i].second, candidates[j].first, candidates[j].second, mA, mB));
        }
    }

    return ans;
}