/*
    Zarad tebe vdigam vurtoleta
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <random>
#include <chrono>
#include <vector>
#include <stack>
#include <queue>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

template <typename T>
using OSet = __gnu_pbds::tree <T, __gnu_pbds::null_type, std::less <T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

typedef long long llong;
// const llong TIME = std::chrono::steady_clock::now().time_since_epoch().count();
const int MAXN = 1000000 + 10;
const int MAXLOG = 20;
const int INF  = 2e9 + 1;

int n;
int a[MAXN];
int b[MAXN];
double checkTwo(double a1, double b1, double a2, double b2, double mA, double mB)
{
    if (a1 <= a2 && b1 <= b2)
    {
        return 0;
    }

    if (a2 <= a1 && b2 <= b1)
    {
        return 0;
    }

    if (a1 < a2)
    {
        std::swap(a1, a2);
        std::swap(b1, b2);
    }

    double s = (mA * (b2 - b1) + mB * (a1 - a2)) / (a1 * b2 - a2 * b1);
    if (mA < a2 * s) return 0;
    if (mB < b1 * s) return 0;
    // if ((\1 * s - mA) / (a1 - a2) > s) return 0;
    return s;
}

double checkOne(double a, double b, double mA, double mB)
{
    return std::min(mA / a, mB / b);
}

void init(const std::vector <int> &A, const std::vector <int> &B)
{
    n = A.size();
    std::vector <std::pair <int,int>> v;
    for (int i = 0 ; i < n ; ++i) v.push_back({A[i], B[i]});

    std::sort(v.begin(), v.end());
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] = v[i - 1].first;
        b[i] = v[i - 1].second;
    }
}

struct Point
{
    double x, y;
};

double size(Point a, Point b, Point c)
{
    return a.x * b.y + a.y * c.x + b.x * c.y - b.y * c.x - a.x * c.y - a.y * b.x;
}

double friendDrink(int mA, int mB, int lA, int rA)
{
    std::vector <Point> hull;
    for (int i = 1 ; i <= n ; ++i)
    {
        if (lA <= a[i] && a[i] <= rA)
        {
            if (hull.empty() || b[i] < hull.back().y) 
            {
                Point curr = {a[i], b[i]};
                while (hull.size() >= 2 && size(hull[hull.size() - 2], hull[hull.size() - 1], curr) <= 0)
                {
                    hull.pop_back();
                }

                hull.push_back(curr);
            }
        }
    }

    double ans = 0.0;
    int ptr = 0;
    int lastIdx = 0;
    for (int i = 0 ; i < hull.size() ; ++i)
    {
        ans = std::max(ans, checkOne(hull[i].x, hull[i].y, mA, mB));
        double opt = -1;
        int idx = hull.size();
        for (int j = i + 1 ; j < hull.size() && j <= i + 1 ; ++j) // lower convex hull
        {
            double curr = checkTwo(hull[i].x, hull[i].y, hull[j].x, hull[j].y, mA, mB);
            ans = std::max(ans, curr);

            if (opt < curr)
            {
                opt = curr;
                idx = j;
            }
        }

        // std::cout << "idx: " << idx << ' ' << lastIdx << '\n';
        assert(lastIdx <= idx);
        lastIdx = idx;
    }

    return ans;
}