/*
    Zarad tebe vdigam vurtoleta
*/

#include "cycles.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <random>
#include <chrono>
#include <vector>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

template <typename T>
using OSet = __gnu_pbds::tree <T, __gnu_pbds::null_type, std::less <T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

typedef long long llong;
const llong TIME = std::chrono::steady_clock::now().time_since_epoch().count();
const int MAXN = 1e6 + 10;
const int MAXLOG = 20;

int n;
std::mt19937 rng(69420);
std::vector <std::pair <int,int>> v;

void fix(std::vector <int> cycle)
{
    if (cycle.size() == 1)
    {
        return;
    }

    int idxOne = rng() % cycle.size();
    int idxTwo = rng() % (cycle.size() - 1);
    if (idxTwo >= idxOne) idxTwo++;

    int cnt = performSwap(cycle[idxOne], cycle[idxTwo]);
    std::vector <int> cycleOne, cycleTwo;
    cycleOne.push_back(cycle[idxOne]);
    cycleTwo.push_back(cycle[idxTwo]);

    for (int i = 0 ; i < cycle.size() ; ++i)
    {
        if (i == idxOne || i == idxTwo)
        {
            continue;
        }

        int curr = performSwap(cycle[idxOne], cycle[i]);
        if (curr > cnt)
        {
            cycleOne.push_back(cycle[i]);
        } else
        {
            cycleTwo.push_back(cycle[i]);
        }

        performSwap(cycle[idxOne], cycle[i]);
    }

    fix(cycleOne);
    fix(cycleTwo);
}

void sortPermutation(int N)
{
    n = N;
    int cnt = performSwap(0, 1); 
    for (int i = 1 ; i < n ; ++i)
    {
        int curr = performSwap(0, i);
        if (curr > cnt)
        {
            performSwap(0, i);
        } else
        {
            cnt = curr;
        }
    }

    std::vector <int> perm(n);
    std::iota(perm.begin(), perm.end(), 0);
    fix(perm);
}