/*
    Zarad tebe vdigam vurtoleta
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <random>
#include <chrono>
#include <vector>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

template <typename T>
using OSet = __gnu_pbds::tree <T, __gnu_pbds::null_type, std::less <T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

typedef long long llong;
// const llong TIME = std::chrono::steady_clock::now().time_since_epoch().count();
const int MAXN = 1e6 + 10;
const int MAXLOG = 20;
const int INF  = 2e9;

int n, k;
std::vector <std::pair <int,int>> g[MAXN];
llong cost;
llong t;

llong dfs(int node, int par)
{
    std::vector <llong> d;
    for (const auto &[u, ed] : g[node])
    {
        if (u == par)
        {
            continue;
        }

        d.push_back(dfs(u, node) + ed);
    }

    if (d.empty())
    {
        return 0;
    }

    if (d.size() == 1)
    {
        cost += std::max(0LL, d[0] - t);
        return std::min(t, d[0]);
    }

    
    std::sort(d.begin(), d.end(), std::greater <llong> ());
    llong atLeast = t / 2 + (t % 2);
    if (d[1] < atLeast)
    {
        cost += std::max(0LL, d[0] + d[1] - t);
        return std::min(d[0], d[0] - (d[0] + d[1] - t));
    }

    for (int i = 0 ; i < d.size() ; ++i)
    {
        cost += std::max(0LL, d[i] - atLeast);
        d[i] = atLeast;
    }

    if (d[0] + (d.size() == 1 ? 0 : d[1]) > t)
    {
        int cntEqual = 0;
        for (int i = 0 ; i < d.size() ; ++i)
        {
            cntEqual += (d[i] == atLeast);
        }

        cost += cntEqual - 1;
        return atLeast;
    }

    return std::min(d[0], atLeast);
}

bool check(llong val)
{
    cost = 0;
    t = val;
    dfs(1, 0);
    return cost <= k;
}

void solve()
{
    llong l = -1, r = INF, mid;
    while (l < r - 1)
    {
        mid = (l + r) / 2;
        if (!check(mid)) l = mid;
        else r = mid;
    }    

    std::cout << r << '\n';
}

void input()
{
    std::cin >> n >> k;
    for (int i = 1 ; i < n ; ++i)
    {
        int u, v, c;
        std::cin >> u >> v >> c;
        g[u].push_back({v, c});
        g[v].push_back({u, c});
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}