#include <bits/stdc++.h>
using namespace std;

const int maxn = 2e5+2;
int n, k;
bool used[maxn];
unsigned long long d[maxn];
struct edge
{
    int ver;
    long long p;
    bool operator<(const edge&e)const
    {
        return (e.p < p);
    }
};
vector <edge> v[maxn];

void dijkstra(int start)
{
    memset(d, -1, sizeof(d));
    memset(used, 0, sizeof(used));
    used[start] = true;
    d[start] = 0;
    priority_queue<edge> q;
    q.push({start, (long long)(0)});
    //cout << "***" << '\n' << start << '\n' ;
    edge e, nb;
    int i, len;

    while (!q.empty())
    {
        e = q.top(); q.pop();
        if (d[e.ver] >= 0)
        {
            used[e.ver] = true;
            len = (int)(v[e.ver].size());
            for (i=0; i<len; ++i)
            {
                nb.ver = v[e.ver][i].ver;
                nb.p = v[e.ver][i].p;
                if (e.p + nb.p <= d[nb.ver])
                {
                    nb.p += e.p;
                    d[nb.ver] = nb.p;
                    q.push(nb);
                    //cout << nb.ver << '\n' ;
                }
            }
        }
    }
}

void solve()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> k ;
    int i, x, y;
    long long dist;
    for (i=1; i<n; ++i)
    {
        cin >> x >> y >> dist ;
        v[x].push_back({y, dist});
        v[y].push_back({x, dist});
    }

    dijkstra(1);
    long long maxd = 0;
    for (i=1; i<=n; ++i)
    {
        if (d[i] > maxd)
        {
            maxd = d[i];
            x = i;
        }
    }

    dijkstra(x);
    maxd = 0;
    for (i=1; i<=n; ++i)
    {
        if (d[i] > maxd)
            maxd = d[i];
    }
    cout << maxd << '\n' ;
}

int main()
{
    solve();
    return 0;
}