#include <bits/stdc++.h>
using namespace std;

const int maxn = 2e5+2;
const unsigned int inf = -1;
int n, k, pr[maxn];
bool used[maxn];
unsigned int d[maxn];
struct edge
{
    int ver, p;
    bool operator<(const edge&e)const
    {
        return (e.p < p);
    }
};
vector <edge> v[maxn];
unordered_map <long long, bool> used_edge;

void dijkstra(int start)
{
    memset(d, -1, sizeof(d));
    memset(used, 0, sizeof(used));
    //used[start] = true;
    pr[start] = start;
    d[start] = 0;
    priority_queue<edge> q;
    q.push({start, (long long)(0)});
    //cout << "***" << '\n' << start << '\n' ;
    edge e, nb;
    int i, len;

    while (!q.empty())
    {
        e = q.top(); q.pop();
        if (!used[e.ver])
        {
            used[e.ver] = true;
            len = (int)(v[e.ver].size());
            for (i=0; i<len; ++i)
            {
                nb.ver = v[e.ver][i].ver;
                nb.p = v[e.ver][i].p;
                //if (used_edge[{(long long)(e.ver)*(long long)(maxn)+(long long)(nb.ver)}]) nb.p = 0;
                if (e.p + nb.p <= d[nb.ver])
                {
                    nb.p += e.p;
                    d[nb.ver] = (unsigned int)(nb.p);
                    pr[nb.ver] = e.ver;
                    q.push(nb);
                    //cout << nb.ver << '\n' ;
                }
            }
        }
    }
}

void solve()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> k ;
    int i, x, y;
    long long dist;
    for (i=1; i<n; ++i)
    {
        cin >> x >> y >> dist ;
        v[x].push_back({y, dist});
        v[y].push_back({x, dist});
    }

    dijkstra(1);
    unsigned int maxd = 0;
    for (i=1; i<=n; ++i)
    {
        if (d[i] > maxd)
        {
            maxd = d[i];
            x = i;
        }
    }

    dijkstra(x);
    maxd = 0;
    for (i=1; i<=n; ++i)
    {
        if (d[i] > maxd)
        {
            maxd = d[i];
            y = i;
        }
    }

    /*
    if (k == 1)
    {
        cout << maxd << '\n' ;
        //exit(0);
    }
    */
    unsigned int diameter = maxd;

    //cout << "&&&" << endl;

    while (y != x)
    {
        used_edge[(long long)(y)*(long long)(maxn)+(long long)(pr[y])] = true;
        used_edge[(long long)(pr[y])*(long long)(maxn)+(long long)(y)] = true;
        //cout << "edge: " << y << "->" << pr[y] << endl;
        y = pr[y];
    }

    int j, len;
    for (i=1; i<=n; ++i)
    {
        len = (v[i].size());
        for (j=0; j<len; ++j)
        {
            if (used_edge[(long long)(i)*(long long)(maxn)+(long long)(v[i][j].ver)])
            {
                v[i][j].p = (int)(0);
            }
        }
    }

    dijkstra(1);
    maxd = 0;
    for (i=1; i<=n; ++i)
    {
        if (d[i] >= maxd && d[i] != inf)
        {
            maxd = d[i];
            x = i;
        }
    }

    dijkstra(x);
    maxd = 0;
    for (i=1; i<=n; ++i)
    {
        if (d[i] >= maxd && d[i] != inf)
        {
            maxd = d[i];
            y = i;
        }
    }
    //cout << maxd << '\n' ;

    if (diameter > maxd) cout << ((0 > diameter-1) ? 0 : diameter-1) << '\n' ;
    else cout << diameter << '\n' ;
}

int main()
{
    solve();
    return 0;
}