#include <bits/stdc++.h>
using namespace std;

struct point
{
    long long x, y;
    point() {}
    point(long long _x, long long _y)
    {
        x=_x;
        y=_y;
    }
};

bool cmp_x(point p, point q)
{
    return (p.x<q.x || (p.x==q.x && p.y<q.y));
}

long long det_val(point a, point b, point c)
{
    return a.x*b.y+b.x*c.y+c.x*a.y-b.y*c.x-a.y*b.x-c.y*a.x;
}

const int MAXN=100005;

int n, id_min_y;
point P[MAXN];
vector<point> cvhull;

bool cmp_nakl(point p, point q)
{
    if(det_val(P[0], p, q)!=0) return det_val(P[0], p, q)>0;
    return p.x+p.y<q.x+q.y;
}

long double minb=1e18;

void init(const std::vector<int>& A, const std::vector<int>& B)
{
    n=A.size();
    for(int i=0; i<n; i++)
    {
        P[i]=point(A[i], B[i]);
        if(B[i]<minb) minb=B[i];
    }
    sort(P, P+n, cmp_x);
    sort(P+1, P+n, cmp_nakl);
    cvhull.push_back(P[0]);
    cvhull.push_back(P[1]);
    for(int i=2; i<n; i++)
    {
        while(cvhull.size()>=2 && det_val(cvhull[cvhull.size()-2], cvhull[cvhull.size()-1], P[i])<=0) cvhull.resize(cvhull.size()-1);
        cvhull.push_back(P[i]);
    }
    id_min_y=0;
}

long double getminimal_int(long long x, long double Ma, long double Mb)
{
    if(x>P[n-1].x) return 0;
    if(x<P[0].x) return 0;
    int le=0, ri=n-1;
    while(ri-le>1)
    {
        int mid=(le+ri)/2;
        if(x>=P[mid].x) le=mid;
        else ri=mid;
    }
    long double x1=P[le].x, y1=P[le].y;
    long double x2=P[ri].x, y2=P[ri].y;

    long double n1=(y1-y2)/(x1-x2);
    long double xk=x;
    long double yk=((long double)x-x1)*n1+y1;
    if(yk<(1e-12)) return Ma/xk;
    if(xk<(1e-12)) return Mb/yk;
    return min(Ma/xk, Mb/yk);
}

int brt;
point Q[MAXN];

void solve_int(int La, int Ra)
{
    brt=0;
    for(int i=0; i<n; i++)
    {
        if(P[i].x<La || P[i].x>Ra) continue;
        Q[brt]=P[i];
        brt++;
    }
    sort(Q, Q+n, cmp_x);
    sort(Q+1, Q+n, cmp_nakl);
    cvhull.push_back(Q[0]);
    cvhull.push_back(Q[1]);
    for(int i=2; i<n; i++)
    {
        while(cvhull.size()>=2 && det_val(cvhull[cvhull.size()-2], cvhull[cvhull.size()-1], Q[i])<=0) cvhull.resize(cvhull.size()-1);
        cvhull.push_back(Q[i]);
    }
    id_min_y=0;
}

double friendDrink(int Ma, int Mb, int La, int Ra)
{
    solve_int(La, Ra);
    int n=brt;
    long double ans=0;
    for(int i=0; i<n; i++)
    {
        if(Q[i].x<La || Q[i].x>Ra) continue;
        ans=max(ans, min((long double)Ma/P[i].x, (long double)Mb/Q[i].y));
    }
    ///cout<<ans<<endl;
    for(int i=0; i<n; i++)
    {
        for(int j=i+1; j<n; j++)
        {
            if(Q[i].x<La || Q[i].x>Ra) continue;
            if(Q[j].x<La || Q[j].x>Ra || Q[i].x==Q[j].x) continue;
            if(j-i>2 && i!=0) break;

            long double x1=Q[i].x, y1=Q[i].y;
            long double x2=Q[j].x, y2=Q[j].y;
            if(x1>x2)
            {
                swap(x1, x2);
                swap(y1, y2);
            }
            long double x3=0, y3=0;
            long double x4=Ma, y4=Mb;
            long double n1=(y1-y2)/(x1-x2);
            if(Ma!=0 && Mb*(Q[j].x-Q[i].x)!=(Q[j].y-Q[i].y)*Ma)
            {
                long double n3=(y3-y4)/(x3-x4);
                long double x=(x1*n1-y1-x3*n3+y3)/(n1-n3), y=(x-x1)*n1+y1;
                ///cout<<i<<" "<<j<<" "<<x<<" "<<y<<endl;
                if(x-(1e-12)>=x1 && x+(1e-12)<=x2) ans=max(ans, (long double)Ma/x);
            }
        }
    }
    return ans;
}

