#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 2e5 + 5;
vector <pair<int,int>> G[MAXN];
int n;
int k;

int d[MAXN];
int par[MAXN];
int cnt[MAXN];
bool used[MAXN];

bool operator < (pair<int, int> a, pair<int, int> b)
{
    return a.second > b.second;
}

void dijkstra(int v)
{
    priority_queue <pair <int, int>> pq;

    for (int i = 0; i <= n; i++)
    {
        used[i] = 0;
        par[i] = -1;
        cnt[i] = 0;
        d[i] = 2e9+1;
    }

    pq.push({v, 0});
    d[v] = 0;
    par[v] = -1;

    while (!pq.empty())
    {
        auto [v, w] = pq.top();
        pq.pop();
        if (used[v]) continue;

        for (auto x: G[v])
        {
            if (d[v] + x.second < d[x.first])
            {
                d[x.first] = d[v] + x.second;
                par[x.first] = v;
                pq.push({x.first, d[x.first]});
            }
        }
    }
}

void updatePath(int v)
{
    while (v != -1)
    {
        cnt[v]++;
        v = par[v];
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> k;

    for (int i = 1; i < n; i++)
    {
        int a, b, w;
        cin >> a >> b >> w;
        G[a].push_back({b, w});
        G[b].push_back({a, w});
    }

    dijkstra(1);

    int vertex = 1;
    for (int i = 1; i <= n; i++)
    {
        if (d[i] > d[vertex]) vertex = i;
    }

    dijkstra(vertex);
    for (int i = 1; i <= n; i++)
    {
        if (d[i] > d[vertex]) vertex = i;
    }

    int ans = d[vertex];
    int cntSame = 0;

    for (int i = 1; i <= n; i++)
    {
        cntSame++;
        updatePath(i);
    }

    int t = 0;
    for (int i = 1; i <= n; i++)
    {
        if (cnt[i] == cntSame) t++;
    }
    if ((cntSame == 1 || t >= 2) && ans > 0) ans--;

    cout << ans << endl;

    return 0;
}

/**
5 0
1 2 5
2 3 4
2 4 3
4 5 2

*/
