#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 2e5 + 5;
vector <pair<int,int>> G[MAXN];
int n;
int k;

int d[MAXN];
int par[MAXN];
int cnt[MAXN];
bool used[MAXN];

bool operator < (pair<int, int> a, pair<int, int> b)
{
    return a.second > b.second;
}

bool removedVertex[MAXN];

void dijkstra(int v)
{
    priority_queue <pair <int, int>> pq;

    for (int i = 0; i <= n; i++)
    {
        used[i] = 0;
        par[i] = -1;
        cnt[i] = 0;
        d[i] = 2e9+1;
    }

    pq.push({v, 0});
    d[v] = 0;
    par[v] = -1;

    while (!pq.empty())
    {
        auto [v, w] = pq.top();
        pq.pop();
        if (used[v]) continue;

        for (auto x: G[v])
        {
            if (removedVertex[x.first]) continue;

            if (d[v] + x.second < d[x.first])
            {
                d[x.first] = d[v] + x.second;
                par[x.first] = v;
                pq.push({x.first, d[x.first]});
            }
        }
    }
}

void updatePath(int v)
{
    while (v != -1)
    {
//        cerr << v << " ";
        cnt[v]++;
        v = par[v];
    }
//    cerr << endl;
}

int getDiam()
{
    for (int i = 1; i <= n; i++)
    {
        if (!removedVertex[i])
        {
            dijkstra(i);
            break;
        }
    }

    int vertex = 1;
    for (int i = 1; i <= n; i++)
    {
        if (d[i] > d[vertex] && d[i] != 2e9+1) vertex = i;
    }

    dijkstra(vertex);

    for (int i = 1; i <= n; i++)
    {
        if (d[i] > d[vertex] && d[i] != 2e9+1) vertex = i;
    }
    int ans = d[vertex];

    if (ans < 0) return 0;

    return ans;
}

vector<pair <int, int>> edges;

int usedEdge[MAXN];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> k;

    for (int i = 1; i < n; i++)
    {
        int a, b, w;
        cin >> a >> b >> w;
        G[a].push_back({b, w});
        G[b].push_back({a, w});
        edges.push_back({a, b});
    }


    int ans = getDiam();

//    if (k >= n)
//    {
//        cout << 0 << endl;
//        return 0;
//    }
//
//    if (k == n-1)
//    {
//        cout << 1 << endl;
//        return 0;
//    }

//    k = min(k, n);

    while(k > 0 && ans > 0)
    {
        ans = getDiam();
        int cntSame = 0;
        bool flag = 0;

        for (int i = 0; i < edges.size(); i++)
        {
            if (usedEdge[i]) continue;
            auto &y = edges[i];

            if (removedVertex[y.first] || removedVertex[y.second]) continue;

            for (auto &x: G[y.first])
                if (x.first == y.second)
                    x.second--;

            for (auto &x: G[y.second])
                if (x.first == y.first)
                    x.second--;

            int old_ans = ans;
            ans = min(ans, getDiam());
            if (ans < old_ans)
            {
                usedEdge[i] = 1;
                flag = 1;
                k--;
                break;
            }

            for (auto &x: G[y.first])
                if (x.first == y.second)
                    x.second++;
            for (auto &x: G[y.second])
                if (x.first == y.first)
                    x.second++;
        }

        if (!flag)
        {
            int diam = getDiam();
            for (int i = 1; i <= n; i++)
            {
                if (d[i] == diam && k > 0)
                {
                    removedVertex[i] = 1;
                    k--;
                    break;
                }
            }
        }
    }

    cout << getDiam() << endl;

    return 0;
}

/**
5 1
1 2 5
2 3 4
2 4 3
4 5 2


5 1
1 2 3
2 3 3
2 4 1
4 5 3

*/
