#include<iostream>
#include<algorithm>
#define MAXI 1000000005
#include<map>
#include<set>
#include "soft_drinks.h"
using namespace std;
int tree[600005];
map<int,int> to;
set<int> st;
vector<pair<int,int> > v;
int num;
void build(int node,int l,int r)
{
    if(l==r)
    {
        tree[node]=MAXI;
        return;
    }
    int mid=(l+r)/2;

    build(2*node,l,mid);
    build(2*node+1,mid+1,r);

    tree[node]=MAXI;
}
void update(int node,int l,int r,int val)
{
    if(l==r)
    {
        tree[node]=val;
        return;
    }
    int mid=(l+r)/2;

    update(2*node,l,mid,val);
    update(2*node+1,mid+1,r,val);

    tree[node]=min(tree[2*node],tree[2*node+1]);
}
int query(int node,int l,int r,int le,int ri)
{
    if(l>=le && r<=ri)
    {
        return tree[node];
    }
    if(l>ri || r<le) return MAXI;

    int mid=(l+r)/2;
    int a,b;
    a= query(2*node,l,mid,le,ri);b=query(2*node+1,mid+1,r,le,ri);

    if(a==b)
        return a;
    if(a<b)
        return a;
    return b;
}
void init(const std::vector<int>& A, const std::vector<int>& B)
{
    num=0;
    for(int i=0;i<A.size();i++)
    {
        v.push_back({A[i],B[i]});
    }
    sort(v.begin(),v.end());

    for(int i=0;i<v.size();i++)
    {
        if(!to.count(v[i].first))
        {
            num++;
            to[v[i].first]=num;
        }
    }

    build(1,1,num);

    for(int i=0;i<v.size();i++)
    {
        if(i>0 && v[i].first==v[i-1].first) continue;

        update(to[v[i].first],1,num,max(v[i].first,v[i].second));
        st.insert(v[i].first);
    }
}
double friendDrink(int Ma, int Mb, int La, int Ra)
{
   if(La<=v[0].first)
      La=v[0].first;
   else if(La>=v[v.size()-1].first)
      La=v[v.size()-1].first;
    else La=*(st.lower_bound(La));

    if(Ra<=v[0].first)
      Ra=v[0].first;
   else if(Ra>=v[v.size()-1].first)
      Ra=v[v.size()-1].first;
    else Ra=*(st.lower_bound(Ra));

   //cout<<"* "<<La<<" "<<Ra<<" "<<to[La]<<" "<<to[Ra]<<endl;

    return Ma/double(query(1,1,num,to[La],to[Ra]));
}
